GNU bug report logs - #50666
28.0.50; Fix native compilation on Cygwin

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Ken Brown <kbrown@HIDDEN>; Keywords: patch; dated Sat, 18 Sep 2021 20:52:02 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 50666 <at> debbugs.gnu.org:


Received: (at 50666) by debbugs.gnu.org; 25 Sep 2021 15:10:41 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Sep 25 11:10:41 2021
Received: from localhost ([127.0.0.1]:34317 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mU9K5-00016G-7y
	for submit <at> debbugs.gnu.org; Sat, 25 Sep 2021 11:10:41 -0400
Received: from eggs.gnu.org ([209.51.188.92]:39694)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1mU9K3-000164-G3
 for 50666 <at> debbugs.gnu.org; Sat, 25 Sep 2021 11:10:39 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:45250)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1mU9Jv-00034f-3z; Sat, 25 Sep 2021 11:10:31 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:4412
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1mU9Jt-0000le-3G; Sat, 25 Sep 2021 11:10:30 -0400
Date: Sat, 25 Sep 2021 18:10:23 +0300
Message-Id: <8335psr8rk.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: akrl@HIDDEN
In-Reply-To: <83a6k2tfkm.fsf@HIDDEN> (message from Eli Zaretskii on Fri, 24
 Sep 2021 13:48:09 +0300)
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <835yux5dn1.fsf@HIDDEN> <87bl4pf3s1.fsf@HIDDEN>
 <83tuih3uvr.fsf@HIDDEN> <877dfcg5tu.fsf@HIDDEN>
 <83pmt44vn1.fsf@HIDDEN>
 <eae87657-d5b5-2265-9b89-4626467a4ac5@HIDDEN>
 <83mto84r9l.fsf@HIDDEN>
 <fbe7b320-c720-50ad-aa18-a74443d2b070@HIDDEN>
 <83fsu04mai.fsf@HIDDEN>
 <1a5e01a2-2247-2f68-82f6-2075577e02b6@HIDDEN>
 <837dfc4hi1.fsf@HIDDEN>
 <4ae8067f-55b2-d243-66f3-f76493095a39@HIDDEN>
 <83o88jvity.fsf@HIDDEN>
 <8e8e74ce-0deb-bcdc-d298-be2e9d4636d7@HIDDEN>
 <83bl4juu2c.fsf@HIDDEN> <87h7ebrylf.fsf@HIDDEN>
 <834kabuqsf.fsf@HIDDEN> <87zgs3qh5y.fsf@HIDDEN>
 <xjfh7ebqe19.fsf@HIDDEN> <87pmsyo64j.fsf@HIDDEN>
 <xjf4kaaqvic.fsf@HIDDEN> <83a6k2tfkm.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 50666
Cc: Stromeko@HIDDEN, 50666 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Date: Fri, 24 Sep 2021 13:48:09 +0300
> From: Eli Zaretskii <eliz@HIDDEN>
> Cc: Stromeko@HIDDEN, 50666 <at> debbugs.gnu.org
> 
> > Cc: 50666 <at> debbugs.gnu.org
> > Date: Fri, 24 Sep 2021 07:32:11 +0000
> > From:  Andrea Corallo via "Bug reports for GNU Emacs,
> >  the Swiss army knife of text editors" <bug-gnu-emacs@HIDDEN>
> > 
> > > Can you point me to the part of the discussion where it was determined
> > > that the absolute location of the file was making a difference that was
> > > not covered with the hash of the content?
> > 
> > Not at the moment sorry, this was discussed more the once in different
> > threads in the last 1-2 years.
> 
> Right.
> 
> One situation that comes to mind is that a .el file could be
> native-compiled with different versions of macros in scope, although
> that is not necessarily evidenced by the file's absolute name.

I think I know what we were trying to solve by that, but the
explanation is a bit hairy.

It begins by noticing that what goes into the file-name part of the
hash is not the entire absolute file name.  We cannot use the entire
absolute file name, because then moving the .el files somewhere else
(e.g., to relocate the entire tree, or maybe access it from a
different machine) would break loading the *.eln files.  So we
actually disregard the leading directories, leaving just what's below
the 'lisp/' part.  For example, for a file "/foo/bar/baz/lisp/FOO.el"
we use just "//FOO.el".  And that could cause problems if we also have
"/foo/bar/baz/lisp/subdir/FOO.el".  So for the latter we use
"//subdir/FOO.el", which gives a different hash.

IOW, this is to be able to distinguish files with the same base name
that reside in different sub-directories of the same tree.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at 50666 <at> debbugs.gnu.org:


Received: (at 50666) by debbugs.gnu.org; 24 Sep 2021 12:49:25 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Sep 24 08:49:25 2021
Received: from localhost ([127.0.0.1]:56914 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mTkdp-0003UN-CC
	for submit <at> debbugs.gnu.org; Fri, 24 Sep 2021 08:49:25 -0400
Received: from mx.sdf.org ([205.166.94.24]:60176)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1mTkdn-0003UD-7o
 for 50666 <at> debbugs.gnu.org; Fri, 24 Sep 2021 08:49:24 -0400
Received: from ma.sdf.org (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 18OCnJ8D019438
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Fri, 24 Sep 2021 12:49:19 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN>
 <835yux5dn1.fsf@HIDDEN> <87bl4pf3s1.fsf@HIDDEN>
 <83tuih3uvr.fsf@HIDDEN> <877dfcg5tu.fsf@HIDDEN>
 <83pmt44vn1.fsf@HIDDEN>
 <eae87657-d5b5-2265-9b89-4626467a4ac5@HIDDEN>
 <83mto84r9l.fsf@HIDDEN>
 <fbe7b320-c720-50ad-aa18-a74443d2b070@HIDDEN>
 <83fsu04mai.fsf@HIDDEN>
 <1a5e01a2-2247-2f68-82f6-2075577e02b6@HIDDEN>
 <837dfc4hi1.fsf@HIDDEN>
 <4ae8067f-55b2-d243-66f3-f76493095a39@HIDDEN>
 <83o88jvity.fsf@HIDDEN> <xjflf3nqf92.fsf@HIDDEN>
 <87tuiao6g6.fsf@HIDDEN> <83fstutpnt.fsf@HIDDEN>
 <xjf8rzmqvsc.fsf@HIDDEN> <835yuqtejl.fsf@HIDDEN>
Date: Fri, 24 Sep 2021 12:49:19 +0000
In-Reply-To: <835yuqtejl.fsf@HIDDEN> (Eli Zaretskii's message of "Fri, 24 Sep
 2021 14:10:22 +0300")
Message-ID: <xjfzgs2p29c.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 50666
Cc: Stromeko@HIDDEN, 50666 <at> debbugs.gnu.org, kbrown@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> From: Andrea Corallo <akrl@HIDDEN>
>> Cc: ASSI <Stromeko@HIDDEN>, 50666 <at> debbugs.gnu.org, kbrown@HIDDEN
>> Date: Fri, 24 Sep 2021 07:26:11 +0000
>> 
>> > Or maybe we should add an automatic fallback on .elc/.el in case
>> > loading a .eln fails?  Andrea, WDYT? will that work?
>> 
>> Yes I think we could have an automatic fallback, we might have
>> 'native-elisp-load' (invoked by 'load') re invoke load itself in case of
>> failure, not very clean tho.
>
> Is 'native-elisp-load' always called from 'load'?

No but we could have it just return nil in case of fail with no
breakage.

> If so, we could
> make it return some special value to signal that fallback is in order,
> and then modify 'load' to proceed with loading *.el/*.elc file in that
> case.

Not sure how complex would be to integrate that with the controlo flow
in 'load' but yes that's a good idea if we wanna pursue this way.

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at 50666 <at> debbugs.gnu.org:


Received: (at 50666) by debbugs.gnu.org; 24 Sep 2021 11:10:43 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Sep 24 07:10:43 2021
Received: from localhost ([127.0.0.1]:56780 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mTj6J-0002XB-8L
	for submit <at> debbugs.gnu.org; Fri, 24 Sep 2021 07:10:43 -0400
Received: from eggs.gnu.org ([209.51.188.92]:42660)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1mTj6G-0002Ww-Pv
 for 50666 <at> debbugs.gnu.org; Fri, 24 Sep 2021 07:10:41 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:38504)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1mTj69-0008KN-A2; Fri, 24 Sep 2021 07:10:33 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:3799
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1mTj64-0007FL-Gw; Fri, 24 Sep 2021 07:10:32 -0400
Date: Fri, 24 Sep 2021 14:10:22 +0300
Message-Id: <835yuqtejl.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjf8rzmqvsc.fsf@HIDDEN> (message from Andrea Corallo on Fri, 
 24 Sep 2021 07:26:11 +0000)
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN>
 <835yux5dn1.fsf@HIDDEN> <87bl4pf3s1.fsf@HIDDEN>
 <83tuih3uvr.fsf@HIDDEN> <877dfcg5tu.fsf@HIDDEN>
 <83pmt44vn1.fsf@HIDDEN>
 <eae87657-d5b5-2265-9b89-4626467a4ac5@HIDDEN>
 <83mto84r9l.fsf@HIDDEN>
 <fbe7b320-c720-50ad-aa18-a74443d2b070@HIDDEN>
 <83fsu04mai.fsf@HIDDEN>
 <1a5e01a2-2247-2f68-82f6-2075577e02b6@HIDDEN>
 <837dfc4hi1.fsf@HIDDEN>
 <4ae8067f-55b2-d243-66f3-f76493095a39@HIDDEN>
 <83o88jvity.fsf@HIDDEN> <xjflf3nqf92.fsf@HIDDEN>
 <87tuiao6g6.fsf@HIDDEN> <83fstutpnt.fsf@HIDDEN>
 <xjf8rzmqvsc.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 50666
Cc: Stromeko@HIDDEN, 50666 <at> debbugs.gnu.org, kbrown@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Andrea Corallo <akrl@HIDDEN>
> Cc: ASSI <Stromeko@HIDDEN>, 50666 <at> debbugs.gnu.org, kbrown@HIDDEN
> Date: Fri, 24 Sep 2021 07:26:11 +0000
> 
> > Or maybe we should add an automatic fallback on .elc/.el in case
> > loading a .eln fails?  Andrea, WDYT? will that work?
> 
> Yes I think we could have an automatic fallback, we might have
> 'native-elisp-load' (invoked by 'load') re invoke load itself in case of
> failure, not very clean tho.

Is 'native-elisp-load' always called from 'load'?  If so, we could
make it return some special value to signal that fallback is in order,
and then modify 'load' to proceed with loading *.el/*.elc file in that
case.

> But aside the fact that is implementable I think it should be limited to
> just this specific load failure, otherwise it could easily mask other
> issues.

We could log a message in *Messages* about this, so that the fallback
could be discovered.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at 50666 <at> debbugs.gnu.org:


Received: (at 50666) by debbugs.gnu.org; 24 Sep 2021 11:03:39 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Sep 24 07:03:39 2021
Received: from localhost ([127.0.0.1]:56763 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mTizT-0002KP-2j
	for submit <at> debbugs.gnu.org; Fri, 24 Sep 2021 07:03:39 -0400
Received: from eggs.gnu.org ([209.51.188.92]:41334)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1mTizN-0002K5-6m
 for 50666 <at> debbugs.gnu.org; Fri, 24 Sep 2021 07:03:37 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:37550)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1mTizG-0002po-Cj; Fri, 24 Sep 2021 07:03:26 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:3358
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1mTizA-0005ab-5h; Fri, 24 Sep 2021 07:03:24 -0400
Date: Fri, 24 Sep 2021 14:03:13 +0300
Message-Id: <837df6tevi.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: ASSI <Stromeko@HIDDEN>
In-Reply-To: <87ee9enxkp.fsf@HIDDEN> (message from ASSI on Fri, 24 Sep
 2021 11:15:50 +0200)
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN>
 <835yux5dn1.fsf@HIDDEN> <87bl4pf3s1.fsf@HIDDEN>
 <83tuih3uvr.fsf@HIDDEN> <877dfcg5tu.fsf@HIDDEN>
 <83pmt44vn1.fsf@HIDDEN>
 <eae87657-d5b5-2265-9b89-4626467a4ac5@HIDDEN>
 <83mto84r9l.fsf@HIDDEN>
 <fbe7b320-c720-50ad-aa18-a74443d2b070@HIDDEN>
 <83fsu04mai.fsf@HIDDEN>
 <1a5e01a2-2247-2f68-82f6-2075577e02b6@HIDDEN>
 <837dfc4hi1.fsf@HIDDEN>
 <4ae8067f-55b2-d243-66f3-f76493095a39@HIDDEN>
 <83o88jvity.fsf@HIDDEN> <xjflf3nqf92.fsf@HIDDEN>
 <87tuiao6g6.fsf@HIDDEN> <83fstutpnt.fsf@HIDDEN>
 <87ee9enxkp.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 50666
Cc: 50666 <at> debbugs.gnu.org, akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: ASSI <Stromeko@HIDDEN>
> Cc: ASSI <Stromeko@HIDDEN>,  50666 <at> debbugs.gnu.org,  akrl@HIDDEN
> Date: Fri, 24 Sep 2021 11:15:50 +0200
> 
> What do you do on Linux in the case that two processes try to generate
> the same .eln?

The OS takes care of that (it makes the first one invisible in the
filesystem when the second one is created, and will delete the first
one when the session using it exits).




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at 50666 <at> debbugs.gnu.org:


Received: (at 50666) by debbugs.gnu.org; 24 Sep 2021 10:48:22 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Sep 24 06:48:22 2021
Received: from localhost ([127.0.0.1]:56750 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mTikg-0001u1-2H
	for submit <at> debbugs.gnu.org; Fri, 24 Sep 2021 06:48:22 -0400
Received: from eggs.gnu.org ([209.51.188.92]:37660)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1mTikd-0001ti-Vs
 for 50666 <at> debbugs.gnu.org; Fri, 24 Sep 2021 06:48:20 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:35540)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1mTikX-0006ee-C0; Fri, 24 Sep 2021 06:48:14 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:2441
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1mTikW-0004V6-43; Fri, 24 Sep 2021 06:48:13 -0400
Date: Fri, 24 Sep 2021 13:48:09 +0300
Message-Id: <83a6k2tfkm.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjf4kaaqvic.fsf@HIDDEN> (bug-gnu-emacs@HIDDEN)
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <835yux5dn1.fsf@HIDDEN> <87bl4pf3s1.fsf@HIDDEN>
 <83tuih3uvr.fsf@HIDDEN> <877dfcg5tu.fsf@HIDDEN>
 <83pmt44vn1.fsf@HIDDEN>
 <eae87657-d5b5-2265-9b89-4626467a4ac5@HIDDEN>
 <83mto84r9l.fsf@HIDDEN>
 <fbe7b320-c720-50ad-aa18-a74443d2b070@HIDDEN>
 <83fsu04mai.fsf@HIDDEN>
 <1a5e01a2-2247-2f68-82f6-2075577e02b6@HIDDEN>
 <837dfc4hi1.fsf@HIDDEN>
 <4ae8067f-55b2-d243-66f3-f76493095a39@HIDDEN>
 <83o88jvity.fsf@HIDDEN>
 <8e8e74ce-0deb-bcdc-d298-be2e9d4636d7@HIDDEN>
 <83bl4juu2c.fsf@HIDDEN> <87h7ebrylf.fsf@HIDDEN>
 <834kabuqsf.fsf@HIDDEN> <87zgs3qh5y.fsf@HIDDEN>
 <xjfh7ebqe19.fsf@HIDDEN> <87pmsyo64j.fsf@HIDDEN>
 <xjf4kaaqvic.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 50666
Cc: Stromeko@HIDDEN, 50666 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Cc: 50666 <at> debbugs.gnu.org
> Date: Fri, 24 Sep 2021 07:32:11 +0000
> From:  Andrea Corallo via "Bug reports for GNU Emacs,
>  the Swiss army knife of text editors" <bug-gnu-emacs@HIDDEN>
> 
> > Can you point me to the part of the discussion where it was determined
> > that the absolute location of the file was making a difference that was
> > not covered with the hash of the content?
> 
> Not at the moment sorry, this was discussed more the once in different
> threads in the last 1-2 years.

Right.

One situation that comes to mind is that a .el file could be
native-compiled with different versions of macros in scope, although
that is not necessarily evidenced by the file's absolute name.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at 50666 <at> debbugs.gnu.org:


Received: (at 50666) by debbugs.gnu.org; 24 Sep 2021 09:16:00 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Sep 24 05:16:00 2021
Received: from localhost ([127.0.0.1]:56709 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mThJI-0007fu-Dn
	for submit <at> debbugs.gnu.org; Fri, 24 Sep 2021 05:16:00 -0400
Received: from smtpout2.vodafonemail.de ([145.253.239.133]:40526)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <Stromeko@HIDDEN>) id 1mThJG-0007fd-7E
 for 50666 <at> debbugs.gnu.org; Fri, 24 Sep 2021 05:15:58 -0400
Received: from smtp.vodafone.de (smtpa04.fra-mediabeam.com [10.2.0.35])
 by smtpout2.vodafonemail.de (Postfix) with ESMTP id DC1406096B;
 Fri, 24 Sep 2021 11:15:51 +0200 (CEST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=nexgo.de;
 s=vfde-smtpout-mb-15sep; t=1632474951;
 bh=y82qkkXXBUWjWIMbN3+qGvG5fZMSiaxGx4lY7+/2QoQ=;
 h=From:To:Cc:Subject:References:Date:In-Reply-To;
 b=mPRDA7EQGp3te4j4Ltu3iv5swv1YI8Q6sBfSP/axOYQntpe9d2ZsnbRoGoWEdSk4k
 3vlla0+oZju9AAmH7D35Ja9UPZ+DKrmGrTT6lXIeGncUMGsEc2gYghPZJ/Vyg2JHlu
 Whg5Z46BndOpr9kMRvDwgMSAl0cVWfOSMVMwSq6s=
Received: from Otto (p54a0cb96.dip0.t-ipconnect.de [84.160.203.150])
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256/256 bits)
 key-exchange ECDHE (P-256) server-signature RSA-PSS (2048 bits) server-digest
 SHA256) (No client certificate requested)
 by smtp.vodafone.de (Postfix) with ESMTPSA id 12BDF1401A0;
 Fri, 24 Sep 2021 09:15:51 +0000 (UTC)
From: ASSI <Stromeko@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN>
 <835yux5dn1.fsf@HIDDEN> <87bl4pf3s1.fsf@HIDDEN>
 <83tuih3uvr.fsf@HIDDEN> <877dfcg5tu.fsf@HIDDEN>
 <83pmt44vn1.fsf@HIDDEN>
 <eae87657-d5b5-2265-9b89-4626467a4ac5@HIDDEN>
 <83mto84r9l.fsf@HIDDEN>
 <fbe7b320-c720-50ad-aa18-a74443d2b070@HIDDEN>
 <83fsu04mai.fsf@HIDDEN>
 <1a5e01a2-2247-2f68-82f6-2075577e02b6@HIDDEN>
 <837dfc4hi1.fsf@HIDDEN>
 <4ae8067f-55b2-d243-66f3-f76493095a39@HIDDEN>
 <83o88jvity.fsf@HIDDEN> <xjflf3nqf92.fsf@HIDDEN>
 <87tuiao6g6.fsf@HIDDEN> <83fstutpnt.fsf@HIDDEN>
Date: Fri, 24 Sep 2021 11:15:50 +0200
In-Reply-To: <83fstutpnt.fsf@HIDDEN> (Eli Zaretskii's message of "Fri, 24 Sep
 2021 10:10:14 +0300")
Message-ID: <87ee9enxkp.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-purgate-type: clean
X-purgate-Ad: Categorized by eleven eXpurgate (R) http://www.eleven.de
X-purgate: This mail is considered clean (visit http://www.eleven.de for
 further information)
X-purgate: clean
X-purgate-size: 980
X-purgate-ID: 155817::1632474951-00006056-6D7EBD93/0/0
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 50666
Cc: ASSI <Stromeko@HIDDEN>, 50666 <at> debbugs.gnu.org, akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Eli Zaretskii writes:
> This means that the following situation will predictably fail:
>
>   . Emacs session A (or just some shell command) rebases a .eln file
>   . Emacs session B decides it needs to load that .eln
>
> What kind of failure will session B see in this case?  Is it possible
> to figure out somehow that this is the reason, so that we could
> instead try loading the .elc or .el?

Something like EPERM I'd think, and only very briefly (i.e. if you tretry
the exact same call it will usually succeed).  We could rename the file
while operating on it, but that just moves the point of where the file
system race is happening and makes the window a tiny bit smaller.

What do you do on Linux in the case that two processes try to generate
the same .eln?


Regards,
Achim.
-- 
+<[Q+ Matrix-12 WAVE#46+305 Neuron microQkb Andromeda XTk Blofeld]>+

Wavetables for the Terratec KOMPLEXER:
http://Synth.Stromeko.net/Downloads.html#KomplexerWaves




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at 50666 <at> debbugs.gnu.org:


Received: (at 50666) by debbugs.gnu.org; 24 Sep 2021 09:06:18 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Sep 24 05:06:18 2021
Received: from localhost ([127.0.0.1]:56701 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mTh9t-0007QB-SJ
	for submit <at> debbugs.gnu.org; Fri, 24 Sep 2021 05:06:18 -0400
Received: from smtpout2.vodafonemail.de ([145.253.239.133]:32816)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <Stromeko@HIDDEN>) id 1mTh9s-0007Px-O3
 for 50666 <at> debbugs.gnu.org; Fri, 24 Sep 2021 05:06:17 -0400
Received: from smtp.vodafone.de (smtpa03.fra-mediabeam.com [10.2.0.34])
 by smtpout2.vodafonemail.de (Postfix) with ESMTP id E4D5E616EA;
 Fri, 24 Sep 2021 11:05:38 +0200 (CEST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=nexgo.de;
 s=vfde-smtpout-mb-15sep; t=1632474338;
 bh=6ZvBva42n7KsLl/cBtpbXa3BTEovjD6qTOjJ7AG3+28=;
 h=From:To:Cc:Subject:References:Date:In-Reply-To;
 b=H6UQPsqXuPDCKc7Rk5GbWkYE3DrxpTsqi4q2tzmNYEwHaZDo7SqHnjtvMqD55yRP4
 RaGvGVrss8M1hrt/OC8gqI+9KIIlmoYg9jfULIawYdDsrUsj9Bh6jRgm0QBCWGm2nm
 84zYpNQBg04UXfxXfcrd1iGRsITfFQu5NMAKLopc=
Received: from Otto (p54a0cb96.dip0.t-ipconnect.de [84.160.203.150])
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256/256 bits)
 key-exchange ECDHE (P-256) server-signature RSA-PSS (2048 bits) server-digest
 SHA256) (No client certificate requested)
 by smtp.vodafone.de (Postfix) with ESMTPSA id 4058B1401E3;
 Fri, 24 Sep 2021 09:05:38 +0000 (UTC)
From: ASSI <Stromeko@HIDDEN>
To: Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of
 text editors" <bug-gnu-emacs@HIDDEN>
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <87bl4pf3s1.fsf@HIDDEN> <83tuih3uvr.fsf@HIDDEN>
 <877dfcg5tu.fsf@HIDDEN> <83pmt44vn1.fsf@HIDDEN>
 <eae87657-d5b5-2265-9b89-4626467a4ac5@HIDDEN>
 <83mto84r9l.fsf@HIDDEN>
 <fbe7b320-c720-50ad-aa18-a74443d2b070@HIDDEN>
 <83fsu04mai.fsf@HIDDEN>
 <1a5e01a2-2247-2f68-82f6-2075577e02b6@HIDDEN>
 <837dfc4hi1.fsf@HIDDEN>
 <4ae8067f-55b2-d243-66f3-f76493095a39@HIDDEN>
 <83o88jvity.fsf@HIDDEN>
 <8e8e74ce-0deb-bcdc-d298-be2e9d4636d7@HIDDEN>
 <83bl4juu2c.fsf@HIDDEN> <87h7ebrylf.fsf@HIDDEN>
 <834kabuqsf.fsf@HIDDEN> <87zgs3qh5y.fsf@HIDDEN>
 <xjfh7ebqe19.fsf@HIDDEN> <87pmsyo64j.fsf@HIDDEN>
 <xjf4kaaqvic.fsf@HIDDEN>
Date: Fri, 24 Sep 2021 11:05:34 +0200
In-Reply-To: <xjf4kaaqvic.fsf@HIDDEN> (Andrea Corallo via's message of
 "Fri, 24 Sep 2021 07:32:11 +0000")
Message-ID: <87lf3mny1t.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-purgate-type: clean
X-purgate-Ad: Categorized by eleven eXpurgate (R) http://www.eleven.de
X-purgate: This mail is considered clean (visit http://www.eleven.de for
 further information)
X-purgate: clean
X-purgate-size: 802
X-purgate-ID: 155817::1632474338-00000B26-AE93B055/0/0
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 50666
Cc: ASSI <Stromeko@HIDDEN>, 50666 <at> debbugs.gnu.org,
 Andrea Corallo <akrl@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Andrea Corallo  writes:
>> In general, is this hardcoded or can we change the hashing strategy for
>> Cygwin via some configuration or hook?
>
> Hardcoded. Could you explain why this could be problematic for cygwin?

It's not preblematic per se, I am just trying to figure out what the
options are to deal with the fact that rebase is host specific while the
cache is not.

> Note we use the absolute location hash mainly to try to keep clean the
> cache folders (we can't have two eln with the same 'path_hash', one must
> be obsolete).

Understood.  I'll try to trawl the old threads some time and may come
back with more questions. :-)


Regards,
Achim.
-- 
+<[Q+ Matrix-12 WAVE#46+305 Neuron microQkb Andromeda XTk Blofeld]>+

DIY Stuff:
http://Synth.Stromeko.net/DIY.html




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 24 Sep 2021 09:06:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Sep 24 05:06:24 2021
Received: from localhost ([127.0.0.1]:56704 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mThA0-0007QW-4D
	for submit <at> debbugs.gnu.org; Fri, 24 Sep 2021 05:06:24 -0400
Received: from lists.gnu.org ([209.51.188.17]:35562)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <Stromeko@HIDDEN>) id 1mTh9y-0007QN-Ns
 for submit <at> debbugs.gnu.org; Fri, 24 Sep 2021 05:06:22 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:36292)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <Stromeko@HIDDEN>) id 1mTh9y-0004c1-HP
 for bug-gnu-emacs@HIDDEN; Fri, 24 Sep 2021 05:06:22 -0400
Received: from smtpout2.vodafonemail.de ([145.253.239.133]:49884)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <Stromeko@HIDDEN>) id 1mTh9w-0003Oq-7S
 for bug-gnu-emacs@HIDDEN; Fri, 24 Sep 2021 05:06:21 -0400
Received: from smtp.vodafone.de (smtpa03.fra-mediabeam.com [10.2.0.34])
 by smtpout2.vodafonemail.de (Postfix) with ESMTP id E4D5E616EA;
 Fri, 24 Sep 2021 11:05:38 +0200 (CEST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=nexgo.de;
 s=vfde-smtpout-mb-15sep; t=1632474338;
 bh=6ZvBva42n7KsLl/cBtpbXa3BTEovjD6qTOjJ7AG3+28=;
 h=From:To:Cc:Subject:References:Date:In-Reply-To;
 b=H6UQPsqXuPDCKc7Rk5GbWkYE3DrxpTsqi4q2tzmNYEwHaZDo7SqHnjtvMqD55yRP4
 RaGvGVrss8M1hrt/OC8gqI+9KIIlmoYg9jfULIawYdDsrUsj9Bh6jRgm0QBCWGm2nm
 84zYpNQBg04UXfxXfcrd1iGRsITfFQu5NMAKLopc=
Received: from Otto (p54a0cb96.dip0.t-ipconnect.de [84.160.203.150])
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256/256 bits)
 key-exchange ECDHE (P-256) server-signature RSA-PSS (2048 bits) server-digest
 SHA256) (No client certificate requested)
 by smtp.vodafone.de (Postfix) with ESMTPSA id 4058B1401E3;
 Fri, 24 Sep 2021 09:05:38 +0000 (UTC)
From: ASSI <Stromeko@HIDDEN>
To: Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of
 text editors" <bug-gnu-emacs@HIDDEN>
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <87bl4pf3s1.fsf@HIDDEN> <83tuih3uvr.fsf@HIDDEN>
 <877dfcg5tu.fsf@HIDDEN> <83pmt44vn1.fsf@HIDDEN>
 <eae87657-d5b5-2265-9b89-4626467a4ac5@HIDDEN>
 <83mto84r9l.fsf@HIDDEN>
 <fbe7b320-c720-50ad-aa18-a74443d2b070@HIDDEN>
 <83fsu04mai.fsf@HIDDEN>
 <1a5e01a2-2247-2f68-82f6-2075577e02b6@HIDDEN>
 <837dfc4hi1.fsf@HIDDEN>
 <4ae8067f-55b2-d243-66f3-f76493095a39@HIDDEN>
 <83o88jvity.fsf@HIDDEN>
 <8e8e74ce-0deb-bcdc-d298-be2e9d4636d7@HIDDEN>
 <83bl4juu2c.fsf@HIDDEN> <87h7ebrylf.fsf@HIDDEN>
 <834kabuqsf.fsf@HIDDEN> <87zgs3qh5y.fsf@HIDDEN>
 <xjfh7ebqe19.fsf@HIDDEN> <87pmsyo64j.fsf@HIDDEN>
 <xjf4kaaqvic.fsf@HIDDEN>
Date: Fri, 24 Sep 2021 11:05:34 +0200
In-Reply-To: <xjf4kaaqvic.fsf@HIDDEN> (Andrea Corallo via's message of
 "Fri, 24 Sep 2021 07:32:11 +0000")
Message-ID: <87lf3mny1t.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-purgate-type: clean
X-purgate-Ad: Categorized by eleven eXpurgate (R) http://www.eleven.de
X-purgate: This mail is considered clean (visit http://www.eleven.de for
 further information)
X-purgate: clean
X-purgate-size: 802
X-purgate-ID: 155817::1632474338-00000B26-AE93B055/0/0
Received-SPF: pass client-ip=145.253.239.133; envelope-from=Stromeko@HIDDEN;
 helo=smtpout2.vodafonemail.de
X-Spam_score_int: -27
X-Spam_score: -2.8
X-Spam_bar: --
X-Spam_report: (-2.8 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1,
 RCVD_IN_DNSWL_LOW=-0.7, RCVD_IN_MSPIKE_H2=-0.001, SPF_HELO_NONE=0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.4 (-)
X-Debbugs-Envelope-To: submit
Cc: ASSI <Stromeko@HIDDEN>, 50666 <at> debbugs.gnu.org,
 Andrea Corallo <akrl@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.4 (--)

Andrea Corallo  writes:
>> In general, is this hardcoded or can we change the hashing strategy for
>> Cygwin via some configuration or hook?
>
> Hardcoded. Could you explain why this could be problematic for cygwin?

It's not preblematic per se, I am just trying to figure out what the
options are to deal with the fact that rebase is host specific while the
cache is not.

> Note we use the absolute location hash mainly to try to keep clean the
> cache folders (we can't have two eln with the same 'path_hash', one must
> be obsolete).

Understood.  I'll try to trawl the old threads some time and may come
back with more questions. :-)


Regards,
Achim.
-- 
+<[Q+ Matrix-12 WAVE#46+305 Neuron microQkb Andromeda XTk Blofeld]>+

DIY Stuff:
http://Synth.Stromeko.net/DIY.html




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at 50666 <at> debbugs.gnu.org:


Received: (at 50666) by debbugs.gnu.org; 24 Sep 2021 07:32:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Sep 24 03:32:15 2021
Received: from localhost ([127.0.0.1]:56617 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mTfgt-0004os-0h
	for submit <at> debbugs.gnu.org; Fri, 24 Sep 2021 03:32:15 -0400
Received: from mx.sdf.org ([205.166.94.24]:53440)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1mTfgq-0004ok-VJ
 for 50666 <at> debbugs.gnu.org; Fri, 24 Sep 2021 03:32:13 -0400
Received: from ma.sdf.org (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 18O7WBIl007902
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Fri, 24 Sep 2021 07:32:12 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: ASSI <Stromeko@HIDDEN>
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <835yux5dn1.fsf@HIDDEN> <87bl4pf3s1.fsf@HIDDEN>
 <83tuih3uvr.fsf@HIDDEN> <877dfcg5tu.fsf@HIDDEN>
 <83pmt44vn1.fsf@HIDDEN>
 <eae87657-d5b5-2265-9b89-4626467a4ac5@HIDDEN>
 <83mto84r9l.fsf@HIDDEN>
 <fbe7b320-c720-50ad-aa18-a74443d2b070@HIDDEN>
 <83fsu04mai.fsf@HIDDEN>
 <1a5e01a2-2247-2f68-82f6-2075577e02b6@HIDDEN>
 <837dfc4hi1.fsf@HIDDEN>
 <4ae8067f-55b2-d243-66f3-f76493095a39@HIDDEN>
 <83o88jvity.fsf@HIDDEN>
 <8e8e74ce-0deb-bcdc-d298-be2e9d4636d7@HIDDEN>
 <83bl4juu2c.fsf@HIDDEN> <87h7ebrylf.fsf@HIDDEN>
 <834kabuqsf.fsf@HIDDEN> <87zgs3qh5y.fsf@HIDDEN>
 <xjfh7ebqe19.fsf@HIDDEN> <87pmsyo64j.fsf@HIDDEN>
Date: Fri, 24 Sep 2021 07:32:11 +0000
In-Reply-To: <87pmsyo64j.fsf@HIDDEN> (ASSI's message of "Fri, 24 Sep
 2021 08:11:08 +0200")
Message-ID: <xjf4kaaqvic.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 50666
Cc: 50666 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

ASSI <Stromeko@HIDDEN> writes:

> Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of
> text editors" writes:
>> To get practical I've:
>>
>> ~/.emacs.d/eln-cache/28.0.50-2045295c/apropos-7c1ecbdf-10e46ddb.eln
>>                               ^^^               ^^^       ^^^
>>                                A                 B         C
>>
>> A- accounts for emacs-verison, system-configuration,
>>    system-configuration-options and the signatures of all the subr
>>    present in the C code.
>
> OK, so this would be unique for one Cygwin Emacs release and architecture.
>
>> B- accounts for the absolute filename of
>>    the source file
>
> In general, is this hardcoded or can we change the hashing strategy for
> Cygwin via some configuration or hook?

Hardcoded. Could you explain why this could be problematic for cygwin?

>> C- accounts for the content for the source file
>
> Can you point me to the part of the discussion where it was determined
> that the absolute location of the file was making a difference that was
> not covered with the hash of the content?

Not at the moment sorry, this was discussed more the once in different
threads in the last 1-2 years.

Note we use the absolute location hash mainly to try to keep clean the
cache folders (we can't have two eln with the same 'path_hash', one must
be obsolete).

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at 50666 <at> debbugs.gnu.org:


Received: (at 50666) by debbugs.gnu.org; 24 Sep 2021 07:26:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Sep 24 03:26:29 2021
Received: from localhost ([127.0.0.1]:56602 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mTfb8-0004da-VA
	for submit <at> debbugs.gnu.org; Fri, 24 Sep 2021 03:26:29 -0400
Received: from mx.sdf.org ([205.166.94.24]:53750)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1mTfb5-0004dO-HW
 for 50666 <at> debbugs.gnu.org; Fri, 24 Sep 2021 03:26:17 -0400
Received: from ma.sdf.org (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 18O7QBDN014773
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Fri, 24 Sep 2021 07:26:11 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN>
 <835yux5dn1.fsf@HIDDEN> <87bl4pf3s1.fsf@HIDDEN>
 <83tuih3uvr.fsf@HIDDEN> <877dfcg5tu.fsf@HIDDEN>
 <83pmt44vn1.fsf@HIDDEN>
 <eae87657-d5b5-2265-9b89-4626467a4ac5@HIDDEN>
 <83mto84r9l.fsf@HIDDEN>
 <fbe7b320-c720-50ad-aa18-a74443d2b070@HIDDEN>
 <83fsu04mai.fsf@HIDDEN>
 <1a5e01a2-2247-2f68-82f6-2075577e02b6@HIDDEN>
 <837dfc4hi1.fsf@HIDDEN>
 <4ae8067f-55b2-d243-66f3-f76493095a39@HIDDEN>
 <83o88jvity.fsf@HIDDEN> <xjflf3nqf92.fsf@HIDDEN>
 <87tuiao6g6.fsf@HIDDEN> <83fstutpnt.fsf@HIDDEN>
Date: Fri, 24 Sep 2021 07:26:11 +0000
In-Reply-To: <83fstutpnt.fsf@HIDDEN> (Eli Zaretskii's message of "Fri, 24 Sep
 2021 10:10:14 +0300")
Message-ID: <xjf8rzmqvsc.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 50666
Cc: ASSI <Stromeko@HIDDEN>, 50666 <at> debbugs.gnu.org, kbrown@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> From: ASSI <Stromeko@HIDDEN>
>> Cc: Eli Zaretskii <eliz@HIDDEN>,  Andrea Corallo <akrl@HIDDEN>,
>>   Stromeko@HIDDEN,  50666 <at> debbugs.gnu.org,  Ken Brown
>>  <kbrown@HIDDEN>
>> Date: Fri, 24 Sep 2021 08:04:09 +0200
>> 
>> You can't rebase an object that is already loaded on Windows (or load an
>> object that is in the process of getting rebased), so I would not worry
>> about this situation too much at the moment.
>
> This means that the following situation will predictably fail:
>
>   . Emacs session A (or just some shell command) rebases a .eln file
>   . Emacs session B decides it needs to load that .eln
>
> What kind of failure will session B see in this case?  Is it possible
> to figure out somehow that this is the reason, so that we could
> instead try loading the .elc or .el?
>
> Or maybe we should add an automatic fallback on .elc/.el in case
> loading a .eln fails?  Andrea, WDYT? will that work?

Yes I think we could have an automatic fallback, we might have
'native-elisp-load' (invoked by 'load') re invoke load itself in case of
failure, not very clean tho.

But aside the fact that is implementable I think it should be limited to
just this specific load failure, otherwise it could easily mask other
issues.  And this raise another question: can we identify this specific
kind of load failure?

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at 50666 <at> debbugs.gnu.org:


Received: (at 50666) by debbugs.gnu.org; 24 Sep 2021 07:13:39 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Sep 24 03:13:39 2021
Received: from localhost ([127.0.0.1]:56589 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mTfOl-0004HA-Bw
	for submit <at> debbugs.gnu.org; Fri, 24 Sep 2021 03:13:39 -0400
Received: from eggs.gnu.org ([209.51.188.92]:49892)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1mTfOj-0004Gu-Ex
 for 50666 <at> debbugs.gnu.org; Fri, 24 Sep 2021 03:13:29 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:46446)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1mTfOd-0006Xv-BZ; Fri, 24 Sep 2021 03:13:23 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:1266
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1mTfOc-00072l-UE; Fri, 24 Sep 2021 03:13:23 -0400
Date: Fri, 24 Sep 2021 10:13:19 +0300
Message-Id: <83ee9etpio.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: ASSI <Stromeko@HIDDEN>
In-Reply-To: <87pmsyo64j.fsf@HIDDEN> (message from ASSI on Fri, 24 Sep
 2021 08:11:08 +0200)
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN>
 <835yux5dn1.fsf@HIDDEN> <87bl4pf3s1.fsf@HIDDEN>
 <83tuih3uvr.fsf@HIDDEN> <877dfcg5tu.fsf@HIDDEN>
 <83pmt44vn1.fsf@HIDDEN>
 <eae87657-d5b5-2265-9b89-4626467a4ac5@HIDDEN>
 <83mto84r9l.fsf@HIDDEN>
 <fbe7b320-c720-50ad-aa18-a74443d2b070@HIDDEN>
 <83fsu04mai.fsf@HIDDEN>
 <1a5e01a2-2247-2f68-82f6-2075577e02b6@HIDDEN>
 <837dfc4hi1.fsf@HIDDEN>
 <4ae8067f-55b2-d243-66f3-f76493095a39@HIDDEN>
 <83o88jvity.fsf@HIDDEN>
 <8e8e74ce-0deb-bcdc-d298-be2e9d4636d7@HIDDEN>
 <83bl4juu2c.fsf@HIDDEN> <87h7ebrylf.fsf@HIDDEN>
 <834kabuqsf.fsf@HIDDEN> <87zgs3qh5y.fsf@HIDDEN>
 <xjfh7ebqe19.fsf@HIDDEN> <87pmsyo64j.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 50666
Cc: 50666 <at> debbugs.gnu.org, kbrown@HIDDEN, akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

> From: ASSI <Stromeko@HIDDEN>
> Date: Fri, 24 Sep 2021 08:11:08 +0200
> Cc: Stromeko@HIDDEN, akrl@HIDDEN
> 
> > B- accounts for the absolute filename of
> >    the source file
> 
> In general, is this hardcoded or can we change the hashing strategy for
> Cygwin via some configuration or hook?

It's currently hardcoded.  Why do you need to change it?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at 50666 <at> debbugs.gnu.org:


Received: (at 50666) by debbugs.gnu.org; 24 Sep 2021 07:10:43 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Sep 24 03:10:43 2021
Received: from localhost ([127.0.0.1]:56576 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mTfM3-0004Be-H5
	for submit <at> debbugs.gnu.org; Fri, 24 Sep 2021 03:10:43 -0400
Received: from eggs.gnu.org ([209.51.188.92]:48118)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1mTfM1-0004BR-Fm
 for 50666 <at> debbugs.gnu.org; Fri, 24 Sep 2021 03:10:42 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:46252)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1mTfLr-0003mh-7j; Fri, 24 Sep 2021 03:10:33 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:1080
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1mTfLi-0006Pl-Ae; Fri, 24 Sep 2021 03:10:31 -0400
Date: Fri, 24 Sep 2021 10:10:14 +0300
Message-Id: <83fstutpnt.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: ASSI <Stromeko@HIDDEN>
In-Reply-To: <87tuiao6g6.fsf@HIDDEN> (message from ASSI on Fri, 24 Sep
 2021 08:04:09 +0200)
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN>
 <835yux5dn1.fsf@HIDDEN> <87bl4pf3s1.fsf@HIDDEN>
 <83tuih3uvr.fsf@HIDDEN> <877dfcg5tu.fsf@HIDDEN>
 <83pmt44vn1.fsf@HIDDEN>
 <eae87657-d5b5-2265-9b89-4626467a4ac5@HIDDEN>
 <83mto84r9l.fsf@HIDDEN>
 <fbe7b320-c720-50ad-aa18-a74443d2b070@HIDDEN>
 <83fsu04mai.fsf@HIDDEN>
 <1a5e01a2-2247-2f68-82f6-2075577e02b6@HIDDEN>
 <837dfc4hi1.fsf@HIDDEN>
 <4ae8067f-55b2-d243-66f3-f76493095a39@HIDDEN>
 <83o88jvity.fsf@HIDDEN> <xjflf3nqf92.fsf@HIDDEN>
 <87tuiao6g6.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 50666
Cc: 50666 <at> debbugs.gnu.org, kbrown@HIDDEN, akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: ASSI <Stromeko@HIDDEN>
> Cc: Eli Zaretskii <eliz@HIDDEN>,  Andrea Corallo <akrl@HIDDEN>,
>   Stromeko@HIDDEN,  50666 <at> debbugs.gnu.org,  Ken Brown
>  <kbrown@HIDDEN>
> Date: Fri, 24 Sep 2021 08:04:09 +0200
> 
> You can't rebase an object that is already loaded on Windows (or load an
> object that is in the process of getting rebased), so I would not worry
> about this situation too much at the moment.

This means that the following situation will predictably fail:

  . Emacs session A (or just some shell command) rebases a .eln file
  . Emacs session B decides it needs to load that .eln

What kind of failure will session B see in this case?  Is it possible
to figure out somehow that this is the reason, so that we could
instead try loading the .elc or .el?

Or maybe we should add an automatic fallback on .elc/.el in case
loading a .eln fails?  Andrea, WDYT? will that work?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at 50666 <at> debbugs.gnu.org:


Received: (at 50666) by debbugs.gnu.org; 24 Sep 2021 06:11:17 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Sep 24 02:11:17 2021
Received: from localhost ([127.0.0.1]:56496 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mTeQX-0000Hx-JZ
	for submit <at> debbugs.gnu.org; Fri, 24 Sep 2021 02:11:17 -0400
Received: from smtpout2.vodafonemail.de ([145.253.239.133]:51502)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <Stromeko@HIDDEN>) id 1mTeQW-0000Hj-Nr
 for 50666 <at> debbugs.gnu.org; Fri, 24 Sep 2021 02:11:17 -0400
Received: from smtp.vodafone.de (smtpa03.fra-mediabeam.com [10.2.0.34])
 by smtpout2.vodafonemail.de (Postfix) with ESMTP id 53AAA61287;
 Fri, 24 Sep 2021 08:11:11 +0200 (CEST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=nexgo.de;
 s=vfde-smtpout-mb-15sep; t=1632463871;
 bh=nQ+CjHv2oxkASoWH7VUgZJ61HpquVR4nnL16p6mScHA=;
 h=From:To:Cc:Subject:References:Date:In-Reply-To;
 b=ErvwsTuqdwEMTrJlMDbXIlstZBTq3/dgc8iZlq6Nn086gDyPuuzK3P9XQETpA4JRL
 ozzw/h9N+qgE6i8cHYZ7jl6zDCSaQwNf4vrV/vvHPF+pkkEQKIxtx5fspGkQnqiq5I
 2akXeryLkje4uTPBEqGUEHfGb6UiZv2hPfZ4lG6k=
Received: from Otto (p54a0cb96.dip0.t-ipconnect.de [84.160.203.150])
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256/256 bits)
 key-exchange ECDHE (P-256) server-signature RSA-PSS (2048 bits) server-digest
 SHA256) (No client certificate requested)
 by smtp.vodafone.de (Postfix) with ESMTPSA id E142C140278;
 Fri, 24 Sep 2021 06:11:09 +0000 (UTC)
From: ASSI <Stromeko@HIDDEN>
To: Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of
 text editors" <bug-gnu-emacs@HIDDEN>
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN>
 <835yux5dn1.fsf@HIDDEN> <87bl4pf3s1.fsf@HIDDEN>
 <83tuih3uvr.fsf@HIDDEN> <877dfcg5tu.fsf@HIDDEN>
 <83pmt44vn1.fsf@HIDDEN>
 <eae87657-d5b5-2265-9b89-4626467a4ac5@HIDDEN>
 <83mto84r9l.fsf@HIDDEN>
 <fbe7b320-c720-50ad-aa18-a74443d2b070@HIDDEN>
 <83fsu04mai.fsf@HIDDEN>
 <1a5e01a2-2247-2f68-82f6-2075577e02b6@HIDDEN>
 <837dfc4hi1.fsf@HIDDEN>
 <4ae8067f-55b2-d243-66f3-f76493095a39@HIDDEN>
 <83o88jvity.fsf@HIDDEN>
 <8e8e74ce-0deb-bcdc-d298-be2e9d4636d7@HIDDEN>
 <83bl4juu2c.fsf@HIDDEN> <87h7ebrylf.fsf@HIDDEN>
 <834kabuqsf.fsf@HIDDEN> <87zgs3qh5y.fsf@HIDDEN>
 <xjfh7ebqe19.fsf@HIDDEN>
Date: Fri, 24 Sep 2021 08:11:08 +0200
In-Reply-To: <xjfh7ebqe19.fsf@HIDDEN> (Andrea Corallo via's message of
 "Thu, 23 Sep 2021 19:37:22 +0000")
Message-ID: <87pmsyo64j.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-purgate-type: clean
X-purgate-Ad: Categorized by eleven eXpurgate (R) http://www.eleven.de
X-purgate: This mail is considered clean (visit http://www.eleven.de for
 further information)
X-purgate: clean
X-purgate-size: 1203
X-purgate-ID: 155817::1632463870-00000B26-B84EAB7D/0/0
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 50666
Cc: Achim Gratz <Stromeko@HIDDEN>, 50666 <at> debbugs.gnu.org,
 Andrea Corallo <akrl@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of
text editors" writes:
> To get practical I've:
>
> ~/.emacs.d/eln-cache/28.0.50-2045295c/apropos-7c1ecbdf-10e46ddb.eln
>                               ^^^               ^^^       ^^^
>                                A                 B         C
>
> A- accounts for emacs-verison, system-configuration,
>    system-configuration-options and the signatures of all the subr
>    present in the C code.

OK, so this would be unique for one Cygwin Emacs release and architecture.

> B- accounts for the absolute filename of
>    the source file

In general, is this hardcoded or can we change the hashing strategy for
Cygwin via some configuration or hook?

> C- accounts for the content for the source file

Can you point me to the part of the discussion where it was determined
that the absolute location of the file was making a difference that was
not covered with the hash of the content?


Regards,
Achim.
-- 
+<[Q+ Matrix-12 WAVE#46+305 Neuron microQkb Andromeda XTk Blofeld]>+

Factory and User Sound Singles for Waldorf Q+, Q and microQ:
http://Synth.Stromeko.net/Downloads.html#WaldorfSounds




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 24 Sep 2021 06:11:23 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Sep 24 02:11:23 2021
Received: from localhost ([127.0.0.1]:56499 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mTeQc-0000IH-S9
	for submit <at> debbugs.gnu.org; Fri, 24 Sep 2021 02:11:23 -0400
Received: from lists.gnu.org ([209.51.188.17]:57316)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <Stromeko@HIDDEN>) id 1mTeQY-0000I4-Fr
 for submit <at> debbugs.gnu.org; Fri, 24 Sep 2021 02:11:18 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:56222)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <Stromeko@HIDDEN>) id 1mTeQY-0003Li-9h
 for bug-gnu-emacs@HIDDEN; Fri, 24 Sep 2021 02:11:18 -0400
Received: from smtpout2.vodafonemail.de ([145.253.239.133]:40336)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <Stromeko@HIDDEN>) id 1mTeQV-0003cG-VG
 for bug-gnu-emacs@HIDDEN; Fri, 24 Sep 2021 02:11:17 -0400
Received: from smtp.vodafone.de (smtpa03.fra-mediabeam.com [10.2.0.34])
 by smtpout2.vodafonemail.de (Postfix) with ESMTP id 53AAA61287;
 Fri, 24 Sep 2021 08:11:11 +0200 (CEST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=nexgo.de;
 s=vfde-smtpout-mb-15sep; t=1632463871;
 bh=nQ+CjHv2oxkASoWH7VUgZJ61HpquVR4nnL16p6mScHA=;
 h=From:To:Cc:Subject:References:Date:In-Reply-To;
 b=ErvwsTuqdwEMTrJlMDbXIlstZBTq3/dgc8iZlq6Nn086gDyPuuzK3P9XQETpA4JRL
 ozzw/h9N+qgE6i8cHYZ7jl6zDCSaQwNf4vrV/vvHPF+pkkEQKIxtx5fspGkQnqiq5I
 2akXeryLkje4uTPBEqGUEHfGb6UiZv2hPfZ4lG6k=
Received: from Otto (p54a0cb96.dip0.t-ipconnect.de [84.160.203.150])
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256/256 bits)
 key-exchange ECDHE (P-256) server-signature RSA-PSS (2048 bits) server-digest
 SHA256) (No client certificate requested)
 by smtp.vodafone.de (Postfix) with ESMTPSA id E142C140278;
 Fri, 24 Sep 2021 06:11:09 +0000 (UTC)
From: ASSI <Stromeko@HIDDEN>
To: Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of
 text editors" <bug-gnu-emacs@HIDDEN>
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN>
 <835yux5dn1.fsf@HIDDEN> <87bl4pf3s1.fsf@HIDDEN>
 <83tuih3uvr.fsf@HIDDEN> <877dfcg5tu.fsf@HIDDEN>
 <83pmt44vn1.fsf@HIDDEN>
 <eae87657-d5b5-2265-9b89-4626467a4ac5@HIDDEN>
 <83mto84r9l.fsf@HIDDEN>
 <fbe7b320-c720-50ad-aa18-a74443d2b070@HIDDEN>
 <83fsu04mai.fsf@HIDDEN>
 <1a5e01a2-2247-2f68-82f6-2075577e02b6@HIDDEN>
 <837dfc4hi1.fsf@HIDDEN>
 <4ae8067f-55b2-d243-66f3-f76493095a39@HIDDEN>
 <83o88jvity.fsf@HIDDEN>
 <8e8e74ce-0deb-bcdc-d298-be2e9d4636d7@HIDDEN>
 <83bl4juu2c.fsf@HIDDEN> <87h7ebrylf.fsf@HIDDEN>
 <834kabuqsf.fsf@HIDDEN> <87zgs3qh5y.fsf@HIDDEN>
 <xjfh7ebqe19.fsf@HIDDEN>
Date: Fri, 24 Sep 2021 08:11:08 +0200
In-Reply-To: <xjfh7ebqe19.fsf@HIDDEN> (Andrea Corallo via's message of
 "Thu, 23 Sep 2021 19:37:22 +0000")
Message-ID: <87pmsyo64j.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-purgate-type: clean
X-purgate-Ad: Categorized by eleven eXpurgate (R) http://www.eleven.de
X-purgate: This mail is considered clean (visit http://www.eleven.de for
 further information)
X-purgate: clean
X-purgate-size: 1203
X-purgate-ID: 155817::1632463870-00000B26-B84EAB7D/0/0
Received-SPF: pass client-ip=145.253.239.133; envelope-from=Stromeko@HIDDEN;
 helo=smtpout2.vodafonemail.de
X-Spam_score_int: -27
X-Spam_score: -2.8
X-Spam_bar: --
X-Spam_report: (-2.8 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1,
 RCVD_IN_DNSWL_LOW=-0.7, RCVD_IN_MSPIKE_H2=-0.001, SPF_HELO_NONE=0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.4 (-)
X-Debbugs-Envelope-To: submit
Cc: Achim Gratz <Stromeko@HIDDEN>, 50666 <at> debbugs.gnu.org,
 Andrea Corallo <akrl@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.4 (--)

Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of
text editors" writes:
> To get practical I've:
>
> ~/.emacs.d/eln-cache/28.0.50-2045295c/apropos-7c1ecbdf-10e46ddb.eln
>                               ^^^               ^^^       ^^^
>                                A                 B         C
>
> A- accounts for emacs-verison, system-configuration,
>    system-configuration-options and the signatures of all the subr
>    present in the C code.

OK, so this would be unique for one Cygwin Emacs release and architecture.

> B- accounts for the absolute filename of
>    the source file

In general, is this hardcoded or can we change the hashing strategy for
Cygwin via some configuration or hook?

> C- accounts for the content for the source file

Can you point me to the part of the discussion where it was determined
that the absolute location of the file was making a difference that was
not covered with the hash of the content?


Regards,
Achim.
-- 
+<[Q+ Matrix-12 WAVE#46+305 Neuron microQkb Andromeda XTk Blofeld]>+

Factory and User Sound Singles for Waldorf Q+, Q and microQ:
http://Synth.Stromeko.net/Downloads.html#WaldorfSounds




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at 50666 <at> debbugs.gnu.org:


Received: (at 50666) by debbugs.gnu.org; 24 Sep 2021 06:04:23 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Sep 24 02:04:23 2021
Received: from localhost ([127.0.0.1]:56483 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mTeJr-0008WT-8D
	for submit <at> debbugs.gnu.org; Fri, 24 Sep 2021 02:04:23 -0400
Received: from smtpout2.vodafonemail.de ([145.253.239.133]:60240)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <Stromeko@HIDDEN>) id 1mTeJp-0008WI-Hg
 for 50666 <at> debbugs.gnu.org; Fri, 24 Sep 2021 02:04:22 -0400
Received: from smtp.vodafone.de (smtpa08.fra-mediabeam.com [10.2.0.39])
 by smtpout2.vodafonemail.de (Postfix) with ESMTP id 21D8061343;
 Fri, 24 Sep 2021 08:04:16 +0200 (CEST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=nexgo.de;
 s=vfde-smtpout-mb-15sep; t=1632463456;
 bh=ob25ooEH11YXtZ/el32zqXAqIi4y2s1ZdtdWYqAronU=;
 h=From:To:Cc:Subject:References:Date:In-Reply-To;
 b=WgjeKTscBmpXllK7h1TbLIoa0jOJF+KcoupwNI5DntC3T0jTrr39+ivFZxosZyjAY
 D4MtAfT6y4E8nG0mg6GWK8lfarrRcvW6zbI4UNWzy5ZXw0/bdwjk2S5PZ9IilGBq9p
 gM2DmHAuQev4rooossyHxCda84u++yzkoLfxhX7k=
Received: from Otto (p54a0cb96.dip0.t-ipconnect.de [84.160.203.150])
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256/256 bits)
 key-exchange ECDHE (P-256) server-signature RSA-PSS (2048 bits) server-digest
 SHA256) (No client certificate requested)
 by smtp.vodafone.de (Postfix) with ESMTPSA id 256FB1401EA;
 Fri, 24 Sep 2021 06:04:13 +0000 (UTC)
From: ASSI <Stromeko@HIDDEN>
To: Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of
 text editors" <bug-gnu-emacs@HIDDEN>
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN>
 <835yux5dn1.fsf@HIDDEN> <87bl4pf3s1.fsf@HIDDEN>
 <83tuih3uvr.fsf@HIDDEN> <877dfcg5tu.fsf@HIDDEN>
 <83pmt44vn1.fsf@HIDDEN>
 <eae87657-d5b5-2265-9b89-4626467a4ac5@HIDDEN>
 <83mto84r9l.fsf@HIDDEN>
 <fbe7b320-c720-50ad-aa18-a74443d2b070@HIDDEN>
 <83fsu04mai.fsf@HIDDEN>
 <1a5e01a2-2247-2f68-82f6-2075577e02b6@HIDDEN>
 <837dfc4hi1.fsf@HIDDEN>
 <4ae8067f-55b2-d243-66f3-f76493095a39@HIDDEN>
 <83o88jvity.fsf@HIDDEN> <xjflf3nqf92.fsf@HIDDEN>
Date: Fri, 24 Sep 2021 08:04:09 +0200
In-Reply-To: <xjflf3nqf92.fsf@HIDDEN> (Andrea Corallo via's message of
 "Thu, 23 Sep 2021 19:11:05 +0000")
Message-ID: <87tuiao6g6.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-purgate-type: clean
X-purgate-Ad: Categorized by eleven eXpurgate (R) http://www.eleven.de
X-purgate: This mail is considered clean (visit http://www.eleven.de for
 further information)
X-purgate: clean
X-purgate-size: 614
X-purgate-ID: 155817::1632463454-00007455-9241EC8C/0/0
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 50666
Cc: Eli Zaretskii <eliz@HIDDEN>, Stromeko@HIDDEN, 50666 <at> debbugs.gnu.org,
 Ken Brown <kbrown@HIDDEN>, Andrea Corallo <akrl@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of
text editors" writes:
> That said I'm wondering what is going to happen if an Emacs is running
> and a second sessions starts rebasing some eln.

You can't rebase an object that is already loaded on Windows (or load an
object that is in the process of getting rebased), so I would not worry
about this situation too much at the moment.


Regards,
Achim.
-- 
+<[Q+ Matrix-12 WAVE#46+305 Neuron microQkb Andromeda XTk Blofeld]>+

SD adaptation for Waldorf Blofeld V1.15B11:
http://Synth.Stromeko.net/Downloads.html#WaldorfSDada




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 24 Sep 2021 06:04:28 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Sep 24 02:04:28 2021
Received: from localhost ([127.0.0.1]:56486 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mTeJw-00005B-Fw
	for submit <at> debbugs.gnu.org; Fri, 24 Sep 2021 02:04:28 -0400
Received: from lists.gnu.org ([209.51.188.17]:48104)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <Stromeko@HIDDEN>) id 1mTeJu-000050-Bl
 for submit <at> debbugs.gnu.org; Fri, 24 Sep 2021 02:04:26 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:55214)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <Stromeko@HIDDEN>) id 1mTeJu-0005AA-6H
 for bug-gnu-emacs@HIDDEN; Fri, 24 Sep 2021 02:04:26 -0400
Received: from smtpout2.vodafonemail.de ([145.253.239.133]:35996)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <Stromeko@HIDDEN>)
 id 1mTeJr-0006BL-Pg; Fri, 24 Sep 2021 02:04:25 -0400
Received: from smtp.vodafone.de (smtpa08.fra-mediabeam.com [10.2.0.39])
 by smtpout2.vodafonemail.de (Postfix) with ESMTP id 21D8061343;
 Fri, 24 Sep 2021 08:04:16 +0200 (CEST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=nexgo.de;
 s=vfde-smtpout-mb-15sep; t=1632463456;
 bh=ob25ooEH11YXtZ/el32zqXAqIi4y2s1ZdtdWYqAronU=;
 h=From:To:Cc:Subject:References:Date:In-Reply-To;
 b=WgjeKTscBmpXllK7h1TbLIoa0jOJF+KcoupwNI5DntC3T0jTrr39+ivFZxosZyjAY
 D4MtAfT6y4E8nG0mg6GWK8lfarrRcvW6zbI4UNWzy5ZXw0/bdwjk2S5PZ9IilGBq9p
 gM2DmHAuQev4rooossyHxCda84u++yzkoLfxhX7k=
Received: from Otto (p54a0cb96.dip0.t-ipconnect.de [84.160.203.150])
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256/256 bits)
 key-exchange ECDHE (P-256) server-signature RSA-PSS (2048 bits) server-digest
 SHA256) (No client certificate requested)
 by smtp.vodafone.de (Postfix) with ESMTPSA id 256FB1401EA;
 Fri, 24 Sep 2021 06:04:13 +0000 (UTC)
From: ASSI <Stromeko@HIDDEN>
To: Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of
 text editors" <bug-gnu-emacs@HIDDEN>
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN>
 <835yux5dn1.fsf@HIDDEN> <87bl4pf3s1.fsf@HIDDEN>
 <83tuih3uvr.fsf@HIDDEN> <877dfcg5tu.fsf@HIDDEN>
 <83pmt44vn1.fsf@HIDDEN>
 <eae87657-d5b5-2265-9b89-4626467a4ac5@HIDDEN>
 <83mto84r9l.fsf@HIDDEN>
 <fbe7b320-c720-50ad-aa18-a74443d2b070@HIDDEN>
 <83fsu04mai.fsf@HIDDEN>
 <1a5e01a2-2247-2f68-82f6-2075577e02b6@HIDDEN>
 <837dfc4hi1.fsf@HIDDEN>
 <4ae8067f-55b2-d243-66f3-f76493095a39@HIDDEN>
 <83o88jvity.fsf@HIDDEN> <xjflf3nqf92.fsf@HIDDEN>
Date: Fri, 24 Sep 2021 08:04:09 +0200
In-Reply-To: <xjflf3nqf92.fsf@HIDDEN> (Andrea Corallo via's message of
 "Thu, 23 Sep 2021 19:11:05 +0000")
Message-ID: <87tuiao6g6.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-purgate-type: clean
X-purgate-Ad: Categorized by eleven eXpurgate (R) http://www.eleven.de
X-purgate: This mail is considered clean (visit http://www.eleven.de for
 further information)
X-purgate: clean
X-purgate-size: 614
X-purgate-ID: 155817::1632463454-00007455-9241EC8C/0/0
Received-SPF: pass client-ip=145.253.239.133; envelope-from=Stromeko@HIDDEN;
 helo=smtpout2.vodafonemail.de
X-Spam_score_int: -27
X-Spam_score: -2.8
X-Spam_bar: --
X-Spam_report: (-2.8 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1,
 RCVD_IN_DNSWL_LOW=-0.7, RCVD_IN_MSPIKE_H2=-0.001, SPF_HELO_NONE=0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.4 (-)
X-Debbugs-Envelope-To: submit
Cc: Eli Zaretskii <eliz@HIDDEN>, Stromeko@HIDDEN, 50666 <at> debbugs.gnu.org,
 Ken Brown <kbrown@HIDDEN>, Andrea Corallo <akrl@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.4 (--)

Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of
text editors" writes:
> That said I'm wondering what is going to happen if an Emacs is running
> and a second sessions starts rebasing some eln.

You can't rebase an object that is already loaded on Windows (or load an
object that is in the process of getting rebased), so I would not worry
about this situation too much at the moment.


Regards,
Achim.
-- 
+<[Q+ Matrix-12 WAVE#46+305 Neuron microQkb Andromeda XTk Blofeld]>+

SD adaptation for Waldorf Blofeld V1.15B11:
http://Synth.Stromeko.net/Downloads.html#WaldorfSDada




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at 50666 <at> debbugs.gnu.org:


Received: (at 50666) by debbugs.gnu.org; 23 Sep 2021 19:37:26 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Sep 23 15:37:26 2021
Received: from localhost ([127.0.0.1]:55928 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mTUX7-0003TU-RK
	for submit <at> debbugs.gnu.org; Thu, 23 Sep 2021 15:37:26 -0400
Received: from mx.sdf.org ([205.166.94.24]:56316)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1mTUX5-0003TJ-VH
 for 50666 <at> debbugs.gnu.org; Thu, 23 Sep 2021 15:37:24 -0400
Received: from ma.sdf.org (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 18NJbMla018919
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Thu, 23 Sep 2021 19:37:22 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Achim Gratz <Stromeko@HIDDEN>
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN>
 <835yux5dn1.fsf@HIDDEN> <87bl4pf3s1.fsf@HIDDEN>
 <83tuih3uvr.fsf@HIDDEN> <877dfcg5tu.fsf@HIDDEN>
 <83pmt44vn1.fsf@HIDDEN>
 <eae87657-d5b5-2265-9b89-4626467a4ac5@HIDDEN>
 <83mto84r9l.fsf@HIDDEN>
 <fbe7b320-c720-50ad-aa18-a74443d2b070@HIDDEN>
 <83fsu04mai.fsf@HIDDEN>
 <1a5e01a2-2247-2f68-82f6-2075577e02b6@HIDDEN>
 <837dfc4hi1.fsf@HIDDEN>
 <4ae8067f-55b2-d243-66f3-f76493095a39@HIDDEN>
 <83o88jvity.fsf@HIDDEN>
 <8e8e74ce-0deb-bcdc-d298-be2e9d4636d7@HIDDEN>
 <83bl4juu2c.fsf@HIDDEN> <87h7ebrylf.fsf@HIDDEN>
 <834kabuqsf.fsf@HIDDEN> <87zgs3qh5y.fsf@HIDDEN>
Date: Thu, 23 Sep 2021 19:37:22 +0000
In-Reply-To: <87zgs3qh5y.fsf@HIDDEN> (Achim Gratz's message of "Thu,
 23 Sep 2021 20:29:45 +0200")
Message-ID: <xjfh7ebqe19.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 50666
Cc: 50666 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Achim Gratz <Stromeko@HIDDEN> writes:

> Eli Zaretskii writes:
>> Out of curiosity, what do you do with the myriad DLLs that Windows
>> itself provides?  Aren't they part of the same problem with the Cygwin
>> implementation of 'fork'?
>
> These are never part of the Cygwin process.
>
>> No, there are no architecture-specific branches.  I guess the idea is
>> that the 2 hashes in the file name and the 3rd has in the directory
>> name (which depends on the Emacs binary) will take care of that.
>
> Hmm, I seem to remember some post from Andrea that showed a
> x86_64-pc-linux-gnu subdirectory for the cached files.  So how are these
> hashes generated, then?

Hi Achim,

the triplet is not mentioned explicitly in the generated path as it was
deemed to be excessively verbose.  It is now included in the hash of the
directory name.

To get practical I've:

~/.emacs.d/eln-cache/28.0.50-2045295c/apropos-7c1ecbdf-10e46ddb.eln
                              ^^^               ^^^       ^^^
                               A                 B         C

A- accounts for emacs-verison, system-configuration,
   system-configuration-options and the signatures of all the subr
   present in the C code.

B- accounts for the absolute filename of
   the source file

C- accounts for the content for the source file

Regards

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at 50666 <at> debbugs.gnu.org:


Received: (at 50666) by debbugs.gnu.org; 23 Sep 2021 19:21:31 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Sep 23 15:21:31 2021
Received: from localhost ([127.0.0.1]:55912 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mTUHi-00032N-SB
	for submit <at> debbugs.gnu.org; Thu, 23 Sep 2021 15:21:31 -0400
Received: from eggs.gnu.org ([209.51.188.92]:52754)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1mTUHh-000329-1X
 for 50666 <at> debbugs.gnu.org; Thu, 23 Sep 2021 15:21:29 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:56770)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1mTUHY-0007os-Ec; Thu, 23 Sep 2021 15:21:20 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:1421
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1mTUHY-0003yo-1g; Thu, 23 Sep 2021 15:21:20 -0400
Date: Thu, 23 Sep 2021 22:21:12 +0300
Message-Id: <83r1dft7x3.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjflf3nqf92.fsf@HIDDEN> (message from Andrea Corallo on Thu, 
 23 Sep 2021 19:11:05 +0000)
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN>
 <835yux5dn1.fsf@HIDDEN> <87bl4pf3s1.fsf@HIDDEN>
 <83tuih3uvr.fsf@HIDDEN> <877dfcg5tu.fsf@HIDDEN>
 <83pmt44vn1.fsf@HIDDEN>
 <eae87657-d5b5-2265-9b89-4626467a4ac5@HIDDEN>
 <83mto84r9l.fsf@HIDDEN>
 <fbe7b320-c720-50ad-aa18-a74443d2b070@HIDDEN>
 <83fsu04mai.fsf@HIDDEN>
 <1a5e01a2-2247-2f68-82f6-2075577e02b6@HIDDEN>
 <837dfc4hi1.fsf@HIDDEN>
 <4ae8067f-55b2-d243-66f3-f76493095a39@HIDDEN>
 <83o88jvity.fsf@HIDDEN> <xjflf3nqf92.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 50666
Cc: Stromeko@HIDDEN, 50666 <at> debbugs.gnu.org, kbrown@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Andrea Corallo <akrl@HIDDEN>
> Cc: Ken Brown <kbrown@HIDDEN>, Stromeko@HIDDEN, 50666 <at> debbugs.gnu.org
> Date: Thu, 23 Sep 2021 19:11:05 +0000
> 
> That said I'm wondering what is going to happen if an Emacs is running
> and a second sessions starts rebasing some eln.

I think the session which rebases will have to use the same trick with
renaming we use when recompiling a loaded .eln.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at 50666 <at> debbugs.gnu.org:


Received: (at 50666) by debbugs.gnu.org; 23 Sep 2021 19:11:17 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Sep 23 15:11:17 2021
Received: from localhost ([127.0.0.1]:55899 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mTU7o-0002lM-VH
	for submit <at> debbugs.gnu.org; Thu, 23 Sep 2021 15:11:17 -0400
Received: from mx.sdf.org ([205.166.94.24]:58267)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1mTU7m-0002lA-K3
 for 50666 <at> debbugs.gnu.org; Thu, 23 Sep 2021 15:11:15 -0400
Received: from ma.sdf.org (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 18NJB5kU025282
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Thu, 23 Sep 2021 19:11:07 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN>
 <835yux5dn1.fsf@HIDDEN> <87bl4pf3s1.fsf@HIDDEN>
 <83tuih3uvr.fsf@HIDDEN> <877dfcg5tu.fsf@HIDDEN>
 <83pmt44vn1.fsf@HIDDEN>
 <eae87657-d5b5-2265-9b89-4626467a4ac5@HIDDEN>
 <83mto84r9l.fsf@HIDDEN>
 <fbe7b320-c720-50ad-aa18-a74443d2b070@HIDDEN>
 <83fsu04mai.fsf@HIDDEN>
 <1a5e01a2-2247-2f68-82f6-2075577e02b6@HIDDEN>
 <837dfc4hi1.fsf@HIDDEN>
 <4ae8067f-55b2-d243-66f3-f76493095a39@HIDDEN>
 <83o88jvity.fsf@HIDDEN>
Date: Thu, 23 Sep 2021 19:11:05 +0000
In-Reply-To: <83o88jvity.fsf@HIDDEN> (Eli Zaretskii's message of "Thu, 23 Sep
 2021 10:42:33 +0300")
Message-ID: <xjflf3nqf92.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 50666
Cc: Stromeko@HIDDEN, 50666 <at> debbugs.gnu.org, Ken Brown <kbrown@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> Cc: Stromeko@HIDDEN, 50666 <at> debbugs.gnu.org
>> From: Ken Brown <kbrown@HIDDEN>
>> Date: Wed, 22 Sep 2021 17:35:28 -0400
>> 
>> We've made a good start on the Cygwin side, but I have a question about how to 
>> integrate it into Emacs.
>
> I added Andrea to this discussion, as he knows more than anyone else
> about the Emacs side of this stuff.
>
>> Let's say we have a script that I'll call "rebase" for the purpose of this 
>> discussion, which rebases all the eln files in ~/.emacs.d/eln-cache.  The user 
>> would then start Emacs via a script that first calls rebase and then starts 
>> Emacs.
>
> Is it really necessary to rebase the *.eln files before each startup?
> Isn't it enough to rebase each of the .eln files just once, when it is
> produced?  If indeed this is needed every time, can you explain why?
>
>> Within Emacs, I would then want to do something like
>> 
>> (if (eq system-type 'cygwin)
>>      (call-process "rebase" nil
>>                    '(:file "<log file>")
>>                    nil "<arg>" ...))
>> 
>> after every compilation but before the compiled file is loaded.
>> 
>> I'm not familiar enough with native compilation to know where this should go. 
>
> The non-preloaded *.eln files are all loaded by native-elisp-load, so
> I guess the rebase should be launched from there?  The preloaded *.eln
> files are loaded in pdumper.c:dump_do_dump_relocation, but do we need
> to support non-rebased preloaded *.eln files?

Yes I think too `native-elisp-load' and `dump_do_dump_relocation' are
the two places we'd want to trigger the rebase (not sure if in
`dump_do_dump_relocation' we are already able to spawn subprocesses
tho).

That said I'm wondering what is going to happen if an Emacs is running
and a second sessions starts rebasing some eln.

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at 50666 <at> debbugs.gnu.org:


Received: (at 50666) by debbugs.gnu.org; 23 Sep 2021 18:57:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Sep 23 14:57:48 2021
Received: from localhost ([127.0.0.1]:55891 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mTTum-0002O4-Cs
	for submit <at> debbugs.gnu.org; Thu, 23 Sep 2021 14:57:48 -0400
Received: from eggs.gnu.org ([209.51.188.92]:48628)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1mTTul-0002Nq-B4
 for 50666 <at> debbugs.gnu.org; Thu, 23 Sep 2021 14:57:47 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:55884)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1mTTue-0004S7-5G; Thu, 23 Sep 2021 14:57:40 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:3932
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1mTTub-00083r-QH; Thu, 23 Sep 2021 14:57:38 -0400
Date: Thu, 23 Sep 2021 21:57:30 +0300
Message-Id: <83v92rt90l.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Achim Gratz <Stromeko@HIDDEN>
In-Reply-To: <87zgs3qh5y.fsf@HIDDEN> (message from Achim Gratz on Thu, 
 23 Sep 2021 20:29:45 +0200)
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN>
 <835yux5dn1.fsf@HIDDEN> <87bl4pf3s1.fsf@HIDDEN>
 <83tuih3uvr.fsf@HIDDEN> <877dfcg5tu.fsf@HIDDEN>
 <83pmt44vn1.fsf@HIDDEN>
 <eae87657-d5b5-2265-9b89-4626467a4ac5@HIDDEN>
 <83mto84r9l.fsf@HIDDEN>
 <fbe7b320-c720-50ad-aa18-a74443d2b070@HIDDEN>
 <83fsu04mai.fsf@HIDDEN>
 <1a5e01a2-2247-2f68-82f6-2075577e02b6@HIDDEN>
 <837dfc4hi1.fsf@HIDDEN>
 <4ae8067f-55b2-d243-66f3-f76493095a39@HIDDEN>
 <83o88jvity.fsf@HIDDEN>
 <8e8e74ce-0deb-bcdc-d298-be2e9d4636d7@HIDDEN>
 <83bl4juu2c.fsf@HIDDEN> <87h7ebrylf.fsf@HIDDEN>
 <834kabuqsf.fsf@HIDDEN> <87zgs3qh5y.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 50666
Cc: 50666 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Achim Gratz <Stromeko@HIDDEN>
> Date: Thu, 23 Sep 2021 20:29:45 +0200
> 
> > No, there are no architecture-specific branches.  I guess the idea is
> > that the 2 hashes in the file name and the 3rd has in the directory
> > name (which depends on the Emacs binary) will take care of that.
> 
> Hmm, I seem to remember some post from Andrea that showed a
> x86_64-pc-linux-gnu subdirectory for the cached files.  So how are these
> hashes generated, then?

The directory where the *.eln files are installed is named XX.YY-HASH,
where XX.YY is the Emacs version and HASH is computed by hashing the
string that's the concatenation of the native-compilation ABI version,
the Emacs version, the system-configuration (that's your
x86_64-pc-linux-gnu thing), system-configuration-options, and the
signatures of all the primitives.

The *.eln file names have 2 hashes: one is computed from the absolute
file name of the source .el file, the other from the contents of the
source .el file.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at 50666 <at> debbugs.gnu.org:


Received: (at 50666) by debbugs.gnu.org; 23 Sep 2021 18:47:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Sep 23 14:47:03 2021
Received: from localhost ([127.0.0.1]:55868 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mTTkI-00023T-So
	for submit <at> debbugs.gnu.org; Thu, 23 Sep 2021 14:47:03 -0400
Received: from eggs.gnu.org ([209.51.188.92]:47138)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1mTTkG-00023E-Lu
 for 50666 <at> debbugs.gnu.org; Thu, 23 Sep 2021 14:46:56 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:55692)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1mTTk9-0003nv-KX; Thu, 23 Sep 2021 14:46:49 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:3277
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1mTTk9-00070l-5g; Thu, 23 Sep 2021 14:46:49 -0400
Date: Thu, 23 Sep 2021 21:46:44 +0300
Message-Id: <83wnn7t9ij.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Achim Gratz <Stromeko@HIDDEN>
In-Reply-To: <874kabrvy9.fsf@HIDDEN> (message from Achim Gratz on Thu, 
 23 Sep 2021 20:25:02 +0200)
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN>
 <835yux5dn1.fsf@HIDDEN> <87bl4pf3s1.fsf@HIDDEN>
 <83tuih3uvr.fsf@HIDDEN> <877dfcg5tu.fsf@HIDDEN>
 <83pmt44vn1.fsf@HIDDEN>
 <eae87657-d5b5-2265-9b89-4626467a4ac5@HIDDEN>
 <83mto84r9l.fsf@HIDDEN>
 <fbe7b320-c720-50ad-aa18-a74443d2b070@HIDDEN>
 <83fsu04mai.fsf@HIDDEN>
 <1a5e01a2-2247-2f68-82f6-2075577e02b6@HIDDEN>
 <837dfc4hi1.fsf@HIDDEN>
 <4ae8067f-55b2-d243-66f3-f76493095a39@HIDDEN>
 <83o88jvity.fsf@HIDDEN>
 <8e8e74ce-0deb-bcdc-d298-be2e9d4636d7@HIDDEN>
 <83bl4juu2c.fsf@HIDDEN>
 <a4c6b589-dc73-9553-a7a3-271f4aca0aaa@HIDDEN>
 <837df7urnz.fsf@HIDDEN> <878rznrxm6.fsf@HIDDEN>
 <83zgs3tblj.fsf@HIDDEN> <874kabrvy9.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 50666
Cc: 50666 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Achim Gratz <Stromeko@HIDDEN>
> Date: Thu, 23 Sep 2021 20:25:02 +0200
> 
> Eli Zaretskii writes:
> > You mean, ASLR doesn't work with Cygwin because it must use the same
> > address in the forked process?  But then why did Ken say that ASLR and
> > High Entropy could solve the problem with the *.eln files -- isn't
> > that the same problem?
> 
> It is, but on 64bit with the massive address space and high entropy
> using most of it, it will often "just work" for quite some time.

I understand that it might "just work" wrt collisions, but what about
the requirement that the DLL be loaded at the same address in the
forked child?  Doesn't ASLR randomize the base address each time a DLL
is loaded?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 23 Sep 2021 18:30:10 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Sep 23 14:30:10 2021
Received: from localhost ([127.0.0.1]:55845 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mTTU2-0001bz-Ff
	for submit <at> debbugs.gnu.org; Thu, 23 Sep 2021 14:30:10 -0400
Received: from lists.gnu.org ([209.51.188.17]:47004)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1mTTU0-0001bq-L6
 for submit <at> debbugs.gnu.org; Thu, 23 Sep 2021 14:30:08 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:60948)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1mTTU0-0003A6-Bl
 for bug-gnu-emacs@HIDDEN; Thu, 23 Sep 2021 14:30:08 -0400
Received: from ciao.gmane.io ([116.202.254.214]:38462)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1mTTTy-00060M-NY
 for bug-gnu-emacs@HIDDEN; Thu, 23 Sep 2021 14:30:07 -0400
Received: from list by ciao.gmane.io with local (Exim 4.92)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1mTTTu-0009EU-4C
 for bug-gnu-emacs@HIDDEN; Thu, 23 Sep 2021 20:30:02 +0200
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Achim Gratz <Stromeko@HIDDEN>
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
Date: Thu, 23 Sep 2021 20:29:45 +0200
Organization: Linux Private Site
Message-ID: <87zgs3qh5y.fsf@HIDDEN>
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN>
 <835yux5dn1.fsf@HIDDEN> <87bl4pf3s1.fsf@HIDDEN>
 <83tuih3uvr.fsf@HIDDEN> <877dfcg5tu.fsf@HIDDEN>
 <83pmt44vn1.fsf@HIDDEN>
 <eae87657-d5b5-2265-9b89-4626467a4ac5@HIDDEN>
 <83mto84r9l.fsf@HIDDEN>
 <fbe7b320-c720-50ad-aa18-a74443d2b070@HIDDEN>
 <83fsu04mai.fsf@HIDDEN>
 <1a5e01a2-2247-2f68-82f6-2075577e02b6@HIDDEN>
 <837dfc4hi1.fsf@HIDDEN>
 <4ae8067f-55b2-d243-66f3-f76493095a39@HIDDEN>
 <83o88jvity.fsf@HIDDEN>
 <8e8e74ce-0deb-bcdc-d298-be2e9d4636d7@HIDDEN>
 <83bl4juu2c.fsf@HIDDEN> <87h7ebrylf.fsf@HIDDEN>
 <834kabuqsf.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.2 (gnu/linux)
Cancel-Lock: sha1:VsA995TJdYJrJYueh1HqS9qPZK0=
Received-SPF: pass client-ip=116.202.254.214;
 envelope-from=geb-bug-gnu-emacs@HIDDEN; helo=ciao.gmane.io
X-Spam_score_int: -16
X-Spam_score: -1.7
X-Spam_bar: -
X-Spam_report: (-1.7 / 5.0 requ) BAYES_00=-1.9,
 HEADER_FROM_DIFFERENT_DOMAINS=0.248, SPF_HELO_NONE=0.001,
 SPF_PASS=-0.001 autolearn=no autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.1 (-)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.1 (--)

Eli Zaretskii writes:
> Out of curiosity, what do you do with the myriad DLLs that Windows
> itself provides?  Aren't they part of the same problem with the Cygwin
> implementation of 'fork'?

These are never part of the Cygwin process.

> No, there are no architecture-specific branches.  I guess the idea is
> that the 2 hashes in the file name and the 3rd has in the directory
> name (which depends on the Emacs binary) will take care of that.

Hmm, I seem to remember some post from Andrea that showed a
x86_64-pc-linux-gnu subdirectory for the cached files.  So how are these
hashes generated, then?


Regards,
Achim.
-- 
+<[Q+ Matrix-12 WAVE#46+305 Neuron microQkb Andromeda XTk Blofeld]>+

SD adaptations for Waldorf Q V3.00R3 and Q+ V3.54R2:
http://Synth.Stromeko.net/Downloads.html#WaldorfSDada





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 23 Sep 2021 18:25:18 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Sep 23 14:25:18 2021
Received: from localhost ([127.0.0.1]:55841 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mTTPJ-0001Sw-So
	for submit <at> debbugs.gnu.org; Thu, 23 Sep 2021 14:25:18 -0400
Received: from lists.gnu.org ([209.51.188.17]:42402)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1mTTPI-0001So-47
 for submit <at> debbugs.gnu.org; Thu, 23 Sep 2021 14:25:16 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:59946)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1mTTPH-0008GO-TP
 for bug-gnu-emacs@HIDDEN; Thu, 23 Sep 2021 14:25:15 -0400
Received: from ciao.gmane.io ([116.202.254.214]:50096)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1mTTPF-0001pt-OV
 for bug-gnu-emacs@HIDDEN; Thu, 23 Sep 2021 14:25:15 -0400
Received: from list by ciao.gmane.io with local (Exim 4.92)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1mTTPC-0002rR-Vm
 for bug-gnu-emacs@HIDDEN; Thu, 23 Sep 2021 20:25:10 +0200
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Achim Gratz <Stromeko@HIDDEN>
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
Date: Thu, 23 Sep 2021 20:25:02 +0200
Organization: Linux Private Site
Message-ID: <874kabrvy9.fsf@HIDDEN>
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN>
 <835yux5dn1.fsf@HIDDEN> <87bl4pf3s1.fsf@HIDDEN>
 <83tuih3uvr.fsf@HIDDEN> <877dfcg5tu.fsf@HIDDEN>
 <83pmt44vn1.fsf@HIDDEN>
 <eae87657-d5b5-2265-9b89-4626467a4ac5@HIDDEN>
 <83mto84r9l.fsf@HIDDEN>
 <fbe7b320-c720-50ad-aa18-a74443d2b070@HIDDEN>
 <83fsu04mai.fsf@HIDDEN>
 <1a5e01a2-2247-2f68-82f6-2075577e02b6@HIDDEN>
 <837dfc4hi1.fsf@HIDDEN>
 <4ae8067f-55b2-d243-66f3-f76493095a39@HIDDEN>
 <83o88jvity.fsf@HIDDEN>
 <8e8e74ce-0deb-bcdc-d298-be2e9d4636d7@HIDDEN>
 <83bl4juu2c.fsf@HIDDEN>
 <a4c6b589-dc73-9553-a7a3-271f4aca0aaa@HIDDEN>
 <837df7urnz.fsf@HIDDEN> <878rznrxm6.fsf@HIDDEN>
 <83zgs3tblj.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.2 (gnu/linux)
Cancel-Lock: sha1:6SuUEVrNKqYAA5N70cat/iKr0XY=
Received-SPF: pass client-ip=116.202.254.214;
 envelope-from=geb-bug-gnu-emacs@HIDDEN; helo=ciao.gmane.io
X-Spam_score_int: -16
X-Spam_score: -1.7
X-Spam_bar: -
X-Spam_report: (-1.7 / 5.0 requ) BAYES_00=-1.9,
 HEADER_FROM_DIFFERENT_DOMAINS=0.248, SPF_HELO_NONE=0.001,
 SPF_PASS=-0.001 autolearn=no autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.1 (-)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.1 (--)

Eli Zaretskii writes:
> You mean, ASLR doesn't work with Cygwin because it must use the same
> address in the forked process?  But then why did Ken say that ASLR and
> High Entropy could solve the problem with the *.eln files -- isn't
> that the same problem?

It is, but on 64bit with the massive address space and high entropy
using most of it, it will often "just work" for quite some time.

> Sorry, I don't understand.  My suggestion was, if you need to make the
> *.eln files be marked as ASLR with High Entropy, to use a variable we
> have for this purpose, it will force the linker to produce *.eln files
> with these bits set in the PE+ header.  What other control do you need
> for your purposes, or what am I missing?

The control that Cygwin would need is an indication to whatever
generates the image base shifts for ASLR that it should not re-map an
image that is already in use elsewhere (maybe just in the same process
group).  ASLR already re-uses the address for the same image most of the
time (the exact behaviour is different across Windows versions), but
depending on circumstances outside your control it can suddenly decide
to use a different address.


Regards,
Achim.
-- 
+<[Q+ Matrix-12 WAVE#46+305 Neuron microQkb Andromeda XTk Blofeld]>+

Factory and User Sound Singles for Waldorf rackAttack:
http://Synth.Stromeko.net/Downloads.html#WaldorfSounds





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at 50666 <at> debbugs.gnu.org:


Received: (at 50666) by debbugs.gnu.org; 23 Sep 2021 18:01:58 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Sep 23 14:01:58 2021
Received: from localhost ([127.0.0.1]:55814 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mTT2k-0000pm-60
	for submit <at> debbugs.gnu.org; Thu, 23 Sep 2021 14:01:58 -0400
Received: from eggs.gnu.org ([209.51.188.92]:36550)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1mTT2i-0000pV-Dx
 for 50666 <at> debbugs.gnu.org; Thu, 23 Sep 2021 14:01:56 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:54324)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1mTT2b-0006iw-72; Thu, 23 Sep 2021 14:01:49 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:4508
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1mTT2Z-0004ln-Qh; Thu, 23 Sep 2021 14:01:49 -0400
Date: Thu, 23 Sep 2021 21:01:44 +0300
Message-Id: <83zgs3tblj.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Achim Gratz <Stromeko@HIDDEN>
In-Reply-To: <878rznrxm6.fsf@HIDDEN> (message from Achim Gratz on Thu, 
 23 Sep 2021 19:49:05 +0200)
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN>
 <835yux5dn1.fsf@HIDDEN> <87bl4pf3s1.fsf@HIDDEN>
 <83tuih3uvr.fsf@HIDDEN> <877dfcg5tu.fsf@HIDDEN>
 <83pmt44vn1.fsf@HIDDEN>
 <eae87657-d5b5-2265-9b89-4626467a4ac5@HIDDEN>
 <83mto84r9l.fsf@HIDDEN>
 <fbe7b320-c720-50ad-aa18-a74443d2b070@HIDDEN>
 <83fsu04mai.fsf@HIDDEN>
 <1a5e01a2-2247-2f68-82f6-2075577e02b6@HIDDEN>
 <837dfc4hi1.fsf@HIDDEN>
 <4ae8067f-55b2-d243-66f3-f76493095a39@HIDDEN>
 <83o88jvity.fsf@HIDDEN>
 <8e8e74ce-0deb-bcdc-d298-be2e9d4636d7@HIDDEN>
 <83bl4juu2c.fsf@HIDDEN>
 <a4c6b589-dc73-9553-a7a3-271f4aca0aaa@HIDDEN>
 <837df7urnz.fsf@HIDDEN> <878rznrxm6.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 50666
Cc: 50666 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Achim Gratz <Stromeko@HIDDEN>
> Date: Thu, 23 Sep 2021 19:49:05 +0200
> 
> Eli Zaretskii writes:
> >> We still need to do something for 64-bit Cygwin.  Even though address collisions 
> >> are unlikely they could still happen theoretically.  But there might be a much 
> >> easier solution that doesn't necessarily require rebasing.  For example, Achim 
> >> mentioned earlier the possibility of marking the eln as ASLR w/ high-entropy and
> >> large address aware.
> >
> > Isn't that the default of the 64-bit GNU ld on Windows?  Or does
> > Cygwin configure Binutils differently from MinGW?
> 
> No, I've had to remove that default since obviously it doesn't work on
> Cygwin.

You mean, ASLR doesn't work with Cygwin because it must use the same
address in the forked process?  But then why did Ken say that ASLR and
High Entropy could solve the problem with the *.eln files -- isn't
that the same problem?

> > If not, we can use native-comp-driver-options, by giving it a non-nil
> > value for Cygwin, to force this.
> 
> All that would be needed, on 64bit at least, is a tiny bit more control
> over how ASLR works, but there isn't even proper documentation about
> what it actually does (that I can find anyway).  M$ must have solved
> that problem for WSL1, but whatever it was, it didn't make it to the NT
> subsystem.

Sorry, I don't understand.  My suggestion was, if you need to make the
*.eln files be marked as ASLR with High Entropy, to use a variable we
have for this purpose, it will force the linker to produce *.eln files
with these bits set in the PE+ header.  What other control do you need
for your purposes, or what am I missing?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 23 Sep 2021 17:49:25 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Sep 23 13:49:25 2021
Received: from localhost ([127.0.0.1]:55795 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mTSqb-0000TT-1B
	for submit <at> debbugs.gnu.org; Thu, 23 Sep 2021 13:49:25 -0400
Received: from lists.gnu.org ([209.51.188.17]:56140)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1mTSqZ-0000TJ-6y
 for submit <at> debbugs.gnu.org; Thu, 23 Sep 2021 13:49:23 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:50970)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1mTSqV-00035r-PC
 for bug-gnu-emacs@HIDDEN; Thu, 23 Sep 2021 13:49:22 -0400
Received: from ciao.gmane.io ([116.202.254.214]:38196)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1mTSqT-0004P2-8q
 for bug-gnu-emacs@HIDDEN; Thu, 23 Sep 2021 13:49:18 -0400
Received: from list by ciao.gmane.io with local (Exim 4.92)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1mTSqP-0008WL-St
 for bug-gnu-emacs@HIDDEN; Thu, 23 Sep 2021 19:49:13 +0200
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Achim Gratz <Stromeko@HIDDEN>
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
Date: Thu, 23 Sep 2021 19:49:05 +0200
Organization: Linux Private Site
Message-ID: <878rznrxm6.fsf@HIDDEN>
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN>
 <835yux5dn1.fsf@HIDDEN> <87bl4pf3s1.fsf@HIDDEN>
 <83tuih3uvr.fsf@HIDDEN> <877dfcg5tu.fsf@HIDDEN>
 <83pmt44vn1.fsf@HIDDEN>
 <eae87657-d5b5-2265-9b89-4626467a4ac5@HIDDEN>
 <83mto84r9l.fsf@HIDDEN>
 <fbe7b320-c720-50ad-aa18-a74443d2b070@HIDDEN>
 <83fsu04mai.fsf@HIDDEN>
 <1a5e01a2-2247-2f68-82f6-2075577e02b6@HIDDEN>
 <837dfc4hi1.fsf@HIDDEN>
 <4ae8067f-55b2-d243-66f3-f76493095a39@HIDDEN>
 <83o88jvity.fsf@HIDDEN>
 <8e8e74ce-0deb-bcdc-d298-be2e9d4636d7@HIDDEN>
 <83bl4juu2c.fsf@HIDDEN>
 <a4c6b589-dc73-9553-a7a3-271f4aca0aaa@HIDDEN>
 <837df7urnz.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.2 (gnu/linux)
Cancel-Lock: sha1:nq60DzIuN5PUqrlj0R8IC4T6zW4=
Received-SPF: pass client-ip=116.202.254.214;
 envelope-from=geb-bug-gnu-emacs@HIDDEN; helo=ciao.gmane.io
X-Spam_score_int: -16
X-Spam_score: -1.7
X-Spam_bar: -
X-Spam_report: (-1.7 / 5.0 requ) BAYES_00=-1.9,
 HEADER_FROM_DIFFERENT_DOMAINS=0.248, SPF_HELO_NONE=0.001,
 SPF_PASS=-0.001 autolearn=no autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.1 (-)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.1 (--)

Eli Zaretskii writes:
>> We still need to do something for 64-bit Cygwin.  Even though address collisions 
>> are unlikely they could still happen theoretically.  But there might be a much 
>> easier solution that doesn't necessarily require rebasing.  For example, Achim 
>> mentioned earlier the possibility of marking the eln as ASLR w/ high-entropy and
>> large address aware.
>
> Isn't that the default of the 64-bit GNU ld on Windows?  Or does
> Cygwin configure Binutils differently from MinGW?

No, I've had to remove that default since obviously it doesn't work on
Cygwin.  Yes, I have seen this problem in reality while testing the
new binutils - that why I patched it out.

> If not, we can use native-comp-driver-options, by giving it a non-nil
> value for Cygwin, to force this.

All that would be needed, on 64bit at least, is a tiny bit more control
over how ASLR works, but there isn't even proper documentation about
what it actually does (that I can find anyway).  M$ must have solved
that problem for WSL1, but whatever it was, it didn't make it to the NT
subsystem.


Regards,
Achim.
-- 
+<[Q+ Matrix-12 WAVE#46+305 Neuron microQkb Andromeda XTk Blofeld]>+

Wavetables for the Terratec KOMPLEXER:
http://Synth.Stromeko.net/Downloads.html#KomplexerWaves





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at 50666 <at> debbugs.gnu.org:


Received: (at 50666) by debbugs.gnu.org; 23 Sep 2021 17:48:33 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Sep 23 13:48:33 2021
Received: from localhost ([127.0.0.1]:55791 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mTSpk-0000Rm-MB
	for submit <at> debbugs.gnu.org; Thu, 23 Sep 2021 13:48:32 -0400
Received: from eggs.gnu.org ([209.51.188.92]:33730)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1mTSpj-0000RW-6k
 for 50666 <at> debbugs.gnu.org; Thu, 23 Sep 2021 13:48:31 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:53800)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1mTSpa-0003fz-Ij; Thu, 23 Sep 2021 13:48:23 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:3681
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1mTSpa-0005Ba-1p; Thu, 23 Sep 2021 13:48:22 -0400
Date: Thu, 23 Sep 2021 20:48:16 +0300
Message-Id: <834kabuqsf.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Achim Gratz <Stromeko@HIDDEN>
In-Reply-To: <87h7ebrylf.fsf@HIDDEN> (message from Achim Gratz on Thu, 
 23 Sep 2021 19:27:56 +0200)
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN>
 <835yux5dn1.fsf@HIDDEN> <87bl4pf3s1.fsf@HIDDEN>
 <83tuih3uvr.fsf@HIDDEN> <877dfcg5tu.fsf@HIDDEN>
 <83pmt44vn1.fsf@HIDDEN>
 <eae87657-d5b5-2265-9b89-4626467a4ac5@HIDDEN>
 <83mto84r9l.fsf@HIDDEN>
 <fbe7b320-c720-50ad-aa18-a74443d2b070@HIDDEN>
 <83fsu04mai.fsf@HIDDEN>
 <1a5e01a2-2247-2f68-82f6-2075577e02b6@HIDDEN>
 <837dfc4hi1.fsf@HIDDEN>
 <4ae8067f-55b2-d243-66f3-f76493095a39@HIDDEN>
 <83o88jvity.fsf@HIDDEN>
 <8e8e74ce-0deb-bcdc-d298-be2e9d4636d7@HIDDEN>
 <83bl4juu2c.fsf@HIDDEN> <87h7ebrylf.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 50666
Cc: 50666 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Achim Gratz <Stromeko@HIDDEN>
> Date: Thu, 23 Sep 2021 19:27:56 +0200
> 
> Eli Zaretskii writes:
> > What do you mean by "system libraries" here?  Does it, for example,
> > include the DLLs distributed in the Cygwin port of libpng or libjpeg?
> > Or does that include only the basic libraries: the Cygwin DLL, the C
> > runtime, etc.?
> 
> Any and all dynamic objects that have been properly installed by the
> Cygwin setup application will have their base addresses adjusted so that
> there will be no overlapping images.  The rebase process tries to keep
> this space reasonably compact, if you really need to have the most
> compact address space you can trigger a full rebase.

Out of curiosity, what do you do with the myriad DLLs that Windows
itself provides?  Aren't they part of the same problem with the Cygwin
implementation of 'fork'?

> >    window-0d1b8b93-3370bedb.eln
> >    window-0d1b8b93-7d08b7b4.eln
> >    window-0d1b8b93-f8fc9683.eln
> >
> > This makes the job of maintaining the database by hand even harder and
> > more error-prone.
> 
> I have been wondering about that, especially since the user might have
> the same home directory on different machines.  That will be a major
> headache since we'll either need to find out which object belongs to
> which system (and have separate maps for each) or somehow ensure that
> the user rebase map is compatible with all systems the user works on.
> Skipping that part for now, all such objects must be the same
> architecture (i686-pc-cygwin / x86_64-pc-cygwin) and there should be
> some sort of architecture specific branches in the cache directory,
> which I seem to remember was already the case.

No, there are no architecture-specific branches.  I guess the idea is
that the 2 hashes in the file name and the 3rd has in the directory
name (which depends on the Emacs binary) will take care of that.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at 50666 <at> debbugs.gnu.org:


Received: (at 50666) by debbugs.gnu.org; 23 Sep 2021 17:29:39 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Sep 23 13:29:39 2021
Received: from localhost ([127.0.0.1]:55779 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mTSXS-0008Le-PG
	for submit <at> debbugs.gnu.org; Thu, 23 Sep 2021 13:29:39 -0400
Received: from eggs.gnu.org ([209.51.188.92]:57798)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1mTSXN-0008LM-Oe
 for 50666 <at> debbugs.gnu.org; Thu, 23 Sep 2021 13:29:37 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:53222)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1mTSXH-00043T-0V; Thu, 23 Sep 2021 13:29:27 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:2527
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1mTSXG-0001YC-KK; Thu, 23 Sep 2021 13:29:26 -0400
Date: Thu, 23 Sep 2021 20:29:20 +0300
Message-Id: <837df7urnz.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Ken Brown <kbrown@HIDDEN>
In-Reply-To: <a4c6b589-dc73-9553-a7a3-271f4aca0aaa@HIDDEN> (message from
 Ken Brown on Thu, 23 Sep 2021 13:13:05 -0400)
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN> <835yux5dn1.fsf@HIDDEN>
 <87bl4pf3s1.fsf@HIDDEN> <83tuih3uvr.fsf@HIDDEN>
 <877dfcg5tu.fsf@HIDDEN> <83pmt44vn1.fsf@HIDDEN>
 <eae87657-d5b5-2265-9b89-4626467a4ac5@HIDDEN> <83mto84r9l.fsf@HIDDEN>
 <fbe7b320-c720-50ad-aa18-a74443d2b070@HIDDEN> <83fsu04mai.fsf@HIDDEN>
 <1a5e01a2-2247-2f68-82f6-2075577e02b6@HIDDEN> <837dfc4hi1.fsf@HIDDEN>
 <4ae8067f-55b2-d243-66f3-f76493095a39@HIDDEN> <83o88jvity.fsf@HIDDEN>
 <8e8e74ce-0deb-bcdc-d298-be2e9d4636d7@HIDDEN> <83bl4juu2c.fsf@HIDDEN>
 <a4c6b589-dc73-9553-a7a3-271f4aca0aaa@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 50666
Cc: Stromeko@HIDDEN, 50666 <at> debbugs.gnu.org, akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Cc: akrl@HIDDEN, Stromeko@HIDDEN, 50666 <at> debbugs.gnu.org
> From: Ken Brown <kbrown@HIDDEN>
> Date: Thu, 23 Sep 2021 13:13:05 -0400
> 
> > My point is that maybe we should make that decision already, before
> > burning too much time and energy on it.
> 
> You might be right.  I wasn't aware of all the complications you mentioned above.

It took us most of the last year to realize how tricky this stuff is.
We are still learning ;-)

> We still need to do something for 64-bit Cygwin.  Even though address collisions 
> are unlikely they could still happen theoretically.  But there might be a much 
> easier solution that doesn't necessarily require rebasing.  For example, Achim 
> mentioned earlier the possibility of marking the eln as ASLR w/ high-entropy and
> large address aware.

Isn't that the default of the 64-bit GNU ld on Windows?  Or does
Cygwin configure Binutils differently from MinGW?

If not, we can use native-comp-driver-options, by giving it a non-nil
value for Cygwin, to force this.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 23 Sep 2021 17:28:12 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Sep 23 13:28:12 2021
Received: from localhost ([127.0.0.1]:55775 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mTSW4-0008JP-9G
	for submit <at> debbugs.gnu.org; Thu, 23 Sep 2021 13:28:12 -0400
Received: from lists.gnu.org ([209.51.188.17]:57090)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1mTSW2-0008JH-M8
 for submit <at> debbugs.gnu.org; Thu, 23 Sep 2021 13:28:11 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:46324)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1mTSW2-0000ls-C8
 for bug-gnu-emacs@HIDDEN; Thu, 23 Sep 2021 13:28:10 -0400
Received: from ciao.gmane.io ([116.202.254.214]:49802)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1mTSVz-0002n7-UQ
 for bug-gnu-emacs@HIDDEN; Thu, 23 Sep 2021 13:28:10 -0400
Received: from list by ciao.gmane.io with local (Exim 4.92)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1mTSVv-0001w9-PJ
 for bug-gnu-emacs@HIDDEN; Thu, 23 Sep 2021 19:28:03 +0200
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Achim Gratz <Stromeko@HIDDEN>
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
Date: Thu, 23 Sep 2021 19:27:56 +0200
Organization: Linux Private Site
Message-ID: <87h7ebrylf.fsf@HIDDEN>
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN>
 <835yux5dn1.fsf@HIDDEN> <87bl4pf3s1.fsf@HIDDEN>
 <83tuih3uvr.fsf@HIDDEN> <877dfcg5tu.fsf@HIDDEN>
 <83pmt44vn1.fsf@HIDDEN>
 <eae87657-d5b5-2265-9b89-4626467a4ac5@HIDDEN>
 <83mto84r9l.fsf@HIDDEN>
 <fbe7b320-c720-50ad-aa18-a74443d2b070@HIDDEN>
 <83fsu04mai.fsf@HIDDEN>
 <1a5e01a2-2247-2f68-82f6-2075577e02b6@HIDDEN>
 <837dfc4hi1.fsf@HIDDEN>
 <4ae8067f-55b2-d243-66f3-f76493095a39@HIDDEN>
 <83o88jvity.fsf@HIDDEN>
 <8e8e74ce-0deb-bcdc-d298-be2e9d4636d7@HIDDEN>
 <83bl4juu2c.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.2 (gnu/linux)
Cancel-Lock: sha1:HNDP0u+5F5Hct0M1JrQIkw6utSI=
Received-SPF: pass client-ip=116.202.254.214;
 envelope-from=geb-bug-gnu-emacs@HIDDEN; helo=ciao.gmane.io
X-Spam_score_int: -16
X-Spam_score: -1.7
X-Spam_bar: -
X-Spam_report: (-1.7 / 5.0 requ) BAYES_00=-1.9,
 HEADER_FROM_DIFFERENT_DOMAINS=0.248, SPF_HELO_NONE=0.001,
 SPF_PASS=-0.001 autolearn=no autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.1 (-)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.1 (--)

Eli Zaretskii writes:
> What do you mean by "system libraries" here?  Does it, for example,
> include the DLLs distributed in the Cygwin port of libpng or libjpeg?
> Or does that include only the basic libraries: the Cygwin DLL, the C
> runtime, etc.?

Any and all dynamic objects that have been properly installed by the
Cygwin setup application will have their base addresses adjusted so that
there will be no overlapping images.  The rebase process tries to keep
this space reasonably compact, if you really need to have the most
compact address space you can trigger a full rebase.

> If the only problem is with non-preloaded *.eln files, why not rebase
> them on the fly, when they are loaded.  That is, run the 'rebase'
> command from the native-elisp-load function, before it actually loads
> the file.  User libraries are never loaded during startup, only when
> some Lisp requires them.

That might work.

>> ...but it wouldn't eliminate the need for rebasing at each start for the reasons 
>> explained above.
>
> Perhaps that need could be eliminated after all, see above.

The rebase would just happen at a different time, but I think it should
be OK.

> That's tough on users, because Emacs by default automatically compiles
> every .el file it loads into .eln, if there's no up-to-date .eln file
> already, and the compilation runs in the background (by forking
> additional Emacs sub-processes that run in batch mode).  In addition,
> the native-compilation process sometimes decides that it needs to
> create a special "trampoline" .eln file (if you want to know why, I'm
> sure Andrea can explain) that correspond to parts of the *.el files.
> The upshot is that users may not even be aware that new *.eln files
> have been created as part of their session, and may not know their
> names.  Unless the automatic rebase process, which runs from
> native-elisp-load, will also update the file in dynpath.d, I don't see
> how users could maintain such a database by hand in practice.

That's why Ken wants to ensure that the rebase is done directly after
the creation of such files.  We still need to rebase them again when the
system address map changes.

> There's one more aspect that you should be aware of.  A single file
> FOO.el could give birth to several different .eln files, for example
> if they are compiled by different Emacs binaries and/or from different
> source directories and/or from somewhat different versions of FOO.el.
> For example, I now have 3 different versions of .eln files
> corresponding to window.el, in the same directory:
>
>    window-0d1b8b93-3370bedb.eln
>    window-0d1b8b93-7d08b7b4.eln
>    window-0d1b8b93-f8fc9683.eln
>
> This makes the job of maintaining the database by hand even harder and
> more error-prone.

I have been wondering about that, especially since the user might have
the same home directory on different machines.  That will be a major
headache since we'll either need to find out which object belongs to
which system (and have separate maps for each) or somehow ensure that
the user rebase map is compatible with all systems the user works on.
Skipping that part for now, all such objects must be the same
architecture (i686-pc-cygwin / x86_64-pc-cygwin) and there should be
some sort of architecture specific branches in the cache directory,
which I seem to remember was already the case.  Rebasing would then just
treat every file in the current architecture branch as a separate object
(and use up address space for each).  Aside from the unfortunate
proliferation of objects files (which each use up space in 64kByte
blocks) it should still work however as long as there is never an object
with the same name but different content.  Trying to figure out which of
these can actually be used in the same process would be too much and
mostly wasted effort I'd think.

> My point is that maybe we should make that decision already, before
> burning too much time and energy on it.  Maybe you should ask on the
> Cygwin list whether somebody will object to making 32-bit Cygwin Emacs
> a second-class citizen.

We have not yet seen how well (or not) it works in practise, so I would
not make that call today.  Besides, there really is no way of knowing
ahead of time what users actually do and I would not like to take that
option away when just a small subset of users would run into trouble.


Regards,
Achim.
-- 
+<[Q+ Matrix-12 WAVE#46+305 Neuron microQkb Andromeda XTk Blofeld]>+

Wavetables for the Waldorf Blofeld:
http://Synth.Stromeko.net/Downloads.html#BlofeldUserWavetables





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at 50666 <at> debbugs.gnu.org:


Received: (at 50666) by debbugs.gnu.org; 23 Sep 2021 17:13:16 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Sep 23 13:13:16 2021
Received: from localhost ([127.0.0.1]:55760 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mTSHb-0007tq-TG
	for submit <at> debbugs.gnu.org; Thu, 23 Sep 2021 13:13:16 -0400
Received: from mail-bn7nam10on2131.outbound.protection.outlook.com
 ([40.107.92.131]:15247 helo=NAM10-BN7-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <kbrown@HIDDEN>) id 1mTSHa-0007tc-5t
 for 50666 <at> debbugs.gnu.org; Thu, 23 Sep 2021 13:13:14 -0400
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=Vo6/y1XtwdgSHKo/t+4YxtWanHtR/wT7iaA2VPq7ihzAYVmo6AERu2dIbUPP7rEng6brB76/9rdhj/lxnddMEuZaFXpEShslsGwEIBBveMa0FLkPZ72pc/bb6jHez51XJQeQGWWq0D6LLIAMugD1V8HS3WzqifcOpfrSR485OXKX1RAtuztMGCN/BZL1Ny6BAlosuwjPffyP3Sd6+2C7b2ixlehTCgCUM4Fd6s9XvtyUNT4+GjTYN92tQHgPz/08N2hQErcLo1piYeIHfg6RRA2mQWL9RSYo3uN0mwoY6cWcvJDpk+TXqfLy0eclILZRvF9aqSwsafAuy0Lca4q+GA==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version; 
 bh=36YSoJ6jPb3pQo6E+NuZoMJD/R747GyaTsw2qUg00nA=;
 b=chuUmG7IDsNT0xWY1C3fZUK2nxEpkyx2aIUql8x3ih2BFuRgxLP8ATYyR/1Xgjb5gYUsvTT/1BTNu0OP5Foc6SB4sChd2osPax2J6xkaWOgE7ykHIdV92UiISYVVOzO3AiAvOzvaW0o066kvm5KrzJFcJ2vEathBITocycY4E6je5QZrRwIDWMjSACqKsPh7gUcvLQAWFJ4noIUyTJ0S3e+h4A0fld2XBXStCocE+D/F5SDZOkW3gMh2jCgkS7NntgVGXJ2TEJz63ugtuMxnk2iG8HnQLCqs45nD0AN+IsL+N3cl20hDo7zDDgUJuR7bRbn4oXCySTjUfAUJbLWJvA==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=pass
 smtp.mailfrom=cornell.edu; dmarc=pass action=none header.from=cornell.edu;
 dkim=pass header.d=cornell.edu; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=cornell.edu;
 s=selector2;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=36YSoJ6jPb3pQo6E+NuZoMJD/R747GyaTsw2qUg00nA=;
 b=RsxlR0HwEDjwbgY9W61YNt5cTKDreJ6ceajXbfp5wKj8RuNIBC5fr3g0ztkEdLJoBSpvlCO9QJxUo30UQJiUhAe1LesTuMhyp+hUpo7InWhnnL9gp3Gd4Tfdjt1UBHmqzVTCY695BPrkXuxedIuSVpPvjqaUA5m3YHrHOgluUxk=
Authentication-Results: debbugs.gnu.org; dkim=none (message not signed)
 header.d=none;debbugs.gnu.org; dmarc=none action=none
 header.from=cornell.edu;
Received: from BN7PR04MB4388.namprd04.prod.outlook.com (2603:10b6:406:f8::19)
 by BN6PR04MB0354.namprd04.prod.outlook.com (2603:10b6:404:99::21)
 with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.4544.13; Thu, 23 Sep
 2021 17:13:07 +0000
Received: from BN7PR04MB4388.namprd04.prod.outlook.com
 ([fe80::5113:e84a:b38a:7a66]) by BN7PR04MB4388.namprd04.prod.outlook.com
 ([fe80::5113:e84a:b38a:7a66%6]) with mapi id 15.20.4523.022; Thu, 23 Sep 2021
 17:13:06 +0000
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
To: Eli Zaretskii <eliz@HIDDEN>
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN> <835yux5dn1.fsf@HIDDEN>
 <87bl4pf3s1.fsf@HIDDEN> <83tuih3uvr.fsf@HIDDEN>
 <877dfcg5tu.fsf@HIDDEN> <83pmt44vn1.fsf@HIDDEN>
 <eae87657-d5b5-2265-9b89-4626467a4ac5@HIDDEN> <83mto84r9l.fsf@HIDDEN>
 <fbe7b320-c720-50ad-aa18-a74443d2b070@HIDDEN> <83fsu04mai.fsf@HIDDEN>
 <1a5e01a2-2247-2f68-82f6-2075577e02b6@HIDDEN> <837dfc4hi1.fsf@HIDDEN>
 <4ae8067f-55b2-d243-66f3-f76493095a39@HIDDEN> <83o88jvity.fsf@HIDDEN>
 <8e8e74ce-0deb-bcdc-d298-be2e9d4636d7@HIDDEN> <83bl4juu2c.fsf@HIDDEN>
From: Ken Brown <kbrown@HIDDEN>
Message-ID: <a4c6b589-dc73-9553-a7a3-271f4aca0aaa@HIDDEN>
Date: Thu, 23 Sep 2021 13:13:05 -0400
User-Agent: Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:78.0) Gecko/20100101
 Thunderbird/78.14.0
In-Reply-To: <83bl4juu2c.fsf@HIDDEN>
Content-Type: text/plain; charset=windows-1252; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-ClientProxiedBy: CH2PR11CA0029.namprd11.prod.outlook.com
 (2603:10b6:610:54::39) To BN7PR04MB4388.namprd04.prod.outlook.com
 (2603:10b6:406:f8::19)
MIME-Version: 1.0
Received: from [IPv6:2603:7081:7e3f:3419:8038:2245:c6fc:6fdc]
 (2603:7081:7e3f:3419:8038:2245:c6fc:6fdc) by
 CH2PR11CA0029.namprd11.prod.outlook.com (2603:10b6:610:54::39) with Microsoft
 SMTP Server (version=TLS1_2, cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id
 15.20.4544.15 via Frontend Transport; Thu, 23 Sep 2021 17:13:06 +0000
X-MS-PublicTrafficType: Email
X-MS-Office365-Filtering-Correlation-Id: b952a529-1f4e-4de3-7594-08d97eb56903
X-MS-TrafficTypeDiagnostic: BN6PR04MB0354:
X-Microsoft-Antispam-PRVS: <BN6PR04MB0354112D3E4207BDFC05E04CD8A39@HIDDEN>
X-MS-Oob-TLC-OOBClassifiers: OLM:10000;
X-MS-Exchange-SenderADCheck: 1
X-MS-Exchange-AntiSpam-Relay: 0
X-Microsoft-Antispam: BCL:0;
X-Microsoft-Antispam-Message-Info: S7l1VB99f+HHDX4Dm3krk2ATue6WNNjUCjjRTMxH+bgPBVSNm1mWENbMeE0WVEf0asiARdtzmQ7wrlTMdIe05pXN7zwGz3WGA5ejVX1mDp6QyWES6sWzlNA/1lyEbvTaWJDLwlWFtB7BjrhGVtwz69ioHzxoo4q/hFFKjuLtoU8JXtIIRRMM2iByLM9zI3vc6u8k8F8Fp4pORLvKbnLlVdOGPOptuguw3Nyca50XnDunj0znHEIBEL+4I+TY/NFJU3jVivtUvFYpapqpQ36Vay9iW/pjwbePWUw1vqpxIsZC2LgSOgFiiwYVX5VkPHm+Ny0lzFyrus8eHXgJgrLmprzMgfjEH+gYIw5agPiDm7Up02kr7eHNOiG3nhMnhm1lUR32nY5XXa45iUzYR4dWBAVD6vLvkdcWCi+MJfAJsLI7nGiBBQ7LZ94yit25kQwy6Hk4wNLIMVm/FEsnX7ICVjzn25e3/AMvFvztUBXT0ng2GMYx8LNhcBPMaB7///LUkPbESoZWEqlsrROJQRXGjmIdSuXFrq71PzyZiwsHJZVIy2WGGFf9aEgVBtJvPOyeCA9I6sDvxu2CzoAyz1tyTq+OJOPhaEEcAXAckiCpBb7UEeNu888sYgaZfK2UtvF5Uwsi/aPcFJGA016FyBKR0fifuUEnJQPtHsnFpMA/tgZ80xl2eF4ebpo6dZ1Pdx4+AwONkmvDYACYTLN2lflaBsYvHudPjtUhouGeQG9/o/3v8t85AjJWuvTpilQZB6ChDExm8aL3P766AOcRN0Qy7uEKHH+ihV5TaIAcWsGteRZyOiwlgQ3M+vP4AnqPkQBX
X-Forefront-Antispam-Report: CIP:255.255.255.255; CTRY:; LANG:en; SCL:1; SRV:;
 IPV:NLI; SFV:NSPM; H:BN7PR04MB4388.namprd04.prod.outlook.com; PTR:; CAT:NONE;
 SFS:(4636009)(366004)(5660300002)(2616005)(31696002)(38100700002)(36756003)(83380400001)(4326008)(86362001)(316002)(508600001)(66946007)(66476007)(66556008)(2906002)(186003)(6486002)(75432002)(966005)(53546011)(31686004)(6916009)(8936002)(8676002)(45980500001)(43740500002);
 DIR:OUT; SFP:1102; 
X-MS-Exchange-AntiSpam-MessageData-ChunkCount: 1
X-MS-Exchange-AntiSpam-MessageData-0: =?Windows-1252?Q?Zt5+1HJurtd8oV4Gtz9rTvLg/NUGhiMTvsjG7BiJF3XlwacLWAuQ6q7k?=
 =?Windows-1252?Q?INmMK4K4kFNhElLtXYhxHl7gedyY5v+wdX5aHMDa8AU8+n2EH+DJFqmC?=
 =?Windows-1252?Q?tgF9h/e2/EefaWO7kWQVLb9seNZGOwD4ca9ybQIkJQD/3krLd02VZV9K?=
 =?Windows-1252?Q?3M09MbyznRCBRyVuSUi2fJXb74raEOYM7eenX5LRfmRHhA625HTEiOhw?=
 =?Windows-1252?Q?nd+g71pDx/DzhNo3GjGajJ0j8vuizzgfhMvmLbvXmB2oBd+ebc/Ym7+Q?=
 =?Windows-1252?Q?L7MUHy3ysBr9wQj1LFm5PRj8HyI4c7O/PYI5oHhNKtC3MeOa7K6c24MX?=
 =?Windows-1252?Q?SWsyjCDX68m7Z3bfsqySRxI5hUzcXqjvkoE/5d7gpoeVtytCuZncmz9v?=
 =?Windows-1252?Q?zQDPSzC8xtat/ICh7gYYwUpPtWCHA+srA4lKPORilp+kAegn2z9r5ilG?=
 =?Windows-1252?Q?foSgpiwcc7/1L8TgR2NsrF1sAvhNOFLTg8+dtmWu6e9h0GflHV4SGTki?=
 =?Windows-1252?Q?Ls6hkULPeZGITeDEf+zAGczXPC+IIL0FlHl223Np9ZIDsjfwDV1uYg5w?=
 =?Windows-1252?Q?Ijq7rO4cf+hAIrK2RzEO4uLuBLxyi4O6R6elCLk1VSESGR6vzI4o+UxA?=
 =?Windows-1252?Q?2cmn4rlKKVWfqnLtTuhHVufOLyEGe+1Hx3WTkUivvMpVI08uJrM589KK?=
 =?Windows-1252?Q?TNqbwM3hBoj6jPN7W/f1ofsOoRC9gTISxMz4DtgMXtv+f3nN3szlliyQ?=
 =?Windows-1252?Q?/Cpkh1btrO5uGf1X6eDmgbmEhjZQlIXfh44N/iHQUBVrvzYh7yBZSILx?=
 =?Windows-1252?Q?H7QS5qLlEBEXH1P/khXzFyu4GXnabUvUklOq3LOxWcNLhptPrWYn9Lrz?=
 =?Windows-1252?Q?FL9Ipe/o4MIL1mMnUWnIpRe+qwx5roPnX3vaoSY8SpBIg0fdYozQJLgE?=
 =?Windows-1252?Q?2IY0Uk5x29XMd9yg2E6JFmPbzZZaNWP0wpId4Wsro9IevWcWXXShajNP?=
 =?Windows-1252?Q?iWgsIr2socLcsA9xjFAGnlqz6hyWM2qfWXm6hjKQx8NUmpLtiQms9HzT?=
 =?Windows-1252?Q?C723SyCPGY4ATHtbqlBWmltW4/3lcHrKBS2jyAyKY86rSBrbHYWDYDGe?=
 =?Windows-1252?Q?eONb12cUN6XLcrdF721JH7r8lYWZ/w+sGXE7n8DHKSRX1u1UxJIhwVH1?=
 =?Windows-1252?Q?YzJztQdG5HxKzEJWef9+az4lPAkUCWf1Rt+BZ4GmKIqJ8ZYfHkBv0S/1?=
 =?Windows-1252?Q?6zq7MpbFShp0f78LCySJAZp/0/s885V2o78OJbTKumEz9JYiQD9dIZB+?=
 =?Windows-1252?Q?ZimB52ZohFInbZZrooqTOokae58pQS7GKQJA/AzPpy1UFi8prcT/QkwK?=
 =?Windows-1252?Q?nPEdpnUVBKGLPIdV9hvBWBnIUeFzVRt5qfoNK8PXqWHiDzkftkQW2D/U?=
 =?Windows-1252?Q?BLcv6d4Bj+GuWWjuNhJji+49LZzdVORoAkLgqKlOB/mA5L0bHs/ed7t8?=
 =?Windows-1252?Q?4/TJZtcLcQCGZSLEzbFQFK9LdXKZqA=3D=3D?=
X-OriginatorOrg: cornell.edu
X-MS-Exchange-CrossTenant-Network-Message-Id: b952a529-1f4e-4de3-7594-08d97eb56903
X-MS-Exchange-CrossTenant-AuthSource: BN7PR04MB4388.namprd04.prod.outlook.com
X-MS-Exchange-CrossTenant-AuthAs: Internal
X-MS-Exchange-CrossTenant-OriginalArrivalTime: 23 Sep 2021 17:13:06.6939 (UTC)
X-MS-Exchange-CrossTenant-FromEntityHeader: Hosted
X-MS-Exchange-CrossTenant-Id: 5d7e4366-1b9b-45cf-8e79-b14b27df46e1
X-MS-Exchange-CrossTenant-MailboxType: HOSTED
X-MS-Exchange-CrossTenant-UserPrincipalName: AbFCOg97gc4Mu44pItYRk9re1uQhOBHJd25XBc4Rkbclp228AQ14KRy8sRuYF+Ca97rN+wh/V6o//0/XCzv/mg==
X-MS-Exchange-Transport-CrossTenantHeadersStamped: BN6PR04MB0354
X-Spam-Score: -0.1 (/)
X-Debbugs-Envelope-To: 50666
Cc: Stromeko@HIDDEN, 50666 <at> debbugs.gnu.org, akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.1 (-)

On 9/23/2021 12:37 PM, Eli Zaretskii wrote:
>> Cc: Stromeko@HIDDEN, 50666 <at> debbugs.gnu.org
>> From: Ken Brown <kbrown@HIDDEN>
>> Date: Thu, 23 Sep 2021 10:20:19 -0400
>>
>>> Is it really necessary to rebase the *.eln files before each startup?
>>> Isn't it enough to rebase each of the .eln files just once, when it is
>>> produced?  If indeed this is needed every time, can you explain why?
>>
>> We have to distinguish between system libraries and user libraries.  Libraries
>> installed by Cygwin packages are system libraries.  The *.eln files in
>> ~/.emacs.d/eln-cache are user libraries.  Cygwin maintains a database of all
>> system libraries and their base addresses.  Whenever a Cygwin package is
>> installed or updated, Cygwin rebases all system libraries and updates the database.
>>
>> Each time Emacs starts, it has no way of knowing whether the system libraries
>> have been rebased since the last time Emacs was run.  So the user's *.eln files
>> could now have base address conflicts with system libraries.  Rebasing the *.eln
>> files fixes this problem.
> 
> What do you mean by "system libraries" here?  Does it, for example,
> include the DLLs distributed in the Cygwin port of libpng or libjpeg?

Yes.

> Or does that include only the basic libraries: the Cygwin DLL, the C
> runtime, etc.? >
>>> The non-preloaded *.eln files are all loaded by native-elisp-load, so
>>> I guess the rebase should be launched from there?  The preloaded *.eln
>>> files are loaded in pdumper.c:dump_do_dump_relocation, but do we need
>>> to support non-rebased preloaded *.eln files?
>>
>> The preloaded *.eln files will be installed by Cygwin's package manager when
>> emacs is installed.  They are therefore system libraries and are automatically
>> rebased as needed.
> 
> If the only problem is with non-preloaded *.eln files, why not rebase
> them on the fly, when they are loaded.  That is, run the 'rebase'
> command from the native-elisp-load function, before it actually loads
> the file.  User libraries are never loaded during startup, only when
> some Lisp requires them.

Good idea.

>>> When an updated .eln file is produced for .eln that is loaded into
>>> some running Emacs, Emacs on Windows renames the original .eln to
>>> avoid a similar problem.
>>
>> I hadn't thought of this issue.  We may have to use a similar technique...
>>
>>> Can't you use the same technique, to avoid
>>> the need of rebasing on each start?
>>
>> ...but it wouldn't eliminate the need for rebasing at each start for the reasons
>> explained above.
> 
> Perhaps that need could be eliminated after all, see above.
> 
>>>   Please note that users could
>>> place *.eln files in unusual locations (and customize
>>> native-comp-eln-load-path to reflect that), so finding _all_ of the
>>> relevant *.eln files from a shell script might not be easy.  In fact,
>>> even without customizing the load-path, I don't think I understand how
>>> will that script you propose know where to find all the *.eln files.
>>
>> The current proposal that Achim and I are looking at would require each user to
>> maintain a file ~/.config/rebase/dynpath.d/emacs containing a list of
>> directories where the .eln files can be found.  By default, this file would
>> contain one line, which is the path to the standard eln-cache directory.  Users
>> who customize native-comp-eln-load-path would have to modify that file accordingly.
> 
> That's tough on users, because Emacs by default automatically compiles
> every .el file it loads into .eln, if there's no up-to-date .eln file
> already, and the compilation runs in the background (by forking
> additional Emacs sub-processes that run in batch mode).  In addition,
> the native-compilation process sometimes decides that it needs to
> create a special "trampoline" .eln file (if you want to know why, I'm
> sure Andrea can explain) that correspond to parts of the *.el files.
> The upshot is that users may not even be aware that new *.eln files
> have been created as part of their session, and may not know their
> names.  Unless the automatic rebase process, which runs from
> native-elisp-load, will also update the file in dynpath.d, I don't see
> how users could maintain such a database by hand in practice.
> 
> There's one more aspect that you should be aware of.  A single file
> FOO.el could give birth to several different .eln files, for example
> if they are compiled by different Emacs binaries and/or from different
> source directories and/or from somewhat different versions of FOO.el.
> For example, I now have 3 different versions of .eln files
> corresponding to window.el, in the same directory:
> 
>     window-0d1b8b93-3370bedb.eln
>     window-0d1b8b93-7d08b7b4.eln
>     window-0d1b8b93-f8fc9683.eln
> 
> This makes the job of maintaining the database by hand even harder and
> more error-prone.
> 
>> Finally, as a side note, I don't think it would be a tragedy if this just turns
>> out to be too complicated and we have to disable native compilation on 32-bit
>> Cygwin.  The Cygwin home page at https://cygwin.com/ already contains the following:
>>
>>     Address space is a very limiting factor for Cygwin. These days, a full
>>     32 bit Cygwin distro is not feasible anymore, and will in all likelihood
>>     fail in random places due to an issue with the fork(2) system call.
>>
>>     Therefore we recommend using 32 bit Cygwin only in limited scenarios, with
>>     only a minimum of necessary packages installed, and only if there's no way
>>     to run 64 bit Cygwin instead.
> 
> My point is that maybe we should make that decision already, before
> burning too much time and energy on it.

You might be right.  I wasn't aware of all the complications you mentioned above.

We still need to do something for 64-bit Cygwin.  Even though address collisions 
are unlikely they could still happen theoretically.  But there might be a much 
easier solution that doesn't necessarily require rebasing.  For example, Achim 
mentioned earlier the possibility of marking the eln as ASLR w/ high-entropy and
large address aware.

> Maybe you should ask on the
> Cygwin list whether somebody will object to making 32-bit Cygwin Emacs
> a second-class citizen.

Well, 32-bit Cygwin is already a second-class citizen, so we might just have to 
do that whether someone objects or not.  But I'll continue the discussion with 
Achim on the cygwin-apps list before making a final decision.

Thanks for all your comments and suggestions.

Ken




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at 50666 <at> debbugs.gnu.org:


Received: (at 50666) by debbugs.gnu.org; 23 Sep 2021 16:37:46 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Sep 23 12:37:46 2021
Received: from localhost ([127.0.0.1]:55689 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mTRjF-0006pO-Ex
	for submit <at> debbugs.gnu.org; Thu, 23 Sep 2021 12:37:45 -0400
Received: from eggs.gnu.org ([209.51.188.92]:46084)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1mTRjC-0006p4-OR
 for 50666 <at> debbugs.gnu.org; Thu, 23 Sep 2021 12:37:44 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:51794)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1mTRj3-0002fJ-R1; Thu, 23 Sep 2021 12:37:33 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:3291
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1mTRj3-0007hh-BG; Thu, 23 Sep 2021 12:37:33 -0400
Date: Thu, 23 Sep 2021 19:37:31 +0300
Message-Id: <83bl4juu2c.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Ken Brown <kbrown@HIDDEN>
In-Reply-To: <8e8e74ce-0deb-bcdc-d298-be2e9d4636d7@HIDDEN> (message from
 Ken Brown on Thu, 23 Sep 2021 10:20:19 -0400)
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN> <835yux5dn1.fsf@HIDDEN>
 <87bl4pf3s1.fsf@HIDDEN> <83tuih3uvr.fsf@HIDDEN>
 <877dfcg5tu.fsf@HIDDEN> <83pmt44vn1.fsf@HIDDEN>
 <eae87657-d5b5-2265-9b89-4626467a4ac5@HIDDEN> <83mto84r9l.fsf@HIDDEN>
 <fbe7b320-c720-50ad-aa18-a74443d2b070@HIDDEN> <83fsu04mai.fsf@HIDDEN>
 <1a5e01a2-2247-2f68-82f6-2075577e02b6@HIDDEN> <837dfc4hi1.fsf@HIDDEN>
 <4ae8067f-55b2-d243-66f3-f76493095a39@HIDDEN> <83o88jvity.fsf@HIDDEN>
 <8e8e74ce-0deb-bcdc-d298-be2e9d4636d7@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 50666
Cc: Stromeko@HIDDEN, 50666 <at> debbugs.gnu.org, akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Cc: Stromeko@HIDDEN, 50666 <at> debbugs.gnu.org
> From: Ken Brown <kbrown@HIDDEN>
> Date: Thu, 23 Sep 2021 10:20:19 -0400
> 
> > Is it really necessary to rebase the *.eln files before each startup?
> > Isn't it enough to rebase each of the .eln files just once, when it is
> > produced?  If indeed this is needed every time, can you explain why?
> 
> We have to distinguish between system libraries and user libraries.  Libraries 
> installed by Cygwin packages are system libraries.  The *.eln files in 
> ~/.emacs.d/eln-cache are user libraries.  Cygwin maintains a database of all 
> system libraries and their base addresses.  Whenever a Cygwin package is 
> installed or updated, Cygwin rebases all system libraries and updates the database.
> 
> Each time Emacs starts, it has no way of knowing whether the system libraries 
> have been rebased since the last time Emacs was run.  So the user's *.eln files 
> could now have base address conflicts with system libraries.  Rebasing the *.eln 
> files fixes this problem.

What do you mean by "system libraries" here?  Does it, for example,
include the DLLs distributed in the Cygwin port of libpng or libjpeg?
Or does that include only the basic libraries: the Cygwin DLL, the C
runtime, etc.?

> > The non-preloaded *.eln files are all loaded by native-elisp-load, so
> > I guess the rebase should be launched from there?  The preloaded *.eln
> > files are loaded in pdumper.c:dump_do_dump_relocation, but do we need
> > to support non-rebased preloaded *.eln files?
> 
> The preloaded *.eln files will be installed by Cygwin's package manager when 
> emacs is installed.  They are therefore system libraries and are automatically 
> rebased as needed.

If the only problem is with non-preloaded *.eln files, why not rebase
them on the fly, when they are loaded.  That is, run the 'rebase'
command from the native-elisp-load function, before it actually loads
the file.  User libraries are never loaded during startup, only when
some Lisp requires them.

> > When an updated .eln file is produced for .eln that is loaded into
> > some running Emacs, Emacs on Windows renames the original .eln to
> > avoid a similar problem.  
> 
> I hadn't thought of this issue.  We may have to use a similar technique...
> 
> > Can't you use the same technique, to avoid
> > the need of rebasing on each start?
> 
> ...but it wouldn't eliminate the need for rebasing at each start for the reasons 
> explained above.

Perhaps that need could be eliminated after all, see above.

> >  Please note that users could
> > place *.eln files in unusual locations (and customize
> > native-comp-eln-load-path to reflect that), so finding _all_ of the
> > relevant *.eln files from a shell script might not be easy.  In fact,
> > even without customizing the load-path, I don't think I understand how
> > will that script you propose know where to find all the *.eln files.
> 
> The current proposal that Achim and I are looking at would require each user to 
> maintain a file ~/.config/rebase/dynpath.d/emacs containing a list of 
> directories where the .eln files can be found.  By default, this file would 
> contain one line, which is the path to the standard eln-cache directory.  Users 
> who customize native-comp-eln-load-path would have to modify that file accordingly.

That's tough on users, because Emacs by default automatically compiles
every .el file it loads into .eln, if there's no up-to-date .eln file
already, and the compilation runs in the background (by forking
additional Emacs sub-processes that run in batch mode).  In addition,
the native-compilation process sometimes decides that it needs to
create a special "trampoline" .eln file (if you want to know why, I'm
sure Andrea can explain) that correspond to parts of the *.el files.
The upshot is that users may not even be aware that new *.eln files
have been created as part of their session, and may not know their
names.  Unless the automatic rebase process, which runs from
native-elisp-load, will also update the file in dynpath.d, I don't see
how users could maintain such a database by hand in practice.

There's one more aspect that you should be aware of.  A single file
FOO.el could give birth to several different .eln files, for example
if they are compiled by different Emacs binaries and/or from different
source directories and/or from somewhat different versions of FOO.el.
For example, I now have 3 different versions of .eln files
corresponding to window.el, in the same directory:

   window-0d1b8b93-3370bedb.eln
   window-0d1b8b93-7d08b7b4.eln
   window-0d1b8b93-f8fc9683.eln

This makes the job of maintaining the database by hand even harder and
more error-prone.

> Finally, as a side note, I don't think it would be a tragedy if this just turns 
> out to be too complicated and we have to disable native compilation on 32-bit 
> Cygwin.  The Cygwin home page at https://cygwin.com/ already contains the following:
> 
>    Address space is a very limiting factor for Cygwin. These days, a full
>    32 bit Cygwin distro is not feasible anymore, and will in all likelihood
>    fail in random places due to an issue with the fork(2) system call.
> 
>    Therefore we recommend using 32 bit Cygwin only in limited scenarios, with
>    only a minimum of necessary packages installed, and only if there's no way
>    to run 64 bit Cygwin instead.

My point is that maybe we should make that decision already, before
burning too much time and energy on it.  Maybe you should ask on the
Cygwin list whether somebody will object to making 32-bit Cygwin Emacs
a second-class citizen.

Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at 50666 <at> debbugs.gnu.org:


Received: (at 50666) by debbugs.gnu.org; 23 Sep 2021 14:20:38 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Sep 23 10:20:38 2021
Received: from localhost ([127.0.0.1]:55313 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mTPaX-0006jl-Lk
	for submit <at> debbugs.gnu.org; Thu, 23 Sep 2021 10:20:38 -0400
Received: from mail-sn1anam02on2100.outbound.protection.outlook.com
 ([40.107.96.100]:63559 helo=NAM02-SN1-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <kbrown@HIDDEN>) id 1mTPaS-0006jO-Mn
 for 50666 <at> debbugs.gnu.org; Thu, 23 Sep 2021 10:20:36 -0400
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=cYtDeqXz66iVKW4v+oWdoePFTR+KWG0hEMzo+A3jRZlidA3vLS3nyrw5Vj4DFFBpwvAHtMfv4h1JfD3n39BqcfB1aMIEM+wk2NmPuib+thVULpZb6L7Qz20srCxq5usapTGDfFQryw0GtYe7nuxBoUtCkiN9G9E3Ipe24UGd/Ea1a+b77wMp+Bf2u4uy+PJiSujM/VICYp5be0KhuGSSwnlrbJo27j9F7SkWog31kxsbelsqzf6Y6CKnT6kL1/XlAC5AD1gJkS8VbJX+pvHNkEKnJvoQY5+IUMndhjyMTalos30L5/YDKofJ5pXIzgq/rU2k/YspNNhm/NWWEyT0pQ==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version; 
 bh=4epyYpGxvGq3Wc3A0y9mOWhctXT08WzeZiXSLQLO/qg=;
 b=R0cKUgtKrpAoIw4x9MjHMh+MX4160aU9lKxFC3bs/rEEYCC1VkptZWm+7f7UjJVboClrmOy5wmKa5yQInpSthIZ7TJxUShHmCq9DsXuGyvnQ4PXCkRJIUzzOA5B5scXyE43SUYwmMEgrDvo9El4JG7SofkySRakV5tUzZY8rZI26SRSqRAa8s2NO+v2MsYI/tIrh7tigCrVF9PEjpVhdTqO07h5AZzUEqmPd3BglSGah9QbEDNIn8zRz/jkaYa28HE+k/JlrXA5W8lQ/cvNTogyE+K89PsIpECNJ94ydSfgEkQbultGODYhVb6fqUBUSObgaCd2Qenl6xUdqFcFFKQ==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=pass
 smtp.mailfrom=cornell.edu; dmarc=pass action=none header.from=cornell.edu;
 dkim=pass header.d=cornell.edu; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=cornell.edu;
 s=selector2;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=4epyYpGxvGq3Wc3A0y9mOWhctXT08WzeZiXSLQLO/qg=;
 b=IDn3Mud5AT1QdmcxmAgv3DnZkgHz5ILCmNC/6O36GLeBTKpe6kuG1cP+v+Xtieju7zw+G+Pb4xUOJDsH8s7QQJXjGIadFH2ZI38/XodOFZASYpA12mtddL+celwZN6X5RUunoBStasQIZnC3JjGB9FLPC2pJRhU5td83UK0tU2A=
Authentication-Results: debbugs.gnu.org; dkim=none (message not signed)
 header.d=none;debbugs.gnu.org; dmarc=none action=none
 header.from=cornell.edu;
Received: from BN7PR04MB4388.namprd04.prod.outlook.com (2603:10b6:406:f8::19)
 by BN8PR04MB5715.namprd04.prod.outlook.com (2603:10b6:408:74::32)
 with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.4544.13; Thu, 23 Sep
 2021 14:20:22 +0000
Received: from BN7PR04MB4388.namprd04.prod.outlook.com
 ([fe80::5113:e84a:b38a:7a66]) by BN7PR04MB4388.namprd04.prod.outlook.com
 ([fe80::5113:e84a:b38a:7a66%6]) with mapi id 15.20.4523.022; Thu, 23 Sep 2021
 14:20:21 +0000
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
To: Eli Zaretskii <eliz@HIDDEN>, Andrea Corallo <akrl@HIDDEN>
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN> <835yux5dn1.fsf@HIDDEN>
 <87bl4pf3s1.fsf@HIDDEN> <83tuih3uvr.fsf@HIDDEN>
 <877dfcg5tu.fsf@HIDDEN> <83pmt44vn1.fsf@HIDDEN>
 <eae87657-d5b5-2265-9b89-4626467a4ac5@HIDDEN> <83mto84r9l.fsf@HIDDEN>
 <fbe7b320-c720-50ad-aa18-a74443d2b070@HIDDEN> <83fsu04mai.fsf@HIDDEN>
 <1a5e01a2-2247-2f68-82f6-2075577e02b6@HIDDEN> <837dfc4hi1.fsf@HIDDEN>
 <4ae8067f-55b2-d243-66f3-f76493095a39@HIDDEN> <83o88jvity.fsf@HIDDEN>
From: Ken Brown <kbrown@HIDDEN>
Message-ID: <8e8e74ce-0deb-bcdc-d298-be2e9d4636d7@HIDDEN>
Date: Thu, 23 Sep 2021 10:20:19 -0400
User-Agent: Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:78.0) Gecko/20100101
 Thunderbird/78.14.0
In-Reply-To: <83o88jvity.fsf@HIDDEN>
Content-Type: text/plain; charset=windows-1252; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-ClientProxiedBy: CH0PR03CA0392.namprd03.prod.outlook.com
 (2603:10b6:610:11b::31) To BN7PR04MB4388.namprd04.prod.outlook.com
 (2603:10b6:406:f8::19)
MIME-Version: 1.0
Received: from [IPv6:2603:7081:7e3f:3419:8038:2245:c6fc:6fdc]
 (2603:7081:7e3f:3419:8038:2245:c6fc:6fdc) by
 CH0PR03CA0392.namprd03.prod.outlook.com (2603:10b6:610:11b::31) with
 Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.4544.15 via Frontend
 Transport; Thu, 23 Sep 2021 14:20:21 +0000
X-MS-PublicTrafficType: Email
X-MS-Office365-Filtering-Correlation-Id: fb0d26a9-0fa8-493b-e4e4-08d97e9d46ff
X-MS-TrafficTypeDiagnostic: BN8PR04MB5715:
X-Microsoft-Antispam-PRVS: <BN8PR04MB5715B29848817623A8E1AA9CD8A39@HIDDEN>
X-MS-Oob-TLC-OOBClassifiers: OLM:10000;
X-MS-Exchange-SenderADCheck: 1
X-MS-Exchange-AntiSpam-Relay: 0
X-Microsoft-Antispam: BCL:0;
X-Microsoft-Antispam-Message-Info: k0KYJxykEgPlR21W/po38N56jis5d/yvrWgFPqwE2pAS1c/AGCogUol8ZgcILJwozayMEVdP6Nhn5sqhIrq2Sp81j0kvVEufcpdGBj44jIvsF70HeLrI9/cU5sNGdd3o8YcxsRvxxOgkwrw2FzKr78eq9b0bjO1kqsXAKQIFu9RQ4842XFtS7Vav3XcsQLULIwgFFUcbgcgG5VQrXZA2qQoIULWXRthhyV/mXlEdGloNO/UYR8ZPOCkf0ErMTyTYKHHQeYhE5TobT5je2QZvoWuQH+fAB+FWgseWePibQmRy+pkkxBKRm4v2WgiRxFlWoPAzDp0WaT/GK8Ty0vfWGhMtH1NHiflZZgN+VyhIehRpHFauimP4OgMBMF+omrgEgPn8IsjtFOznf+JQERJ30AZSiwppK9cvd91lu3nu3MD3NBhUtn3VvfEBgyoUaHHdsDCeSX/J63LwhuP1XU91/h9sv+PsNJ1YyVoP6roCeMaa1evzIYL0hyr2EEa1+4MKaL8Xt1S2WHAT4bDPOEvdrQbDm4PwGb8rGZCIkV5gmuQmBs0dbNei+3/WUYfCfEHkB/+ym43HwbgqVT3XpFgc+AZI/5sIcy4cwzd5BjuWiAmWdC+5hYSydnq+3hZySXM/R63ZBhcOBKhqmzx8GjKyzWhUSPpKDVyWiPrsiuUDjjMCbM2zBSlmR662R394I0MSXUS9fRmFpOz8chjiUTQJ5a84jh8oCa00sd7rBN4P3WhM2p3bpH8VeZLz9s7lvfs9+2WbZQPMRPvimDrMxOmenaZ6pOyhh/VyXhMyxKzs9mhPwQbq3r6XGMoG1htWWd8w
X-Forefront-Antispam-Report: CIP:255.255.255.255; CTRY:; LANG:en; SCL:1; SRV:;
 IPV:NLI; SFV:NSPM; H:BN7PR04MB4388.namprd04.prod.outlook.com; PTR:; CAT:NONE;
 SFS:(4636009)(366004)(84040400005)(5660300002)(2616005)(31686004)(38100700002)(316002)(966005)(8676002)(66556008)(66476007)(508600001)(66946007)(53546011)(4326008)(31696002)(8936002)(110136005)(86362001)(2906002)(36756003)(75432002)(83380400001)(6486002)(186003)(45980500001)(43740500002);
 DIR:OUT; SFP:1102; 
X-MS-Exchange-AntiSpam-MessageData-ChunkCount: 1
X-MS-Exchange-AntiSpam-MessageData-0: =?Windows-1252?Q?B6XNwdXiaeVPylQON97BQbKg0xbAd8Xgcp4pxXiCahtNiWwmiXs6aL3p?=
 =?Windows-1252?Q?tPsWAnE35heGIgZl5rGJqYlaeb2GECJ7OcKSCVXwd18O/6C80Llw7/ae?=
 =?Windows-1252?Q?1xc3x0wcugh/PtXWeCMl/SGyQbfqkichhdpE4f7L/76POR4fleVjZ7af?=
 =?Windows-1252?Q?pEJ76fTa3/wdBExkOfK33QKBQQurii7oygE+oFCLPQwLB4lZ0fZKQHJn?=
 =?Windows-1252?Q?zRx5nmRfTSIFyjcg4KORaAnlKZAxd1bnNCnmuX8/o7hV31cEe4Ba/dcn?=
 =?Windows-1252?Q?Cp3dr9w/2N7HYRy7dItSxGANK+kUIvhUmSuA71N/StNtC/GWSFkhTR1r?=
 =?Windows-1252?Q?f4QyyClMKz5DgEwP7mfvNiAceas1PJNDCBEQ6hoY3Np2dt6jh2IiV8Ci?=
 =?Windows-1252?Q?tE/QLg7nOAhUEm7+M/pe5y0Ttj6NhB83MHI5jRm9C+icl6X3UA4rpofQ?=
 =?Windows-1252?Q?uHzCHn7Qm15MZfLADrKd7aewOdrnXwLSQp57qmaWPme/Sk2n5cO/PPaR?=
 =?Windows-1252?Q?HeQ+5FTUqYCPyH5YZlgDm2xK2VxwFwgvMzAinmxw+IKYvB47kqi91Lhs?=
 =?Windows-1252?Q?eXIYAm5dtF7Kyr1UUegsHsEnN9NqqZfT2I/xQeEIczWjyFN7vo/TyZOR?=
 =?Windows-1252?Q?6XnmI1LjPvSjmXDh0zsbNBxkTUOt4DT+0xPfOy8fG9HvXZMzd1gyValH?=
 =?Windows-1252?Q?CXYXYMATGb0MIvV0/mYrysqCRy+112fdMMa0oL2g0y5bFTRGggT9Tcmb?=
 =?Windows-1252?Q?R7Qseb+J8sbpkBL9aYMpNvi5Mx6Xgc7PV16yu8EbcIcxZNpCiboM4/Uz?=
 =?Windows-1252?Q?oAG9aipPJ/rYuvPWw0UtMScpmFfWem0f3h/Npb9uR+ATNfF/+nq8Bv/5?=
 =?Windows-1252?Q?OzJh9yIMf8kSCsbyFa3MFTYZgJS53LL1IVeFG4minDahulWXTBIBa+9p?=
 =?Windows-1252?Q?1KHkd28n0ZAVeN2zfBpsty87GT1axEd6WVJr+kiIKB6LVLpyb0s/nwhL?=
 =?Windows-1252?Q?qTxVGzoZE4jk6Tv9BgjTClf+n7kKMwgsN8nZ9thZkwScyYzpmu5la5br?=
 =?Windows-1252?Q?WHYqJEBmdnaPaKBKXllsAcgIrNTOU0bIqR1iJP0r6zqe91iA1PKrypBU?=
 =?Windows-1252?Q?TFMfy8tiMJphAgXPk7amcLS8RuVkiZmqWqGWsC4CwsnM4IO1UWiKxyDE?=
 =?Windows-1252?Q?XLJVrN0n1DxuQmEFzt0DadP7+bfQpffunyJTwM1TiWd7YBtcDWxZHkcR?=
 =?Windows-1252?Q?4ISw2jc+Lz5GHlvwvdsNFZEvSx3687MZilmYcUEgANUnUsTs3slQzaPV?=
 =?Windows-1252?Q?xD99RjeP0QnyxlstgazDPnQ/gXzU/2DHfC6HDuodk2iMzcnVtRDctfra?=
 =?Windows-1252?Q?x0+ByC7dWhrWqIFEtO+sz42582Kmov6ZhHM6uck0dqYbhMeLHIKmegnV?=
 =?Windows-1252?Q?6BbeDkRnk59k/mjCXM7fIMhrWYRztpOkiXODw0RaNFFUEo0xVbzSpnKa?=
 =?Windows-1252?Q?emK6yuKPeF2yv+bxmgDr4jrDYV4zgQ=3D=3D?=
X-OriginatorOrg: cornell.edu
X-MS-Exchange-CrossTenant-Network-Message-Id: fb0d26a9-0fa8-493b-e4e4-08d97e9d46ff
X-MS-Exchange-CrossTenant-AuthSource: BN7PR04MB4388.namprd04.prod.outlook.com
X-MS-Exchange-CrossTenant-AuthAs: Internal
X-MS-Exchange-CrossTenant-OriginalArrivalTime: 23 Sep 2021 14:20:21.8265 (UTC)
X-MS-Exchange-CrossTenant-FromEntityHeader: Hosted
X-MS-Exchange-CrossTenant-Id: 5d7e4366-1b9b-45cf-8e79-b14b27df46e1
X-MS-Exchange-CrossTenant-MailboxType: HOSTED
X-MS-Exchange-CrossTenant-UserPrincipalName: XCIQO6MYSWtEVDVM6KfxDXRQ+okpbke5uICCQvwAxJJT8KlIvn3de9ES9GLmpAvgBoq2e9nxlXJwETuDhoUI2A==
X-MS-Exchange-Transport-CrossTenantHeadersStamped: BN8PR04MB5715
X-Spam-Score: -0.1 (/)
X-Debbugs-Envelope-To: 50666
Cc: Stromeko@HIDDEN, 50666 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.1 (-)

On 9/23/2021 3:42 AM, Eli Zaretskii wrote:
>> Cc: Stromeko@HIDDEN, 50666 <at> debbugs.gnu.org
>> From: Ken Brown <kbrown@HIDDEN>
>> Date: Wed, 22 Sep 2021 17:35:28 -0400
>>
>> We've made a good start on the Cygwin side, but I have a question about how to
>> integrate it into Emacs.
> 
> I added Andrea to this discussion, as he knows more than anyone else
> about the Emacs side of this stuff.
> 
>> Let's say we have a script that I'll call "rebase" for the purpose of this
>> discussion, which rebases all the eln files in ~/.emacs.d/eln-cache.  The user
>> would then start Emacs via a script that first calls rebase and then starts
>> Emacs.
> 
> Is it really necessary to rebase the *.eln files before each startup?
> Isn't it enough to rebase each of the .eln files just once, when it is
> produced?  If indeed this is needed every time, can you explain why?

We have to distinguish between system libraries and user libraries.  Libraries 
installed by Cygwin packages are system libraries.  The *.eln files in 
~/.emacs.d/eln-cache are user libraries.  Cygwin maintains a database of all 
system libraries and their base addresses.  Whenever a Cygwin package is 
installed or updated, Cygwin rebases all system libraries and updates the database.

Each time Emacs starts, it has no way of knowing whether the system libraries 
have been rebased since the last time Emacs was run.  So the user's *.eln files 
could now have base address conflicts with system libraries.  Rebasing the *.eln 
files fixes this problem.

>> Within Emacs, I would then want to do something like
>>
>> (if (eq system-type 'cygwin)
>>       (call-process "rebase" nil
>>                     '(:file "<log file>")
>>                     nil "<arg>" ...))
>>
>> after every compilation but before the compiled file is loaded.
>>
>> I'm not familiar enough with native compilation to know where this should go.
> 
> The non-preloaded *.eln files are all loaded by native-elisp-load, so
> I guess the rebase should be launched from there?  The preloaded *.eln
> files are loaded in pdumper.c:dump_do_dump_relocation, but do we need
> to support non-rebased preloaded *.eln files?

The preloaded *.eln files will be installed by Cygwin's package manager when 
emacs is installed.  They are therefore system libraries and are automatically 
rebased as needed.

>> Can you help?
> 
> I hope the above helps.  But I think we should understand better all
> the aspects of this issue, to make sure it will work correctly in the
> wild.  The *.eln files bring quite a few new and unusual aspects and
> dependencies to Emacs, they are not just another kind of DLLs loaded
> dynamically.  So I'd appreciate if you explained:
> 
>    . why is rebasing needed (I think I understand that part, but I'd
>      prefer an explanation from the experts)

I'm not as expert as I'd like to be on the intricacies of Cygwin's fork 
implementation, but here's my best attempt.  Achim may want to correct it or add 
to it.

When Cygwin forks, it creates a new process and copies the memory image of the 
parent to the child.  But Cygwin uses the Windows loader to load DLLs, so it has 
to ensure that Windows will load all DLLs to the same addresses in the child at 
which they were loaded in the parent.

The problem occurs when there's an address collision, i.e., two DLLs have the 
same hard-wired base address.  Window then resolves the collision by loading one 
of them at a different address.  But there's no guarantee that it will resolve 
the collision in the child the same way it resolved it in the parent.  That 
leads to a fork failure.

Cygwin tries to head-off such problems before they occur by rebasing as I've 
described above at package-installation time.

>    . how will the 'rebase' utility determine to which address to remap
>      each .eln file

It simply chooses an address that doesn't conflict with any of the system 
libraries and the already-rebased user libraries.

>> P.S. The rebase script will fail to rebase eln files that are already loaded,
>> but that's harmless in the scenario above.
> 
> When an updated .eln file is produced for .eln that is loaded into
> some running Emacs, Emacs on Windows renames the original .eln to
> avoid a similar problem.  

I hadn't thought of this issue.  We may have to use a similar technique...

> Can't you use the same technique, to avoid
> the need of rebasing on each start?

...but it wouldn't eliminate the need for rebasing at each start for the reasons 
explained above.

>  Please note that users could
> place *.eln files in unusual locations (and customize
> native-comp-eln-load-path to reflect that), so finding _all_ of the
> relevant *.eln files from a shell script might not be easy.  In fact,
> even without customizing the load-path, I don't think I understand how
> will that script you propose know where to find all the *.eln files.

The current proposal that Achim and I are looking at would require each user to 
maintain a file ~/.config/rebase/dynpath.d/emacs containing a list of 
directories where the .eln files can be found.  By default, this file would 
contain one line, which is the path to the standard eln-cache directory.  Users 
who customize native-comp-eln-load-path would have to modify that file accordingly.

For example, I currently have a second line pointing to the native-lisp 
directory of my emacs build directory, so that I can do testing of my built 
emacs without having to install it.

Finally, as a side note, I don't think it would be a tragedy if this just turns 
out to be too complicated and we have to disable native compilation on 32-bit 
Cygwin.  The Cygwin home page at https://cygwin.com/ already contains the following:

   Address space is a very limiting factor for Cygwin. These days, a full
   32 bit Cygwin distro is not feasible anymore, and will in all likelihood
   fail in random places due to an issue with the fork(2) system call.

   Therefore we recommend using 32 bit Cygwin only in limited scenarios, with
   only a minimum of necessary packages installed, and only if there's no way
   to run 64 bit Cygwin instead.

Ken




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at 50666 <at> debbugs.gnu.org:


Received: (at 50666) by debbugs.gnu.org; 23 Sep 2021 07:42:47 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Sep 23 03:42:47 2021
Received: from localhost ([127.0.0.1]:52583 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mTJNX-00013e-7O
	for submit <at> debbugs.gnu.org; Thu, 23 Sep 2021 03:42:47 -0400
Received: from eggs.gnu.org ([209.51.188.92]:33584)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1mTJNT-00013N-Th
 for 50666 <at> debbugs.gnu.org; Thu, 23 Sep 2021 03:42:46 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:36090)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1mTJNM-00046Z-M0; Thu, 23 Sep 2021 03:42:36 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:2312
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1mTJNM-0004Gi-8D; Thu, 23 Sep 2021 03:42:36 -0400
Date: Thu, 23 Sep 2021 10:42:33 +0300
Message-Id: <83o88jvity.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Ken Brown <kbrown@HIDDEN>, Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <4ae8067f-55b2-d243-66f3-f76493095a39@HIDDEN> (message from
 Ken Brown on Wed, 22 Sep 2021 17:35:28 -0400)
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN> <835yux5dn1.fsf@HIDDEN>
 <87bl4pf3s1.fsf@HIDDEN> <83tuih3uvr.fsf@HIDDEN>
 <877dfcg5tu.fsf@HIDDEN> <83pmt44vn1.fsf@HIDDEN>
 <eae87657-d5b5-2265-9b89-4626467a4ac5@HIDDEN> <83mto84r9l.fsf@HIDDEN>
 <fbe7b320-c720-50ad-aa18-a74443d2b070@HIDDEN> <83fsu04mai.fsf@HIDDEN>
 <1a5e01a2-2247-2f68-82f6-2075577e02b6@HIDDEN> <837dfc4hi1.fsf@HIDDEN>
 <4ae8067f-55b2-d243-66f3-f76493095a39@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 50666
Cc: Stromeko@HIDDEN, 50666 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Cc: Stromeko@HIDDEN, 50666 <at> debbugs.gnu.org
> From: Ken Brown <kbrown@HIDDEN>
> Date: Wed, 22 Sep 2021 17:35:28 -0400
> 
> We've made a good start on the Cygwin side, but I have a question about how to 
> integrate it into Emacs.

I added Andrea to this discussion, as he knows more than anyone else
about the Emacs side of this stuff.

> Let's say we have a script that I'll call "rebase" for the purpose of this 
> discussion, which rebases all the eln files in ~/.emacs.d/eln-cache.  The user 
> would then start Emacs via a script that first calls rebase and then starts 
> Emacs.

Is it really necessary to rebase the *.eln files before each startup?
Isn't it enough to rebase each of the .eln files just once, when it is
produced?  If indeed this is needed every time, can you explain why?

> Within Emacs, I would then want to do something like
> 
> (if (eq system-type 'cygwin)
>      (call-process "rebase" nil
>                    '(:file "<log file>")
>                    nil "<arg>" ...))
> 
> after every compilation but before the compiled file is loaded.
> 
> I'm not familiar enough with native compilation to know where this should go. 

The non-preloaded *.eln files are all loaded by native-elisp-load, so
I guess the rebase should be launched from there?  The preloaded *.eln
files are loaded in pdumper.c:dump_do_dump_relocation, but do we need
to support non-rebased preloaded *.eln files?

> Or maybe it has to be done in more than one place, depending on whether the 
> compilation is synchronous or not.
> 
> Can you help?

I hope the above helps.  But I think we should understand better all
the aspects of this issue, to make sure it will work correctly in the
wild.  The *.eln files bring quite a few new and unusual aspects and
dependencies to Emacs, they are not just another kind of DLLs loaded
dynamically.  So I'd appreciate if you explained:

  . why is rebasing needed (I think I understand that part, but I'd
    prefer an explanation from the experts)
  . how will the 'rebase' utility determine to which address to remap
    each .eln file

> P.S. The rebase script will fail to rebase eln files that are already loaded, 
> but that's harmless in the scenario above.

When an updated .eln file is produced for .eln that is loaded into
some running Emacs, Emacs on Windows renames the original .eln to
avoid a similar problem.  Can't you use the same technique, to avoid
the need of rebasing on each start?  Please note that users could
place *.eln files in unusual locations (and customize
native-comp-eln-load-path to reflect that), so finding _all_ of the
relevant *.eln files from a shell script might not be easy.  In fact,
even without customizing the load-path, I don't think I understand how
will that script you propose know where to find all the *.eln files.

Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at 50666 <at> debbugs.gnu.org:


Received: (at 50666) by debbugs.gnu.org; 22 Sep 2021 21:35:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Sep 22 17:35:48 2021
Received: from localhost ([127.0.0.1]:51954 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mT9u8-0000cu-Fu
	for submit <at> debbugs.gnu.org; Wed, 22 Sep 2021 17:35:48 -0400
Received: from mail-mw2nam10on2115.outbound.protection.outlook.com
 ([40.107.94.115]:36704 helo=NAM10-MW2-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <kbrown@HIDDEN>) id 1mT9tx-0000cT-6I
 for 50666 <at> debbugs.gnu.org; Wed, 22 Sep 2021 17:35:47 -0400
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=fGz003oTs2ALzzhqQXlxdQ2rJYKktEmHChr7Sg/GUVYDO/pTgH9BBvYvleHdEa7OQ1r+p7MJ5Jvh/An19fcWcKO2HPEO/l0jI4Vq5EHD9ASSHPY9Ci2UPvMd2E/cD3jBv9y66fhqc7Nvm91VPnbNQkM+yWLGw+2o6ike1hnSqfLt/l4gbYdnAXBllAFtOZfsYCN3A9zrmS1uUNkv/VMm8caKB5roZaXI4L7/vxfjpKg9FF5P21sJaYEAZRCHSwUD9NvyLIWBOpXjp3cwRYkvKMie1j4jhSKoieCzZND4w2M7rQq6V5auPOWMCXI8tFRd3w1FqcIalFe9Ngp9W1TBTA==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version; 
 bh=IkZKi9jWZ1ioPhakfwDmy6MCM/Zjdy2trg9gQOa1VYg=;
 b=ZMgJiMPyh97JQdUrtqj64Vtk7+m6dFFpDYfFd1Qz4QODrEMfr570qXVDs20oZaLmZM4SID0uwabh5M2G7I7O+8eb07Hr+N8PZu0J+Ebvfa/wop9cs8+e9DiChEUYagRTajz/Q4HBciDGTKmWGoybdMh3Stzu3uk2V2lbJKBQMeLvVYifAy9Hl47Fe5OlJqgGbMLKKxC7VGa/ZzGdI5GDkwZ8EKnSYNMsHxnxZ6n6fo/JgabaVDgfe2oWD2qfF3R7qtyTugQce4ElX3Xec7aJjHI86KuC66LH4n+3rj8ssiRAIwvQiwyhJwxI4panqDRPP71F9w5avmhEFkFSGestJw==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=pass
 smtp.mailfrom=cornell.edu; dmarc=pass action=none header.from=cornell.edu;
 dkim=pass header.d=cornell.edu; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=cornell.edu;
 s=selector2;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=IkZKi9jWZ1ioPhakfwDmy6MCM/Zjdy2trg9gQOa1VYg=;
 b=IomV8Vs6MYQ17grZRRmIDKG6nmKveL+H7s3cMcED+xU1WVxycufurnyNCx68e1VeB/9IUaVJx7wiNHi9Agxs5LkejvPVwzMfSXzdLetCgtZnvFphh4rj+LDSQ68xcCBBSuc4ugrwnO5ZDfZXVxpfLXzy+r+FzX2AGQLucs9+kwo=
Authentication-Results: debbugs.gnu.org; dkim=none (message not signed)
 header.d=none;debbugs.gnu.org; dmarc=none action=none
 header.from=cornell.edu;
Received: from BN7PR04MB4388.namprd04.prod.outlook.com (2603:10b6:406:f8::19)
 by BN6PR04MB0531.namprd04.prod.outlook.com (2603:10b6:404:97::12)
 with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.4523.14; Wed, 22 Sep
 2021 21:35:30 +0000
Received: from BN7PR04MB4388.namprd04.prod.outlook.com
 ([fe80::5113:e84a:b38a:7a66]) by BN7PR04MB4388.namprd04.prod.outlook.com
 ([fe80::5113:e84a:b38a:7a66%6]) with mapi id 15.20.4523.019; Wed, 22 Sep 2021
 21:35:30 +0000
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
To: Eli Zaretskii <eliz@HIDDEN>
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN> <835yux5dn1.fsf@HIDDEN>
 <87bl4pf3s1.fsf@HIDDEN> <83tuih3uvr.fsf@HIDDEN>
 <877dfcg5tu.fsf@HIDDEN> <83pmt44vn1.fsf@HIDDEN>
 <eae87657-d5b5-2265-9b89-4626467a4ac5@HIDDEN> <83mto84r9l.fsf@HIDDEN>
 <fbe7b320-c720-50ad-aa18-a74443d2b070@HIDDEN> <83fsu04mai.fsf@HIDDEN>
 <1a5e01a2-2247-2f68-82f6-2075577e02b6@HIDDEN> <837dfc4hi1.fsf@HIDDEN>
From: Ken Brown <kbrown@HIDDEN>
Message-ID: <4ae8067f-55b2-d243-66f3-f76493095a39@HIDDEN>
Date: Wed, 22 Sep 2021 17:35:28 -0400
User-Agent: Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:78.0) Gecko/20100101
 Thunderbird/78.14.0
In-Reply-To: <837dfc4hi1.fsf@HIDDEN>
Content-Type: text/plain; charset=windows-1252; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-ClientProxiedBy: CH2PR11CA0003.namprd11.prod.outlook.com
 (2603:10b6:610:54::13) To BN7PR04MB4388.namprd04.prod.outlook.com
 (2603:10b6:406:f8::19)
MIME-Version: 1.0
Received: from [IPv6:2603:7081:7e3f:3419:8038:2245:c6fc:6fdc]
 (2603:7081:7e3f:3419:8038:2245:c6fc:6fdc) by
 CH2PR11CA0003.namprd11.prod.outlook.com (2603:10b6:610:54::13) with Microsoft
 SMTP Server (version=TLS1_2, cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id
 15.20.4544.13 via Frontend Transport; Wed, 22 Sep 2021 21:35:29 +0000
X-MS-PublicTrafficType: Email
X-MS-Office365-Filtering-Correlation-Id: f29ec547-32e9-4730-9f06-08d97e10e669
X-MS-TrafficTypeDiagnostic: BN6PR04MB0531:
X-Microsoft-Antispam-PRVS: <BN6PR04MB05316102CC27BDA416006604D8A29@HIDDEN>
X-MS-Oob-TLC-OOBClassifiers: OLM:10000;
X-MS-Exchange-SenderADCheck: 1
X-MS-Exchange-AntiSpam-Relay: 0
X-Microsoft-Antispam: BCL:0;
X-Microsoft-Antispam-Message-Info: 4tZ7X4pu5jVcAqSJc7ZJrjt8Dat+Qmi7xUdOaoOlizDfW6JPkzDMkKLCvQi0zc82PAAqm7qqLOu9Cee7/7aHT3koHuuCPK0da2Yt9cU/r68NJdOkbyJ/1WD1QZ+VdJKzeQE+kyN7xM58uANRLJEHfhXgcGyBTLjsYw3oZVGtbjeE6IOZeNxi/hKJQBypl0rTmXhvDH8cNkcPKk5gN1VslbT/W/6N3iSYwjj8XOsILvj5fBM9i955CAB2KUP2TbwXUrLreUquSj10k+n5JKOVRq1WRVRgUxeEXqMv381uZ8OcjgKZpT329Dk72R6wzfOdPflU1XthXGT94uNvABvFXLLu7rkhTO0dTruzQfVHsuYY4iJ5UjOrXblzmRxYbYp4lkZqsMFeWSYJi6Bmu2Z8g0Ns/xdTuly+MfXELdHlzt0JIeDNg9pIpzc1qKua+xBYPNmpsYec/JIQnF4NA2PQTAiaNujYNp+t26qYpTH6+awd8bFwodrcTj540kFLL18iqO9kejmHbqT2oCx+rCFgwnpi57kASOxAHQnRxaLCfXu27GeRgfqG97EcUu5316SYzs65UjaSQRPo3Sbd9Z0lhODarddprKt+jHRsbZ5qK59tWe+tdvNSXi5GFTYFgIbwHLwe+ssB7gx8hatPgRYPLBs8v799hxt/mvw7j6uD1giMlOV4onCmUgHPWYrC11b7DmachssySivoiaAtaYWGDwqS7NK3HYfpUooo1Odq6m0CAdaB4I8z58BLSSdPNAkM
X-Forefront-Antispam-Report: CIP:255.255.255.255; CTRY:; LANG:en; SCL:1; SRV:;
 IPV:NLI; SFV:NSPM; H:BN7PR04MB4388.namprd04.prod.outlook.com; PTR:; CAT:NONE;
 SFS:(4636009)(366004)(84040400005)(86362001)(4326008)(8936002)(316002)(75432002)(8676002)(66946007)(53546011)(66556008)(2906002)(186003)(508600001)(36756003)(6916009)(31686004)(6486002)(5660300002)(66476007)(38100700002)(31696002)(2616005)(43740500002)(45980500001);
 DIR:OUT; SFP:1102; 
X-MS-Exchange-AntiSpam-MessageData-ChunkCount: 1
X-MS-Exchange-AntiSpam-MessageData-0: =?Windows-1252?Q?brsnKILnjw+0Gqnbk4Aou7FivGJRpjFsAxZU1LeGv9ooWfeVLQFmNzTE?=
 =?Windows-1252?Q?mGlrB0jTjk8o0TlkpFI3FX5ITyYSY9RKs0jrFJBeo4eYAheQh6eGn75E?=
 =?Windows-1252?Q?BurwKnF9iwG9jK1KJGIPFjdcqOvsjIqK4l69I+mJABlJ6BZMgj+Mtte4?=
 =?Windows-1252?Q?I+hSzAUE+qLskWPHo26T++S/il0nYksfbxIYfPABxbzOkmgy9j0137vv?=
 =?Windows-1252?Q?DQiF59v4EZLA3FAbF0BRH9l02bOVmPKf4WGsHvXmtnY+ubIiNBTLYulC?=
 =?Windows-1252?Q?vrg7m8qfftuAnhpfj6gRKKw/zOmuRI18jFvEEJCmCx7jqS9cs80qdIG0?=
 =?Windows-1252?Q?dPh/t2rzl3xAJimRbBC9knwEwOXYMjGJOKw++gCy5JmbA1hkcZT6IWTG?=
 =?Windows-1252?Q?O5H0nOFYdbSFaHcOO2h7+h/HXHoD9QyNdmE4mrTIvzJQayJQztvD811A?=
 =?Windows-1252?Q?A4KYiAGCwaQJMjcfRzxRTDRFRnfKV9dLU8Wj/fKdAql4D4AsNBrPZb7h?=
 =?Windows-1252?Q?bxRRc6wI36tSFmAVkZ59DjIK2rhMARoweCZQzspgBqgSil3XtTaiGI09?=
 =?Windows-1252?Q?bW5WX8xMtcHIiSCpYKG95nCupqbfSlKXZlvc+0uXxCiqwT44NqGiAhvm?=
 =?Windows-1252?Q?QFNeHwSXEI82XvtrY0ho5fs5Wh0mzZk33XMmCy7g1r4QKrzEIS+jwSvs?=
 =?Windows-1252?Q?YvDUe5UusP5RSpJYp95fSU5hg0nrEO+8E03QeE/oY90tHlwCXIlQCt9k?=
 =?Windows-1252?Q?4YDg+YjuPKnETox/lTl7a3r6Qz4h0Aen2x3bTYA3Ej2A5HcQhuwClrMv?=
 =?Windows-1252?Q?BJEOVUOlwVFcVw/5JcfpIct75q5nCh39G56bcBOoE8Ww8KBzW7RuC2VG?=
 =?Windows-1252?Q?PY/uhGPw8l54avOHrO/IcoxqDS55qLknbCtWIa+XWDP35LgEQW5sWcOi?=
 =?Windows-1252?Q?mhxsenluyfJ0vRoMGwMmCstSiA22FuaXWUYBD0xltUcNIMN0NlODH2CQ?=
 =?Windows-1252?Q?ZEC+OR7jryH1tUD5J1OKipjVlyVy3oA59DD72vuw9oEwvBZmT4HD2gSA?=
 =?Windows-1252?Q?ieBWkVoG4lGapI7fkwz9gcWhVBoBjdY+R3PUA3ooYXtidPHFdjQ7Jzz1?=
 =?Windows-1252?Q?UNtFn9YwHx3IhgVp2hLjy3bFFCvBdzkJcUQxmgI+2qRGkhVVvkRig428?=
 =?Windows-1252?Q?hhcuuaxMLubTaY3TClnbWfp371FJF+GDwWm2G8qmW+ea3vkt7Itm7E/D?=
 =?Windows-1252?Q?1J1IlFNe/6kXhQAkqoEWCAvafnP42dmllUpbtwWy2YkBox0ff71Cqc6x?=
 =?Windows-1252?Q?ZhCam5HjpfCkR1EG/N4AlO/C6OSWSx2twILSV0gHZ3yw3qR6hGyfKRWn?=
 =?Windows-1252?Q?+p+lSbYRjBwzhnldd5DysaUMkDbHbnZpjluEEeeDLEFJC4qnH3cmszpo?=
 =?Windows-1252?Q?Sp0ZlgWeR7nHkq5j2nfzZzY5ZtT+FXv4TSBQF5jpzoi3qpFSXKJYHw/p?=
 =?Windows-1252?Q?cUWLNfMx?=
X-OriginatorOrg: cornell.edu
X-MS-Exchange-CrossTenant-Network-Message-Id: f29ec547-32e9-4730-9f06-08d97e10e669
X-MS-Exchange-CrossTenant-AuthSource: BN7PR04MB4388.namprd04.prod.outlook.com
X-MS-Exchange-CrossTenant-AuthAs: Internal
X-MS-Exchange-CrossTenant-OriginalArrivalTime: 22 Sep 2021 21:35:30.0983 (UTC)
X-MS-Exchange-CrossTenant-FromEntityHeader: Hosted
X-MS-Exchange-CrossTenant-Id: 5d7e4366-1b9b-45cf-8e79-b14b27df46e1
X-MS-Exchange-CrossTenant-MailboxType: HOSTED
X-MS-Exchange-CrossTenant-UserPrincipalName: IS1AFlvfV3aE+HWOZGxYaclBfZ6/Tn6oVPK3SoaOswbLEBLs2WVWV0OT2KLmfLtcR0nslrVpZyJvUd9H340dew==
X-MS-Exchange-Transport-CrossTenantHeadersStamped: BN6PR04MB0531
X-Spam-Score: 1.7 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview:  On 9/19/2021 1:12 PM,
 Eli Zaretskii wrote: >> Cc: Stromeko@HIDDEN, 
 50666 <at> debbugs.gnu.org >> From: Ken Brown <kbrown@HIDDEN> >> Date: Sun,
 19 Sep 2021 12:17:51 -0400 >> >>>> In the meantime, is [...] 
 Content analysis details:   (1.7 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 0.0 T_SPF_TEMPERROR        SPF: test of record failed (temperror)
 -0.0 SPF_HELO_PASS          SPF: HELO matches SPF record
 0.0 MSGID_FROM_MTA_HEADER  Message-Id was added by a relay
 1.3 FORGED_SPF_HELO        No description available.
 -0.1 NICE_REPLY_A           Looks like a legit reply (A)
 0.4 KHOP_HELO_FCRDNS       Relay HELO differs from its IP's reverse DNS
X-Debbugs-Envelope-To: 50666
Cc: Stromeko@HIDDEN, 50666 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.1 (-)

On 9/19/2021 1:12 PM, Eli Zaretskii wrote:
>> Cc: Stromeko@HIDDEN, 50666 <at> debbugs.gnu.org
>> From: Ken Brown <kbrown@HIDDEN>
>> Date: Sun, 19 Sep 2021 12:17:51 -0400
>>
>>>> In the meantime, is it OK if I install my patch to enable building with native
>>>> compilation?  That would simplify experimentation.
>>>
>>> Yes, it's okay to install that, but it's a band-aid at best, and we'd
>>> like to have the complete solution in Emacs before we release v28.1.
>>> Is that feasible?
>>
>> Yes, I think so.
> 
> Great, let's hopw you will succeed.

We've made a good start on the Cygwin side, but I have a question about how to 
integrate it into Emacs.

Let's say we have a script that I'll call "rebase" for the purpose of this 
discussion, which rebases all the eln files in ~/.emacs.d/eln-cache.  The user 
would then start Emacs via a script that first calls rebase and then starts 
Emacs.  Within Emacs, I would then want to do something like

(if (eq system-type 'cygwin)
     (call-process "rebase" nil
                   '(:file "<log file>")
                   nil "<arg>" ...))

after every compilation but before the compiled file is loaded.

I'm not familiar enough with native compilation to know where this should go. 
Or maybe it has to be done in more than one place, depending on whether the 
compilation is synchronous or not.

Can you help?

Thanks.

Ken

P.S. The rebase script will fail to rebase eln files that are already loaded, 
but that's harmless in the scenario above.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at 50666 <at> debbugs.gnu.org:


Received: (at 50666) by debbugs.gnu.org; 19 Sep 2021 17:12:27 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Sep 19 13:12:27 2021
Received: from localhost ([127.0.0.1]:39792 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mS0Mc-00080V-V5
	for submit <at> debbugs.gnu.org; Sun, 19 Sep 2021 13:12:27 -0400
Received: from eggs.gnu.org ([209.51.188.92]:58918)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1mS0Ma-00080H-H5
 for 50666 <at> debbugs.gnu.org; Sun, 19 Sep 2021 13:12:25 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:58162)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1mS0MU-0007XP-F7; Sun, 19 Sep 2021 13:12:18 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:2350
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1mS0MU-0001zN-1f; Sun, 19 Sep 2021 13:12:18 -0400
Date: Sun, 19 Sep 2021 20:12:06 +0300
Message-Id: <837dfc4hi1.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Ken Brown <kbrown@HIDDEN>
In-Reply-To: <1a5e01a2-2247-2f68-82f6-2075577e02b6@HIDDEN> (message from
 Ken Brown on Sun, 19 Sep 2021 12:17:51 -0400)
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN> <835yux5dn1.fsf@HIDDEN>
 <87bl4pf3s1.fsf@HIDDEN> <83tuih3uvr.fsf@HIDDEN>
 <877dfcg5tu.fsf@HIDDEN> <83pmt44vn1.fsf@HIDDEN>
 <eae87657-d5b5-2265-9b89-4626467a4ac5@HIDDEN> <83mto84r9l.fsf@HIDDEN>
 <fbe7b320-c720-50ad-aa18-a74443d2b070@HIDDEN> <83fsu04mai.fsf@HIDDEN>
 <1a5e01a2-2247-2f68-82f6-2075577e02b6@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 50666
Cc: Stromeko@HIDDEN, 50666 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Cc: Stromeko@HIDDEN, 50666 <at> debbugs.gnu.org
> From: Ken Brown <kbrown@HIDDEN>
> Date: Sun, 19 Sep 2021 12:17:51 -0400
> 
> >> In the meantime, is it OK if I install my patch to enable building with native
> >> compilation?  That would simplify experimentation.
> > 
> > Yes, it's okay to install that, but it's a band-aid at best, and we'd
> > like to have the complete solution in Emacs before we release v28.1.
> > Is that feasible?
> 
> Yes, I think so.

Great, let's hopw you will succeed.

> And if we're not able to do it, I would propose disabling native
> compilation on 32-bit Cygwin.  The user experience is terrible as it
> stands.

Yes, that's why I said "unworkable".  Indeed, disabling it in that
case would be TRT.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at 50666 <at> debbugs.gnu.org:


Received: (at 50666) by debbugs.gnu.org; 19 Sep 2021 16:18:07 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Sep 19 12:18:07 2021
Received: from localhost ([127.0.0.1]:39652 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mRzW3-0002Bm-Bv
	for submit <at> debbugs.gnu.org; Sun, 19 Sep 2021 12:18:07 -0400
Received: from mail-dm6nam11on2091.outbound.protection.outlook.com
 ([40.107.223.91]:45323 helo=NAM11-DM6-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <kbrown@HIDDEN>) id 1mRzVy-0002B3-7L
 for 50666 <at> debbugs.gnu.org; Sun, 19 Sep 2021 12:18:05 -0400
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=aWOIcnJu4qm0LCtlP2Cu3oEydL1ihCFtHGsVwwrydfw4simnvSjUlw2OaCaTQim4O0lNDBkRyOvV7v1BMPlW+B6jiRvre21qtD3bYVZ/1mZEjxUyfDpKo3Cp6jZXLnAibPzm08UeasbflYfWk8WIMku9CerYZPLgfYd0up9HhUnHxApcl8T7U2d0vaFRW41G3BtlJF0khvpgebnJdfKp+Ku4JFJHpC7awY/bpfkBQTOg95Bu2K6BAJIeMeyUY1Ncjm5OfbgfNMG9JlDstyzWVdh5V+eBl8IPht8egDmB9WwiBohVDkXIIg/3a1SM+SIQc9CyySc7XfIG4Bxoa4NoEA==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version; 
 bh=oAbfGYmwLfARxCRL9Kotv4Ov2ZB6Hs2fIYRRv1+EvH4=;
 b=ZAVtBiwcQ7IrPOTnBsIwWRduf0Vxi36YLj7miif4DjcjOYdPu1n0ryjKRTorjSoAFoEQbHwnQw2MRkzYLXHNqaOQnC2RHOhHFRAylnCp1LOAhDPnU762jxz+oOOJBiJlTKKxcc2+eeArHoC9V8NpYTZj+IZ2ny6yf383FQ2ENZewq/OG7rhOoRGQamjAR6F4+9JiUpTZO549uG7psv8LOQA02jvv+8Lx0+sGmattfJkOxgepIC2etZU0+qhkcNaQWdSgYvSFQoFhtmI6DtuIyHqgnksQhMHwJbYwpUuSghZ4Pm/k1nh/PTF4eI9CL9yS5iskcpbiWrERwKnj4NNxFQ==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=pass
 smtp.mailfrom=cornell.edu; dmarc=pass action=none header.from=cornell.edu;
 dkim=pass header.d=cornell.edu; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=cornell.edu;
 s=selector2;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=oAbfGYmwLfARxCRL9Kotv4Ov2ZB6Hs2fIYRRv1+EvH4=;
 b=QkCqeI8PY14cMQDSohbQ7DwQ5c6Yt1b9F/rK7O4lYe/9uzLCxE/92pIqZnHVTv7+Hp4hcZmJ8Jk6aUM90Wqqbj3mqQweCOsjZgnNfgT6iZp/1GHXQ2LqKgH9G+ozL3dwV1e+MPSmGO6z8Y/qOMtPtDumIVJLTMOzuHpZnT/pmgY=
Authentication-Results: debbugs.gnu.org; dkim=none (message not signed)
 header.d=none;debbugs.gnu.org; dmarc=none action=none
 header.from=cornell.edu;
Received: from BN7PR04MB4388.namprd04.prod.outlook.com (2603:10b6:406:f8::19)
 by BN6PR04MB0658.namprd04.prod.outlook.com (2603:10b6:404:d2::19)
 with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.4523.14; Sun, 19 Sep
 2021 16:17:54 +0000
Received: from BN7PR04MB4388.namprd04.prod.outlook.com
 ([fe80::5113:e84a:b38a:7a66]) by BN7PR04MB4388.namprd04.prod.outlook.com
 ([fe80::5113:e84a:b38a:7a66%6]) with mapi id 15.20.4523.018; Sun, 19 Sep 2021
 16:17:54 +0000
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
To: Eli Zaretskii <eliz@HIDDEN>
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN> <835yux5dn1.fsf@HIDDEN>
 <87bl4pf3s1.fsf@HIDDEN> <83tuih3uvr.fsf@HIDDEN>
 <877dfcg5tu.fsf@HIDDEN> <83pmt44vn1.fsf@HIDDEN>
 <eae87657-d5b5-2265-9b89-4626467a4ac5@HIDDEN> <83mto84r9l.fsf@HIDDEN>
 <fbe7b320-c720-50ad-aa18-a74443d2b070@HIDDEN> <83fsu04mai.fsf@HIDDEN>
From: Ken Brown <kbrown@HIDDEN>
Message-ID: <1a5e01a2-2247-2f68-82f6-2075577e02b6@HIDDEN>
Date: Sun, 19 Sep 2021 12:17:51 -0400
User-Agent: Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:78.0) Gecko/20100101
 Thunderbird/78.14.0
In-Reply-To: <83fsu04mai.fsf@HIDDEN>
Content-Type: text/plain; charset=windows-1252; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-ClientProxiedBy: CH2PR19CA0002.namprd19.prod.outlook.com
 (2603:10b6:610:4d::12) To BN7PR04MB4388.namprd04.prod.outlook.com
 (2603:10b6:406:f8::19)
MIME-Version: 1.0
Received: from [IPv6:2603:7081:7e3f:3419:1d36:e122:658d:e368]
 (2603:7081:7e3f:3419:1d36:e122:658d:e368) by
 CH2PR19CA0002.namprd19.prod.outlook.com (2603:10b6:610:4d::12) with Microsoft
 SMTP Server (version=TLS1_2, cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id
 15.20.4523.14 via Frontend Transport; Sun, 19 Sep 2021 16:17:54 +0000
X-MS-PublicTrafficType: Email
X-MS-Office365-Filtering-Correlation-Id: f0115fee-8de8-40c2-add5-08d97b890922
X-MS-TrafficTypeDiagnostic: BN6PR04MB0658:
X-Microsoft-Antispam-PRVS: <BN6PR04MB065864ED40A060F87E2473B5D8DF9@HIDDEN>
X-MS-Oob-TLC-OOBClassifiers: OLM:6790;
X-MS-Exchange-SenderADCheck: 1
X-MS-Exchange-AntiSpam-Relay: 0
X-Microsoft-Antispam: BCL:0;
X-Microsoft-Antispam-Message-Info: VYnZRqx7a317zMJFVWIdZa9p6zrHK/30YgHqprz6W80M7WF9ImfyiGpVHfl8iRibjBrLnWdPgw6N+yBOsQmNnMAJEHN3U73t8biFxDKUkBZmSv0u2FRKV41xWLLRIyY0VCd+OIuoK6vg3gK2tt6jNKMhrg+SpEzika3eWsUjT39q5mR06b1Y7lX20Gx+SIYKwIn3nkNsmUPkv5Zq4xK3gvuwnXJ4Qjp4TpvTdd/uKMNRCi3PqqHd+1uR99WSE4mDq6yK4pOxSetG7w/IUqhuvk869M/eRhAt40JIjGx3ENg4eGsLbAMFGaCmlJ3x7Hdas365w/NXzgYiWmgv9ncy86P7dIha/As2DexJQLXk6S4sGtjEXbRB97kNtjN3+UezPPKmNVy6bcGwv/J1BTlYwLXmBHyOW9QEXNGafc6mfzY8u5v6TZ0aAfq2/9mJDf6HrRRa1FFY7FIUXGMRglqiPvm+pGkfVhdpoN1Hwln1jJycmPQrNp3X9wUgU+LSvdYUrcS8uRf8A3SIMVk0/7mzEbSyfZajkN2uz6z2uM6uniVknUSAQNe0G/7eYrLKB6A7v7vHarro5oU0x2PNT6+z1gtiVPBjCXatYIVf+RJUoZ2NFyRBTUHfRqzDZbBNSAA3t4IkLgSVC5LWIqx30Oo5068BRB1UYbFdWp8HhO2VxYgPB3XE6oxu4mEdPNWdP8tnuhjBXMpIKLmQDnQDqU7Wp5ClXEFPlkLBcjvMIwBTRWM=
X-Forefront-Antispam-Report: CIP:255.255.255.255; CTRY:; LANG:en; SCL:1; SRV:;
 IPV:NLI; SFV:NSPM; H:BN7PR04MB4388.namprd04.prod.outlook.com; PTR:; CAT:NONE;
 SFS:(4636009)(366004)(6916009)(31696002)(31686004)(36756003)(5660300002)(508600001)(186003)(2906002)(66556008)(2616005)(75432002)(6486002)(66476007)(66946007)(8936002)(316002)(86362001)(53546011)(4326008)(38100700002)(6666004)(8676002)(43740500002)(45980500001);
 DIR:OUT; SFP:1102; 
X-MS-Exchange-AntiSpam-MessageData-ChunkCount: 1
X-MS-Exchange-AntiSpam-MessageData-0: =?Windows-1252?Q?zh6BUCbrLbl0n+trhg8z98YpGeP28hCC+ywTSjdBI++VNxMTZiCPIDsl?=
 =?Windows-1252?Q?TYcRxRXFmxuRGoZxnXCYZK6rSqUktHlXNcvolXDZGaAhRUklbUk+SmQ+?=
 =?Windows-1252?Q?3Kj6rtZbihdoFxQoJ/GU4BMicQbviC+ZI/ybE87rE7KlteXMeEuneyQq?=
 =?Windows-1252?Q?eg3c+JbqlBSgI77dPuwxskdRgaY5RSHGH/h22fZ0mbfl5s9NTHQDnT86?=
 =?Windows-1252?Q?nUs9mKOuciJg9JstFMUEDPoCkV0UynF+u4o7AkrhfGlRiSyZ7DLB08+h?=
 =?Windows-1252?Q?lGprWoYfn+UD3l1zKcDrAvcYQdvS/pVLCCPxinFDJrxJzY82YJFJSwub?=
 =?Windows-1252?Q?ckf8y5HuwqQtsU+UBLVjX3fqc27uDnbsnZtoFTn4RFMSCsQ1NB0HRZND?=
 =?Windows-1252?Q?oNqXKwZRT3fQsT3WnN1593GwzzFl63BYjuYa0tC3TmuGrCFP2A3C7f/i?=
 =?Windows-1252?Q?QMFHf2ZGSkWsRaScfHSj3++HxPgKRr9dHdXktdKxTMGebxQ5raaHIn+F?=
 =?Windows-1252?Q?XvtPVFo0w8zLC/ZCx7Lru5yHfYhRmGHkiQgqhk4FU3U3+9V0XbFAhH9C?=
 =?Windows-1252?Q?DrrhGsGEqBsnFQSQT/gyX5aK+S9RSIvqTy3Ig0dDWyLgE6/0IL4lGcYs?=
 =?Windows-1252?Q?nkipM4YZ7n0dwim+V3fyi9GQwN5IypZY1K83kXsnfgoQib4T3LVJL0A/?=
 =?Windows-1252?Q?HDpSTDLbMF2NTprYpCnbyi5qckXggAubkM858vziVYH+9T3RkuIO65u4?=
 =?Windows-1252?Q?dRYc9Uu9kwr0WYqyxifaW+hGke7aU5pS7I4aXv5BcRDXhmWuGCMyLQx8?=
 =?Windows-1252?Q?roDHHv5pZ/FLDMwaoUm24Gp50DUO5A5MKKXhDbVIA+JZOf+idP3NHgYH?=
 =?Windows-1252?Q?9RjIrO9HFw/kMaGR93+AoAhm6iqQCtKLQT9D0c4u2PMjlnDGXNgPlW5x?=
 =?Windows-1252?Q?lGgEVP19OkL2/jklsepz157QQPrpQOT0M225puo1ChjoAXAmBQng8asb?=
 =?Windows-1252?Q?polImCwoA6s0FFI/PRJTZRJGfZi3AqOwAOIi20CuAFPpzHgGd7Kf207d?=
 =?Windows-1252?Q?Tkjb48WpvDuBrq/hWM+msQkhNLRySBNP7iZjrcy971ZZ/wQ5giaGLEjW?=
 =?Windows-1252?Q?XPVRKpHDJhDncIi1Y9NqGuIfHTzzUb0R4ux+it1c040uq/InHA2G6ijH?=
 =?Windows-1252?Q?GE68XDrjzqQDJ4g2j2j2NAZXbpzHjgf9ZJuEDyyYNgJ2OgEJlfGl0qET?=
 =?Windows-1252?Q?yUWJloTgeXfj/pXEHUZMPV1Vs7EDThmhJPVzp/4Le+4n2MGdg0tZfnr+?=
 =?Windows-1252?Q?9BofifhXePe3Zys8Zia68Jrth1DdvmUKsrc7FbkxJBaO/vJNFXxrKSHL?=
 =?Windows-1252?Q?SDHmixjqMPISz3qaUktmwWAlLfpH2Njj3fafIjp/26WZXUHsKtKletIC?=
 =?Windows-1252?Q?8XdmLn1N6qQdt/bBPGauEsxvVDRePnWQnLECe5Hs+s16m1iPIhQxmdUX?=
 =?Windows-1252?Q?z1AAvAsB?=
X-OriginatorOrg: cornell.edu
X-MS-Exchange-CrossTenant-Network-Message-Id: f0115fee-8de8-40c2-add5-08d97b890922
X-MS-Exchange-CrossTenant-AuthSource: BN7PR04MB4388.namprd04.prod.outlook.com
X-MS-Exchange-CrossTenant-AuthAs: Internal
X-MS-Exchange-CrossTenant-OriginalArrivalTime: 19 Sep 2021 16:17:54.4668 (UTC)
X-MS-Exchange-CrossTenant-FromEntityHeader: Hosted
X-MS-Exchange-CrossTenant-Id: 5d7e4366-1b9b-45cf-8e79-b14b27df46e1
X-MS-Exchange-CrossTenant-MailboxType: HOSTED
X-MS-Exchange-CrossTenant-UserPrincipalName: cS3tBiHxaT+Bj1J/wFEKdrh2/ElXzGAEPIE7uQmH9L+CAk2VUAVKmAbcR0y6bMx7JdBjAiPnb6FqfPLk3iCPSw==
X-MS-Exchange-Transport-CrossTenantHeadersStamped: BN6PR04MB0658
X-Spam-Score: -0.1 (/)
X-Debbugs-Envelope-To: 50666
Cc: Stromeko@HIDDEN, 50666 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.1 (-)

On 9/19/2021 11:28 AM, Eli Zaretskii wrote:
>> Cc: Stromeko@HIDDEN, 50666 <at> debbugs.gnu.org
>> From: Ken Brown <kbrown@HIDDEN>
>> Date: Sun, 19 Sep 2021 10:27:27 -0400
>>
>>> I don't think I understand: rebased and added how? manually?
>>
>> No, by a script that Cygwin would have to create and that Emacs would call.  We
>> already have scripts that do system-wide rebasing (and that are run
>> automatically, without user intervention).  The question would be how to extend
>> this to per-user rebasing.  Achim and I have just begun discussing this on the
>> Cygwin mailing lists (currently the cygwin-apps list).  I think it's doable with
>> some effort.
>>
>> In the meantime, is it OK if I install my patch to enable building with native
>> compilation?  That would simplify experimentation.
> 
> Yes, it's okay to install that, but it's a band-aid at best, and we'd
> like to have the complete solution in Emacs before we release v28.1.
> Is that feasible?

Yes, I think so.  And if we're not able to do it, I would propose disabling 
native compilation on 32-bit Cygwin.  The user experience is terrible as it stands.

Ken




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at 50666 <at> debbugs.gnu.org:


Received: (at 50666) by debbugs.gnu.org; 19 Sep 2021 15:28:56 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Sep 19 11:28:56 2021
Received: from localhost ([127.0.0.1]:39571 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mRykS-00050F-AE
	for submit <at> debbugs.gnu.org; Sun, 19 Sep 2021 11:28:56 -0400
Received: from eggs.gnu.org ([209.51.188.92]:45672)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1mRykQ-000502-By
 for 50666 <at> debbugs.gnu.org; Sun, 19 Sep 2021 11:28:54 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:55630)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1mRykI-0003m4-Kh; Sun, 19 Sep 2021 11:28:46 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:3981
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1mRykI-0007Pv-7Z; Sun, 19 Sep 2021 11:28:46 -0400
Date: Sun, 19 Sep 2021 18:28:37 +0300
Message-Id: <83fsu04mai.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Ken Brown <kbrown@HIDDEN>
In-Reply-To: <fbe7b320-c720-50ad-aa18-a74443d2b070@HIDDEN> (message from
 Ken Brown on Sun, 19 Sep 2021 10:27:27 -0400)
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN> <835yux5dn1.fsf@HIDDEN>
 <87bl4pf3s1.fsf@HIDDEN> <83tuih3uvr.fsf@HIDDEN>
 <877dfcg5tu.fsf@HIDDEN> <83pmt44vn1.fsf@HIDDEN>
 <eae87657-d5b5-2265-9b89-4626467a4ac5@HIDDEN> <83mto84r9l.fsf@HIDDEN>
 <fbe7b320-c720-50ad-aa18-a74443d2b070@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 50666
Cc: Stromeko@HIDDEN, 50666 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Cc: Stromeko@HIDDEN, 50666 <at> debbugs.gnu.org
> From: Ken Brown <kbrown@HIDDEN>
> Date: Sun, 19 Sep 2021 10:27:27 -0400
> 
> > I don't think I understand: rebased and added how? manually?
> 
> No, by a script that Cygwin would have to create and that Emacs would call.  We 
> already have scripts that do system-wide rebasing (and that are run 
> automatically, without user intervention).  The question would be how to extend 
> this to per-user rebasing.  Achim and I have just begun discussing this on the 
> Cygwin mailing lists (currently the cygwin-apps list).  I think it's doable with 
> some effort.
> 
> In the meantime, is it OK if I install my patch to enable building with native 
> compilation?  That would simplify experimentation.

Yes, it's okay to install that, but it's a band-aid at best, and we'd
like to have the complete solution in Emacs before we release v28.1.
Is that feasible?

Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at 50666 <at> debbugs.gnu.org:


Received: (at 50666) by debbugs.gnu.org; 19 Sep 2021 14:27:39 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Sep 19 10:27:39 2021
Received: from localhost ([127.0.0.1]:39481 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mRxn9-0003Pb-Cg
	for submit <at> debbugs.gnu.org; Sun, 19 Sep 2021 10:27:39 -0400
Received: from mail-bn8nam08on2139.outbound.protection.outlook.com
 ([40.107.100.139]:36449 helo=NAM04-BN8-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <kbrown@HIDDEN>) id 1mRxn6-0003PN-9X
 for 50666 <at> debbugs.gnu.org; Sun, 19 Sep 2021 10:27:38 -0400
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=lKa52oMmM5uK6zV5ZgKzTra/JrekPoDivuyoxVp5MH6odhz/NclBPHDe06pGZZbdHpjBLPOqdxs4EgqONllhB5QpD0sfMbKFYPMO7P8VZ/0cYs4W8KjJ1Dr91UbxayusOLY8kzT35qEak5GHLx/+kSbea9zhJBx/oc6xMwVbdjuZwzZa18uX7zjY28AIYaJg03RA5fyg8q8zcTD8TzeRTo0dyGDsm92zOdImBIBBFs5uGzzlfM77VgO2b9PFF2t/gMyehrPZYjVjoE19OTXIZdNihAK8uvoWgl+XlPUDNryVXNZCunSHKhdkFNsc7Qz7qh0HjEqqfb0FuOkNxKWa6g==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version; 
 bh=hb3cDS5I1WgfdHB6CVg3/PoG8DIcx/LPDrJCc+DhoMU=;
 b=ZHKGcnyrwdFGmUIRfKBY+xpejuO11BvJapfVtkWKtKdWARZPsbbpBREOpadtj1NWrdvAxK7wP4CD3ntn/CNHo86nmGYAed0Ni8cBY8gfTe3hgP7p8DpXkVEkGMijI/0OeF7LWbvwejPX+maha7dql9dgOeIbmf4XEVV47mo/fFaQPH9NfTg9H2+ryc4ytjT15ca7hniLNSkQ0S3mrDhLaKFZaRG50QthEyGsmPMxtOHqRZCuFAfqKnCYF0BjYrAjvQ6Gnivv99jEbQGNd72BsTO+LzLLxnbcvkOttlJYSP3ouKXcxa/zzgMs0GADQhaHj9O/0RSAFtsMfxqOdYISfQ==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=pass
 smtp.mailfrom=cornell.edu; dmarc=pass action=none header.from=cornell.edu;
 dkim=pass header.d=cornell.edu; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=cornell.edu;
 s=selector2;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=hb3cDS5I1WgfdHB6CVg3/PoG8DIcx/LPDrJCc+DhoMU=;
 b=dOzQXt65YZUnGmVcQwqBVae7f3DuF32lP4/IESeOjUhMdLsD34PaeuB8pdY9u5N7ZE5ZpzPfPQANaqvv/5wuKTNogc1fw9knZKKGvTAFRvei+eAJhe3CU97444ErrxQQ6OLWcCJbGBq0CdaExdDGeGZ6bUi+l7l9n6GC28C/AdE=
Authentication-Results: debbugs.gnu.org; dkim=none (message not signed)
 header.d=none;debbugs.gnu.org; dmarc=none action=none
 header.from=cornell.edu;
Received: from BN7PR04MB4388.namprd04.prod.outlook.com (2603:10b6:406:f8::19)
 by BN3PR04MB2177.namprd04.prod.outlook.com (2a01:111:e400:7bb1::14)
 with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.4523.14; Sun, 19 Sep
 2021 14:27:29 +0000
Received: from BN7PR04MB4388.namprd04.prod.outlook.com
 ([fe80::5113:e84a:b38a:7a66]) by BN7PR04MB4388.namprd04.prod.outlook.com
 ([fe80::5113:e84a:b38a:7a66%6]) with mapi id 15.20.4523.018; Sun, 19 Sep 2021
 14:27:29 +0000
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
To: Eli Zaretskii <eliz@HIDDEN>
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN> <835yux5dn1.fsf@HIDDEN>
 <87bl4pf3s1.fsf@HIDDEN> <83tuih3uvr.fsf@HIDDEN>
 <877dfcg5tu.fsf@HIDDEN> <83pmt44vn1.fsf@HIDDEN>
 <eae87657-d5b5-2265-9b89-4626467a4ac5@HIDDEN> <83mto84r9l.fsf@HIDDEN>
From: Ken Brown <kbrown@HIDDEN>
Message-ID: <fbe7b320-c720-50ad-aa18-a74443d2b070@HIDDEN>
Date: Sun, 19 Sep 2021 10:27:27 -0400
User-Agent: Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:78.0) Gecko/20100101
 Thunderbird/78.14.0
In-Reply-To: <83mto84r9l.fsf@HIDDEN>
Content-Type: text/plain; charset=windows-1252; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-ClientProxiedBy: CH0PR03CA0218.namprd03.prod.outlook.com
 (2603:10b6:610:e7::13) To BN7PR04MB4388.namprd04.prod.outlook.com
 (2603:10b6:406:f8::19)
MIME-Version: 1.0
Received: from [IPv6:2603:7081:7e3f:3419:1d36:e122:658d:e368]
 (2603:7081:7e3f:3419:1d36:e122:658d:e368) by
 CH0PR03CA0218.namprd03.prod.outlook.com (2603:10b6:610:e7::13) with Microsoft
 SMTP Server (version=TLS1_2, cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id
 15.20.4523.14 via Frontend Transport; Sun, 19 Sep 2021 14:27:28 +0000
X-MS-PublicTrafficType: Email
X-MS-Office365-Filtering-Correlation-Id: de21db50-02b2-4fd5-a4e3-08d97b799c29
X-MS-TrafficTypeDiagnostic: BN3PR04MB2177:
X-Microsoft-Antispam-PRVS: <BN3PR04MB2177DFFCE065C5DAAF5FD5CAD8DF9@HIDDEN>
X-MS-Oob-TLC-OOBClassifiers: OLM:4502;
X-MS-Exchange-SenderADCheck: 1
X-MS-Exchange-AntiSpam-Relay: 0
X-Microsoft-Antispam: BCL:0;
X-Microsoft-Antispam-Message-Info: cZVhCitPegyRYvuq6079v0gZJnS9RtGF3WHG7oflCN1/8pam+dg8V18O5CshNhJCjLsl/zhxf/h/L6BxvMmVP4KPwOw5F3wjbb0YlZY1Ms7jx4hmkvcgCV10UnIQkFK4mmJpzsOMeOuma3RPxktyiDyiJpXB1PW3r73+aYfuWrs4Q4vkvKkul07nmny1/s3EPsOZyZYxDmIJFa3wKOALjpM96T0zrEMaza3LAIpuyRilwSCubzw/Rw06pDPv6Zg6sOgMd47G2FokVZgDWxBwhMh2+YCup27YBRue6aZ6QwNmt0VFiFj/hATN1ws6d9g6Qbwj3jeWSOujEY0S9P0cWyX1+Z7iMRUaLa2Inwe0YnRrjNzGHGMB7EHp43MVvoXwMB5xc8bafN9/JW1V3ldH/WSaAGB0AwVcEfeT8Qg5x9TRDFh5n+UJHn12w2YVA9JGtqlyWTdh6y+31d4guqhqtonlcZ9f6dw+F/5HS6H9IG/xZk7SaK8QjJwoV6+XPb64BDFSsXSUPzujfLA4d2rIptzd+2cvJ3AOfrJglIG/Mo5/WvlhGcIeRjkgUTAylLr9o9cH3KBfO8/uG8sYjq+4M5LxW8TaMDRpUgUse8fJvH2k96Jy9J/uWtntlrf2ZZT4g0JulOX9Oo7/vH02PMO/qBrWOkPwbZLkirwGusK8aJODtsGbD5Lor4KorwJJUIsyNYpI6evPNWIVLgbez106bVwGopIW0wQe8lG36fzh4qU=
X-Forefront-Antispam-Report: CIP:255.255.255.255; CTRY:; LANG:en; SCL:1; SRV:;
 IPV:NLI; SFV:NSPM; H:BN7PR04MB4388.namprd04.prod.outlook.com; PTR:; CAT:NONE;
 SFS:(4636009)(366004)(38100700002)(6916009)(2906002)(53546011)(2616005)(66556008)(8676002)(5660300002)(508600001)(66946007)(316002)(75432002)(66476007)(86362001)(4326008)(31696002)(31686004)(8936002)(186003)(6486002)(36756003)(43740500002)(45980500001);
 DIR:OUT; SFP:1102; 
X-MS-Exchange-AntiSpam-MessageData-ChunkCount: 1
X-MS-Exchange-AntiSpam-MessageData-0: =?Windows-1252?Q?0jrvq3bUk9P5N8fCdhG4GLR+q1wnTE0uXXmlowkblU8/sz1OtW6Onqun?=
 =?Windows-1252?Q?7XYzfpFsy6/WGbW89N/dR6mXSQ1UmzpEsQerrAQtZ+e3JqJ0jE+kiMG5?=
 =?Windows-1252?Q?bpQTdLQrQOATOF3jS2CvVw37BIOp4uae+n04AO6vcOBgILgCN2U79Bai?=
 =?Windows-1252?Q?xvuSAtJ1WldkBlD5IfKtAO5cmkXybaqVtbKQcLjEMmoYnV/C9y1Z/CLY?=
 =?Windows-1252?Q?cp/Ce3tLxrpN5KkOOqwz+2aIjl7YVO95eDHlMdWwezxcUerND9onrNh3?=
 =?Windows-1252?Q?mMeoV8bAqoFyUtfHs5+708gAFmYYQX1AxHe/+5ANeW16LlLGQEpnw5GY?=
 =?Windows-1252?Q?VX/6ceuOuzCOyOGWWQSJGwKiVAykzfe6IsA72gsnOVVApvJxjvO4NXxN?=
 =?Windows-1252?Q?l699dxBwAnlZgEwfuPKOVrdm8kH4DmcSTuVnIT8R+IGjr4wEQ1jHeyHq?=
 =?Windows-1252?Q?QjKGuJurqCVM0XW8pQ26L/Jmt3FPhtkoSYvPysj5WEo6LPzLp/KMilFg?=
 =?Windows-1252?Q?hoP5h8X4rLGwANk2h8cA52AVXae5rxToc/aTOBu2qZOhJ0qLi9cQla8U?=
 =?Windows-1252?Q?SPR1ptX2/b3W2iq4bfy7yP3dzZvFpIlFzfMWlGxyb/7OLElADp1ypyOH?=
 =?Windows-1252?Q?9zaWzZjVhgTLJef/nIsQm/Tvw7O1eS+3CFLD1tMvwIf50O7nNG29ITY8?=
 =?Windows-1252?Q?AA9/kAa0KCrmBGLnxjUTnsCfEeiwi2fdb/t0HdekPG0bHZwq8Ja8FTcM?=
 =?Windows-1252?Q?0co2Mxg7gQLc7gbz2pDBBh6i3WsCkUmsAaiIq5HbWYiluYqVtdMJcAke?=
 =?Windows-1252?Q?GIDyDUMiFhnBwHPE4aS+ZghcT5NEOWIAppVvoS/v7ZGNyzre9KYRvBNt?=
 =?Windows-1252?Q?it+mrzYq1HnnLoDvqnM7U8n77WtdI1ciA/MnIAFdy91BFn3VUWHq6kDm?=
 =?Windows-1252?Q?agMs3Jslf1+UmfXtnaygBJQlgEZDI/qNTcYKJQ2FkVrr/m1R0GifDB60?=
 =?Windows-1252?Q?MWCdIhuj52jBjR+8FlRTkCF/5dB0LaHVidBGWz4t+sMDq3XMpCF8nfYI?=
 =?Windows-1252?Q?KfnEn8l+zQfhQ+Atr//FvyfBv0lU3rL85xm9Q7ZUJJnl9J4CFqs/0aQh?=
 =?Windows-1252?Q?qQ9UcyxNuCAZ9mv3qan5sQIYTPpnqMA16B4Km+CyZPDZZ5MGqN5NXAYk?=
 =?Windows-1252?Q?7tJWXgy/7mGIvVu/mMnBHKQuZXNYekNMZpCjaZLaYx+f1Dm5iIBXphza?=
 =?Windows-1252?Q?y+xaU7aVAmEvRSc5Eba9ssDfuSWd9M9piGkoRGNG6/jJVtRrpU5Evys8?=
 =?Windows-1252?Q?Egyxezez+MPO8gTBUck9jK18HSt0jPsinOGHv5w28kkJs7m+dCuIrntZ?=
 =?Windows-1252?Q?ttKIgX+ClHkmGih0TeYiop9ekTPLMAmN+mkasCSy7Q3wn+IDWSh9/3Mp?=
 =?Windows-1252?Q?6J25zVZD8mqRfVWy6V4E7zI/kwH6S94Dz50WVyak844keSODCcWbjnRI?=
 =?Windows-1252?Q?ZFVIm9CE?=
X-OriginatorOrg: cornell.edu
X-MS-Exchange-CrossTenant-Network-Message-Id: de21db50-02b2-4fd5-a4e3-08d97b799c29
X-MS-Exchange-CrossTenant-AuthSource: BN7PR04MB4388.namprd04.prod.outlook.com
X-MS-Exchange-CrossTenant-AuthAs: Internal
X-MS-Exchange-CrossTenant-OriginalArrivalTime: 19 Sep 2021 14:27:29.1789 (UTC)
X-MS-Exchange-CrossTenant-FromEntityHeader: Hosted
X-MS-Exchange-CrossTenant-Id: 5d7e4366-1b9b-45cf-8e79-b14b27df46e1
X-MS-Exchange-CrossTenant-MailboxType: HOSTED
X-MS-Exchange-CrossTenant-UserPrincipalName: 79KmHu+TAVu+1UNGshq/AbGdcq5HY8AHqvxYrZXfDpN92gNiEk5b9yNrMswSv6VgiQp0fFciMMmAlOsIoWElbw==
X-MS-Exchange-Transport-CrossTenantHeadersStamped: BN3PR04MB2177
X-Spam-Score: -0.1 (/)
X-Debbugs-Envelope-To: 50666
Cc: Stromeko@HIDDEN, 50666 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.1 (-)

On 9/19/2021 9:41 AM, Eli Zaretskii wrote:
>> Cc: 50666 <at> debbugs.gnu.org
>> From: Ken Brown <kbrown@HIDDEN>
>> Date: Sun, 19 Sep 2021 08:37:52 -0400
>>
>> Cygwin could maintain a per-user database of *.eln files and their base
>> addresses.  (It already maintains a system database of this type.)  The each
>> time a new *.eln file is created, it could be rebased and added to the database
>> before being loaded.
> 
> I don't think I understand: rebased and added how? manually?

No, by a script that Cygwin would have to create and that Emacs would call.  We 
already have scripts that do system-wide rebasing (and that are run 
automatically, without user intervention).  The question would be how to extend 
this to per-user rebasing.  Achim and I have just begun discussing this on the 
Cygwin mailing lists (currently the cygwin-apps list).  I think it's doable with 
some effort.

In the meantime, is it OK if I install my patch to enable building with native 
compilation?  That would simplify experimentation.

Ken




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at 50666 <at> debbugs.gnu.org:


Received: (at 50666) by debbugs.gnu.org; 19 Sep 2021 13:41:34 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Sep 19 09:41:33 2021
Received: from localhost ([127.0.0.1]:37692 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mRx4X-00082v-Lm
	for submit <at> debbugs.gnu.org; Sun, 19 Sep 2021 09:41:33 -0400
Received: from eggs.gnu.org ([209.51.188.92]:60660)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1mRx4W-00082f-9C
 for 50666 <at> debbugs.gnu.org; Sun, 19 Sep 2021 09:41:32 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:53638)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1mRx4N-0006q7-GJ; Sun, 19 Sep 2021 09:41:23 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:1421
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1mRx4L-0001rN-DU; Sun, 19 Sep 2021 09:41:23 -0400
Date: Sun, 19 Sep 2021 16:41:10 +0300
Message-Id: <83mto84r9l.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Ken Brown <kbrown@HIDDEN>
In-Reply-To: <eae87657-d5b5-2265-9b89-4626467a4ac5@HIDDEN> (message from
 Ken Brown on Sun, 19 Sep 2021 08:37:52 -0400)
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN> <835yux5dn1.fsf@HIDDEN>
 <87bl4pf3s1.fsf@HIDDEN> <83tuih3uvr.fsf@HIDDEN>
 <877dfcg5tu.fsf@HIDDEN> <83pmt44vn1.fsf@HIDDEN>
 <eae87657-d5b5-2265-9b89-4626467a4ac5@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 50666
Cc: Stromeko@HIDDEN, 50666 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Cc: 50666 <at> debbugs.gnu.org
> From: Ken Brown <kbrown@HIDDEN>
> Date: Sun, 19 Sep 2021 08:37:52 -0400
> 
> Cygwin could maintain a per-user database of *.eln files and their base 
> addresses.  (It already maintains a system database of this type.)  The each 
> time a new *.eln file is created, it could be rebased and added to the database 
> before being loaded.

I don't think I understand: rebased and added how? manually?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at 50666 <at> debbugs.gnu.org:


Received: (at 50666) by debbugs.gnu.org; 19 Sep 2021 12:38:05 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Sep 19 08:38:05 2021
Received: from localhost ([127.0.0.1]:37621 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mRw56-0006Lh-W2
	for submit <at> debbugs.gnu.org; Sun, 19 Sep 2021 08:38:05 -0400
Received: from mail-mw2nam12on2117.outbound.protection.outlook.com
 ([40.107.244.117]:26849 helo=NAM12-MW2-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <kbrown@HIDDEN>) id 1mRw54-0006LA-7n
 for 50666 <at> debbugs.gnu.org; Sun, 19 Sep 2021 08:38:03 -0400
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=odjPYTi7EChA44XcvvmncohS9Oxjfed02KzOZCS0pt4XIk9mlyBnhh5VbcgKayiYNLV52NscDS4KCZxmLjkrOByW/017Sei0X+CZx7oiIkM9kQlZjI6JaAIFEyLIXkCtsUtohCtVSieh0snL4gPYk8hO1vP3RKGCwieHvNcRFiNstCIMiTMqoYXur19/3dpnDiWyDQZlM+mYOR8zy5OgvmA7vLFTOi1xBJZuyaNHNHSXqBe7ztkxQEE0sMSn8oEuWpJ0ZVLThgqfd1RIZJJnN7dToYQXS0Ep64Xw+oJlYelhy4MhxfihOQqB8zHARuk8vbDGmpkHCs2l19MdAF44hw==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version; 
 bh=zu6A5d7qZxoNVPIXIX5omE75L5KRcrwZoujstan4PXg=;
 b=eHXrrz4VVWVhvUI3/GOH5h+AzEMmCB0VoFq4kY7EkY8AiBnAFc36rXUaTkpmLnKTUvmsI0zbJXN9eLhHwony34WS+k5K9PFzeEXJh4v6riEfQPsPqFFyea6F8s3GiLvs7+uexRWEW9Fm1/pEqH2vhhFb097eZJq+Tf+CH61ezsLZYjKf21LxKql8nVGmu2/AtFLswr1+Xo54E6S0akcAOBGH9muO48GqRkx2rwJ71xV8fjK4Nz+l0zJ2b0QYJMbjfGLdFy8AVfSmFcGQSgnQ+G0BYyrvwQutQWk4nVtzjF6LZhTC8yd5KA7g5bDZIae+sabNHgOrlEvhj4h6ZuDUkg==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=pass
 smtp.mailfrom=cornell.edu; dmarc=pass action=none header.from=cornell.edu;
 dkim=pass header.d=cornell.edu; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=cornell.edu;
 s=selector2;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=zu6A5d7qZxoNVPIXIX5omE75L5KRcrwZoujstan4PXg=;
 b=X6DNIphhaPtKZJvioS99IBRC6oX4uX5SXtfH54qlm4tbs72Fpa2oiGQIkl2gVPHQhj3ZQ0G+CoqKMYZWgxMi7EN7+YgfPAuPimNi6NCdjQWAUsgN5gaoZrhMHgCnpWlirT4s+2KJtS5ocAGSfi6CEceltEpvwWNvhqkGZiZSBWg=
Authentication-Results: debbugs.gnu.org; dkim=none (message not signed)
 header.d=none;debbugs.gnu.org; dmarc=none action=none
 header.from=cornell.edu;
Received: from BN7PR04MB4388.namprd04.prod.outlook.com (2603:10b6:406:f8::19)
 by BN7PR04MB5169.namprd04.prod.outlook.com (2603:10b6:408:3b::29)
 with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.4523.16; Sun, 19 Sep
 2021 12:37:54 +0000
Received: from BN7PR04MB4388.namprd04.prod.outlook.com
 ([fe80::5113:e84a:b38a:7a66]) by BN7PR04MB4388.namprd04.prod.outlook.com
 ([fe80::5113:e84a:b38a:7a66%6]) with mapi id 15.20.4523.018; Sun, 19 Sep 2021
 12:37:54 +0000
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
To: Eli Zaretskii <eliz@HIDDEN>, ASSI <Stromeko@HIDDEN>
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN> <835yux5dn1.fsf@HIDDEN>
 <87bl4pf3s1.fsf@HIDDEN> <83tuih3uvr.fsf@HIDDEN>
 <877dfcg5tu.fsf@HIDDEN> <83pmt44vn1.fsf@HIDDEN>
From: Ken Brown <kbrown@HIDDEN>
Message-ID: <eae87657-d5b5-2265-9b89-4626467a4ac5@HIDDEN>
Date: Sun, 19 Sep 2021 08:37:52 -0400
User-Agent: Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:78.0) Gecko/20100101
 Thunderbird/78.14.0
In-Reply-To: <83pmt44vn1.fsf@HIDDEN>
Content-Type: text/plain; charset=windows-1252; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-ClientProxiedBy: CH0PR03CA0421.namprd03.prod.outlook.com
 (2603:10b6:610:10e::26) To BN7PR04MB4388.namprd04.prod.outlook.com
 (2603:10b6:406:f8::19)
MIME-Version: 1.0
Received: from [IPv6:2603:7081:7e3f:3419:1d36:e122:658d:e368]
 (2603:7081:7e3f:3419:1d36:e122:658d:e368) by
 CH0PR03CA0421.namprd03.prod.outlook.com (2603:10b6:610:10e::26) with
 Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.4523.14 via Frontend
 Transport; Sun, 19 Sep 2021 12:37:54 +0000
X-MS-PublicTrafficType: Email
X-MS-Office365-Filtering-Correlation-Id: e2adebd8-6ee3-49fc-98ce-08d97b6a4d57
X-MS-TrafficTypeDiagnostic: BN7PR04MB5169:
X-Microsoft-Antispam-PRVS: <BN7PR04MB516909F6761074A203394ECBD8DF9@HIDDEN>
X-MS-Oob-TLC-OOBClassifiers: OLM:6790;
X-MS-Exchange-SenderADCheck: 1
X-MS-Exchange-AntiSpam-Relay: 0
X-Microsoft-Antispam: BCL:0;
X-Microsoft-Antispam-Message-Info: zGzqo3OSrdkQo4tQ/eAwhSpqlBKw+CbSoKczmA6ZxwF/kfq2mcSs2Xtc3q245uwvmPlmA92rovdtXpGOxaJzE4aJlK9zdwfn+6ITjvalyV8bGUBMi2boYyAwGVe3xve+SR84+MJlmxwzw6QIo1UP9PUNZVVzKudVmEKpc7/YcigTAFRvItH1LKf49oYxkMoP3wq1uPOj5qA7SNvczwNftc0inqbPynQCriEWB/qiyTkUYq68DuOsR5BjxQHpzhYnRoaqJUj3rf/YLgMAGgQtrt6/eavd2lPZpsLNEsrptmGXgiMnH+haA7eAI5t1P49EtdiPaoMHOtpAk/CPDuYs1wjSxs0Ws59T4GjgM+MFj9mPfR1wtI4f8sGX60V8gE5NkQYkLsTy/eZ6L8lzGn21HnATF+aOM5HOl3BS93UVEfE7RnVO/yo0oxLHPlrD0O5S0FQ2YnorO0YX6QQYDcyrNb5mMWsCkpQJJqdPUqGNHkFCjb1DlRv1TtqPtloPIOP/odL41ny0wr3BXDkIQOMB/J9Du0CsCl4Nv1RyhJV6bduhOb3IL/TmOKy/KSYdJdOGy3PlEuH69NRCVZhJ7OD6wTj7hTi7YlKvnp/xzSPvIy1FICLUqzLZMLRi64SxCjiDIWPWSnPWg6g4Cs3AYt4Uk2ynjU7zQTsNk/0vyRSE5DiyqD55jWLE6d1Z+9Ffey30FmaAL5sO9s7nypV+TUdH/QuPBet9btf6F1JkCyuP+mM=
X-Forefront-Antispam-Report: CIP:255.255.255.255; CTRY:; LANG:en; SCL:1; SRV:;
 IPV:NLI; SFV:NSPM; H:BN7PR04MB4388.namprd04.prod.outlook.com; PTR:; CAT:NONE;
 SFS:(4636009)(366004)(31686004)(66476007)(36756003)(66946007)(66556008)(2616005)(38100700002)(4326008)(186003)(4744005)(86362001)(75432002)(31696002)(2906002)(110136005)(8676002)(508600001)(8936002)(6486002)(53546011)(5660300002)(316002)(43740500002)(45980500001);
 DIR:OUT; SFP:1102; 
X-MS-Exchange-AntiSpam-MessageData-ChunkCount: 1
X-MS-Exchange-AntiSpam-MessageData-0: =?Windows-1252?Q?lGS47Oe5iKfC/95Hx3yEkF9UFULFZya7jjmG9JmbmXWjk0Tg4zUZwT7i?=
 =?Windows-1252?Q?Jc+61oWIjHV4Eb+dUFDFLOKCXnrn29HlcyDkbmhabvvfovV4LmQcQE54?=
 =?Windows-1252?Q?B/E5tpT3jC3ejp6+iU1uQtniZXmSCLi15QMCxr+GkYaoI68kgo8EKElN?=
 =?Windows-1252?Q?j4hYDkbZo2lcjzSaQn3fL1uMEA13xRPUNR6rd6qawGfx5aR/ylWMdMGm?=
 =?Windows-1252?Q?QCApVwD+lP9vzYyTs5+uVM5zAk3D2f3HbbNm/fpiA63TnPsYS93bMuB0?=
 =?Windows-1252?Q?L5RQJBsEpHuDRgQ8eDgA2i0sGmZyP/Si4+ps48wgef8xoFATZ9bGhIGe?=
 =?Windows-1252?Q?r427FZ1xxbikyo7CGt8jeRE3xxb1cNLcS5uZrpTydZz0PUOD6EzufsmH?=
 =?Windows-1252?Q?F0mYMj6gWGWkWVwMb1L1pJ8tdEv+v13jghHiho9SABQuDxVkWZ0QI0co?=
 =?Windows-1252?Q?OJOJpsJy7CAxZb5+yYEG9j88DAvfTiq6H8aYC4NXjaAjYCpEY3ctlwzr?=
 =?Windows-1252?Q?jWd0t+kCav3hd4MEsvaNxZzJREq5Mc19nNCxDA8r6bbR8XkfS39YOV4B?=
 =?Windows-1252?Q?/LlL+NQ6IkZDVKpYixuoHtj050r7L9+A1RTM47AKcp+jP0vt7CgvVADs?=
 =?Windows-1252?Q?h6HLkFMLvj6CuxFcmypzoq1mXI7HoYpkC/edoz2RufJngPaRv/dQyayA?=
 =?Windows-1252?Q?xQAoHYswVGn1eEnIXo4xrkIFy2SWVn02ikcYTuoQ0jMXO6lOtW+TBsfX?=
 =?Windows-1252?Q?zqSnfMHfTFU8jRtmzsPh6CMrGBkBNOKBPnbvmwK+gVSD6xFVZBMpc//+?=
 =?Windows-1252?Q?16KOLxS5+yvfmjMQL66IAc4iMSV/aV88SG+3QQ2W1j3XIe3uWINKhMxe?=
 =?Windows-1252?Q?sqzHzGUc/UN1Aj0kDG77H+R7DNQN1zCQUJbhG5DJGZaIj3o7uTaxbpNy?=
 =?Windows-1252?Q?EAT3uRrM1/jNQetq7YVDBqu4wlZu66C9ng49+DA+RkFf1bm6QYhq8XeC?=
 =?Windows-1252?Q?kCoOLLqPckYJ9kLCpunXaBEDkpdVSNRKi7Nim6bU6MNkn8i8hMf+AtAE?=
 =?Windows-1252?Q?18khs2XjlvUGilXJIZxoowuNxoX6rQYf91+4W2k43DSW+qj7Sp8bGo2i?=
 =?Windows-1252?Q?9Ik+jDC8xEaODJXqtv3ylKE+8riEvRYsgiSuGKQYF67TjWfPtJ5+QibD?=
 =?Windows-1252?Q?e7ZvwKjcOw6PrGdXutsIiX3Jl8oNBl+woZ65sVgB0Al3OecmrHYoPCft?=
 =?Windows-1252?Q?JTWA9nQrs2nHReQBzNl9N4wT8uYwx/aoH0Zx3hU+pOKYm0YptOdMLsNE?=
 =?Windows-1252?Q?fm7amftviu1FrtXTYA7NZ4P0gQPb47jVGd/iYQGPJNVKLUC4eDQNtRiR?=
 =?Windows-1252?Q?v6+uXdHIMqT4MqL5CdVaIzbFeJXBYe2VnZamWYCrCS+8PuM4T+Fdl/dm?=
 =?Windows-1252?Q?TYo/m2aubDwaG9nn2HJfijyQudYQiKxtx4t+U917K5hGws8Qh24fvycH?=
 =?Windows-1252?Q?BgsbSo/M?=
X-OriginatorOrg: cornell.edu
X-MS-Exchange-CrossTenant-Network-Message-Id: e2adebd8-6ee3-49fc-98ce-08d97b6a4d57
X-MS-Exchange-CrossTenant-AuthSource: BN7PR04MB4388.namprd04.prod.outlook.com
X-MS-Exchange-CrossTenant-AuthAs: Internal
X-MS-Exchange-CrossTenant-OriginalArrivalTime: 19 Sep 2021 12:37:54.4931 (UTC)
X-MS-Exchange-CrossTenant-FromEntityHeader: Hosted
X-MS-Exchange-CrossTenant-Id: 5d7e4366-1b9b-45cf-8e79-b14b27df46e1
X-MS-Exchange-CrossTenant-MailboxType: HOSTED
X-MS-Exchange-CrossTenant-UserPrincipalName: sPQv070xn3TbhtCmfQ3+KwOb1M/0h/yUGxNmixsCYGgDKJrsPCo9rV09Ni2z3c/rUS7iLIcEvLdPFRVPsRIXqw==
X-MS-Exchange-Transport-CrossTenantHeadersStamped: BN7PR04MB5169
X-Spam-Score: -0.1 (/)
X-Debbugs-Envelope-To: 50666
Cc: 50666 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.1 (-)

On 9/19/2021 8:06 AM, Eli Zaretskii wrote:
>> From: ASSI <Stromeko@HIDDEN>
>> Cc: ASSI <Stromeko@HIDDEN>,  50666 <at> debbugs.gnu.org
>> Date: Sun, 19 Sep 2021 13:31:09 +0200
>>
>> Eli Zaretskii writes:
>>> So this basically means that native-compilation is unworkable for
>>> 32-bit Cygwin, right?
>>
>> Explicit rebasing should work on both architectures, the question is
>> just how to best ensure it's done correctly.
> 
> Since Emacs 28 performs native-compilation automatically in the
> background, and also automatically loads the *.eln files once
> produced, I'm not sure what you mean by "should work" if we assume the
> user will have to rebase manually.

Cygwin could maintain a per-user database of *.eln files and their base 
addresses.  (It already maintains a system database of this type.)  The each 
time a new *.eln file is created, it could be rebased and added to the database 
before being loaded.

Ken




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at 50666 <at> debbugs.gnu.org:


Received: (at 50666) by debbugs.gnu.org; 19 Sep 2021 12:07:17 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Sep 19 08:07:17 2021
Received: from localhost ([127.0.0.1]:37576 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mRvbI-0005W1-W7
	for submit <at> debbugs.gnu.org; Sun, 19 Sep 2021 08:07:17 -0400
Received: from eggs.gnu.org ([209.51.188.92]:50034)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1mRvb2-0005VA-L7
 for 50666 <at> debbugs.gnu.org; Sun, 19 Sep 2021 08:07:15 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:51716)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1mRvau-0007W2-UO; Sun, 19 Sep 2021 08:06:53 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:3512
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1mRvat-00067S-1x; Sun, 19 Sep 2021 08:06:52 -0400
Date: Sun, 19 Sep 2021 15:06:42 +0300
Message-Id: <83pmt44vn1.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: ASSI <Stromeko@HIDDEN>
In-Reply-To: <877dfcg5tu.fsf@HIDDEN> (message from ASSI on Sun, 19 Sep
 2021 13:31:09 +0200)
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN>
 <835yux5dn1.fsf@HIDDEN> <87bl4pf3s1.fsf@HIDDEN>
 <83tuih3uvr.fsf@HIDDEN> <877dfcg5tu.fsf@HIDDEN>
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 50666
Cc: Stromeko@HIDDEN, 50666 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: ASSI <Stromeko@HIDDEN>
> Cc: ASSI <Stromeko@HIDDEN>,  50666 <at> debbugs.gnu.org
> Date: Sun, 19 Sep 2021 13:31:09 +0200
> 
> Eli Zaretskii writes:
> > So this basically means that native-compilation is unworkable for
> > 32-bit Cygwin, right?
> 
> Explicit rebasing should work on both architectures, the question is
> just how to best ensure it's done correctly.

Since Emacs 28 performs native-compilation automatically in the
background, and also automatically loads the *.eln files once
produced, I'm not sure what you mean by "should work" if we assume the
user will have to rebase manually.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at 50666 <at> debbugs.gnu.org:


Received: (at 50666) by debbugs.gnu.org; 19 Sep 2021 11:31:25 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Sep 19 07:31:25 2021
Received: from localhost ([127.0.0.1]:37558 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mRv2b-0003aT-0h
	for submit <at> debbugs.gnu.org; Sun, 19 Sep 2021 07:31:25 -0400
Received: from smtpout2.vodafonemail.de ([145.253.239.133]:54982)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <Stromeko@HIDDEN>) id 1mRv2V-0003SR-TU
 for 50666 <at> debbugs.gnu.org; Sun, 19 Sep 2021 07:31:23 -0400
Received: from smtp.vodafone.de (smtpa01.fra-mediabeam.com [10.2.0.32])
 by smtpout2.vodafonemail.de (Postfix) with ESMTP id 74A3E120C35;
 Sun, 19 Sep 2021 13:31:14 +0200 (CEST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=nexgo.de;
 s=vfde-smtpout-mb-15sep; t=1632051074;
 bh=lkGWpePvH+hbFdxrdpvr967PNMGaIaRarBLkjYwh/Iw=;
 h=From:To:Cc:Subject:References:Date:In-Reply-To;
 b=fvOeTAe7WNATK0/KLoMvB5gKBrd5yPMFGUvxbTssOZ4q2BXxTRagBn/D/SZFI+cdj
 7s9GgDCqdQFGKZ62ucpZogt4xcFFMBXmZaz4fzslCGoZrWGMgRvGeBGNs8Wcjdvsxl
 K3zOfQyvOqNdTmv1AChaN8Qr2ipWUYtZrxnYbtyE=
Received: from Otto (p54a0cb96.dip0.t-ipconnect.de [84.160.203.150])
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256/256 bits)
 key-exchange ECDHE (P-256) server-signature RSA-PSS (2048 bits) server-digest
 SHA256) (No client certificate requested)
 by smtp.vodafone.de (Postfix) with ESMTPSA id A3ACC14019D;
 Sun, 19 Sep 2021 11:31:12 +0000 (UTC)
From: ASSI <Stromeko@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN>
 <835yux5dn1.fsf@HIDDEN> <87bl4pf3s1.fsf@HIDDEN>
 <83tuih3uvr.fsf@HIDDEN>
Date: Sun, 19 Sep 2021 13:31:09 +0200
In-Reply-To: <83tuih3uvr.fsf@HIDDEN> (Eli Zaretskii's message of "Sun, 19 Sep
 2021 10:08:24 +0300")
Message-ID: <877dfcg5tu.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-purgate-type: clean
X-purgate-Ad: Categorized by eleven eXpurgate (R) http://www.eleven.de
X-purgate: This mail is considered clean (visit http://www.eleven.de for
 further information)
X-purgate: clean
X-purgate-size: 1047
X-purgate-ID: 155817::1632051073-0000065C-895EDAD6/0/0
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 50666
Cc: ASSI <Stromeko@HIDDEN>, 50666 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Eli Zaretskii writes:
>> There is (of course), but then there is no guarantee that you can do a
>> fork from the resulting memory image.  Which is exactly the problem that
>> fixing the base addresses of all DLL was intended to solve and has the
>> unfortunate side effect that you need to modify the on-disk
>> representation.  On 64bit, marking the eln as ASLR w/ high-entropy and
>> large address aware will probably work most of the time, but 32bit is
>> much more prone to collisions (in fact I did use a shell inside an X11
>> Emacs as my test case when I last unsuccessfully tried to make ASLR work
>> for Cygwin).
>
> So this basically means that native-compilation is unworkable for
> 32-bit Cygwin, right?

Explicit rebasing should work on both architectures, the question is
just how to best ensure it's done correctly.


Regards,
Achim.
-- 
+<[Q+ Matrix-12 WAVE#46+305 Neuron microQkb Andromeda XTk Blofeld]>+

Wavetables for the Waldorf Blofeld:
http://Synth.Stromeko.net/Downloads.html#BlofeldUserWavetables




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at 50666 <at> debbugs.gnu.org:


Received: (at 50666) by debbugs.gnu.org; 19 Sep 2021 07:08:45 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Sep 19 03:08:45 2021
Received: from localhost ([127.0.0.1]:37398 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mRqwP-0003mP-Hw
	for submit <at> debbugs.gnu.org; Sun, 19 Sep 2021 03:08:45 -0400
Received: from eggs.gnu.org ([209.51.188.92]:50836)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1mRqwN-0003m8-RN
 for 50666 <at> debbugs.gnu.org; Sun, 19 Sep 2021 03:08:44 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:47864)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1mRqwH-00012I-Uq; Sun, 19 Sep 2021 03:08:37 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:4892
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1mRqwH-0008HX-B1; Sun, 19 Sep 2021 03:08:37 -0400
Date: Sun, 19 Sep 2021 10:08:24 +0300
Message-Id: <83tuih3uvr.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: ASSI <Stromeko@HIDDEN>
In-Reply-To: <87bl4pf3s1.fsf@HIDDEN> (message from ASSI on Sun, 19 Sep
 2021 09:00:46 +0200)
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN>
 <835yux5dn1.fsf@HIDDEN> <87bl4pf3s1.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 50666
Cc: 50666 <at> debbugs.gnu.org, kbrown@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: ASSI <Stromeko@HIDDEN>
> Cc: Ken Brown <kbrown@HIDDEN>,  50666 <at> debbugs.gnu.org
> Date: Sun, 19 Sep 2021 09:00:46 +0200
> 
> Eli Zaretskii writes:
> > Isn't there a way to rebase a DLL on the fly, when it is loaded?
> 
> There is (of course), but then there is no guarantee that you can do a
> fork from the resulting memory image.  Which is exactly the problem that
> fixing the base addresses of all DLL was intended to solve and has the
> unfortunate side effect that you need to modify the on-disk
> representation.  On 64bit, marking the eln as ASLR w/ high-entropy and
> large address aware will probably work most of the time, but 32bit is
> much more prone to collisions (in fact I did use a shell inside an X11
> Emacs as my test case when I last unsuccessfully tried to make ASLR work
> for Cygwin).

So this basically means that native-compilation is unworkable for
32-bit Cygwin, right?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at 50666 <at> debbugs.gnu.org:


Received: (at 50666) by debbugs.gnu.org; 19 Sep 2021 07:02:08 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Sep 19 03:02:08 2021
Received: from localhost ([127.0.0.1]:37394 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mRqpz-0003cd-P7
	for submit <at> debbugs.gnu.org; Sun, 19 Sep 2021 03:02:08 -0400
Received: from smtpout2.vodafonemail.de ([145.253.239.133]:40004)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <Stromeko@HIDDEN>) id 1mRqpx-0003c7-EN
 for 50666 <at> debbugs.gnu.org; Sun, 19 Sep 2021 03:02:06 -0400
Received: from smtp.vodafone.de (smtpa08.fra-mediabeam.com [10.2.0.39])
 by smtpout2.vodafonemail.de (Postfix) with ESMTP id A23B6612CA;
 Sun, 19 Sep 2021 09:00:48 +0200 (CEST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=nexgo.de;
 s=vfde-smtpout-mb-15sep; t=1632034848;
 bh=6iCOvAahTE+6vujeLJj6xsTiztBfyJXv2zOT8aB9Z/s=;
 h=From:To:Cc:Subject:References:Date:In-Reply-To;
 b=MpvWgYIDV8ZKeK7nl+saHQTL1hHsmXVL7u3zs8znr+p4ylgluVDSpw3qq/KDmHyhq
 oZzqVWcwqhI57J17HopbZYxiPYzjX3okvdImsvCsRfqotswRDTaVkUpQTSGLCZzkeh
 7LKrmhXHxjpXaEwttzLphgLguxvE+tisqI/ehJKU=
Received: from Otto (p54a0cb96.dip0.t-ipconnect.de [84.160.203.150])
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256/256 bits)
 key-exchange ECDHE (P-256) server-signature RSA-PSS (2048 bits) server-digest
 SHA256) (No client certificate requested)
 by smtp.vodafone.de (Postfix) with ESMTPSA id A5A4E1401C8;
 Sun, 19 Sep 2021 07:00:47 +0000 (UTC)
From: ASSI <Stromeko@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN>
 <835yux5dn1.fsf@HIDDEN>
Date: Sun, 19 Sep 2021 09:00:46 +0200
In-Reply-To: <835yux5dn1.fsf@HIDDEN> (Eli Zaretskii's message of "Sun, 19 Sep
 2021 08:37:54 +0300")
Message-ID: <87bl4pf3s1.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-purgate-type: clean
X-purgate-Ad: Categorized by eleven eXpurgate (R) http://www.eleven.de
X-purgate: This mail is considered clean (visit http://www.eleven.de for
 further information)
X-purgate: clean
X-purgate-size: 883
X-purgate-ID: 155817::1632034848-00007455-0EE23518/0/0
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 50666
Cc: 50666 <at> debbugs.gnu.org, Ken Brown <kbrown@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Eli Zaretskii writes:
> Isn't there a way to rebase a DLL on the fly, when it is loaded?

There is (of course), but then there is no guarantee that you can do a
fork from the resulting memory image.  Which is exactly the problem that
fixing the base addresses of all DLL was intended to solve and has the
unfortunate side effect that you need to modify the on-disk
representation.  On 64bit, marking the eln as ASLR w/ high-entropy and
large address aware will probably work most of the time, but 32bit is
much more prone to collisions (in fact I did use a shell inside an X11
Emacs as my test case when I last unsuccessfully tried to make ASLR work
for Cygwin).


Regards,
Achim.
-- 
+<[Q+ Matrix-12 WAVE#46+305 Neuron microQkb Andromeda XTk Blofeld]>+

Factory and User Sound Singles for Waldorf Blofeld:
http://Synth.Stromeko.net/Downloads.html#WaldorfSounds




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at 50666 <at> debbugs.gnu.org:


Received: (at 50666) by debbugs.gnu.org; 19 Sep 2021 05:38:11 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Sep 19 01:38:11 2021
Received: from localhost ([127.0.0.1]:37332 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mRpWl-0001Cq-MH
	for submit <at> debbugs.gnu.org; Sun, 19 Sep 2021 01:38:11 -0400
Received: from eggs.gnu.org ([209.51.188.92]:44066)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1mRpWk-0001Cf-J4
 for 50666 <at> debbugs.gnu.org; Sun, 19 Sep 2021 01:38:10 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:46872)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1mRpWe-000843-Kp; Sun, 19 Sep 2021 01:38:04 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:3319
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1mRpWe-0004Iw-4r; Sun, 19 Sep 2021 01:38:04 -0400
Date: Sun, 19 Sep 2021 08:37:54 +0300
Message-Id: <835yux5dn1.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Ken Brown <kbrown@HIDDEN>
In-Reply-To: <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN> (message from
 Ken Brown on Sat, 18 Sep 2021 16:58:21 -0400)
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
 <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 50666
Cc: 50666 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Ken Brown <kbrown@HIDDEN>
> Date: Sat, 18 Sep 2021 16:58:21 -0400
> 
> * src/Makefile.in (emacs$(EXEEXT)) [CYGWIN]: Rebase the *.eln
> files after they are all created, to avoid fork problems later
> in the build.  (Bug#50666)

Now I see why this doesn't include the *.eln files in
~/.emacs.d/eln-cache.  But this means that on Cygwin, the only
practical way of building Emacs with native-compilation is to compile
everything, i.e. use NATIVE_FULL_AOT, which is unfortunate, IMO.

Isn't there a way to rebase a DLL on the fly, when it is loaded?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at 50666 <at> debbugs.gnu.org:


Received: (at 50666) by debbugs.gnu.org; 19 Sep 2021 05:33:02 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Sep 19 01:33:02 2021
Received: from localhost ([127.0.0.1]:37310 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mRpRj-00013x-57
	for submit <at> debbugs.gnu.org; Sun, 19 Sep 2021 01:33:02 -0400
Received: from eggs.gnu.org ([209.51.188.92]:43698)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1mRpRd-00013g-Sq
 for 50666 <at> debbugs.gnu.org; Sun, 19 Sep 2021 01:32:57 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:46668)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1mRpRY-0003Re-1Q; Sun, 19 Sep 2021 01:32:48 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:2996
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1mRpRX-0001OI-Kf; Sun, 19 Sep 2021 01:32:47 -0400
Date: Sun, 19 Sep 2021 08:32:38 +0300
Message-Id: <837dfd5dvt.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Ken Brown <kbrown@HIDDEN>
In-Reply-To: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN> (message from
 Ken Brown on Sat, 18 Sep 2021 16:46:42 -0400)
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 50666
Cc: 50666 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Ken Brown <kbrown@HIDDEN>
> Date: Sat, 18 Sep 2021 16:46:42 -0400
> 
> In a followup to this message, I'll submit a patch that does this
> ephemeral rebase and fixes the build problem.

Thanks.

> Note: The build will not actually be convenient to use on 32-bit Cygwin, because 
> sooner or later the *.eln files in ~/.emacs.d/eln-cache will also need to be 
> rebased.  I hope to address this in future patches.

Why would they need to be rebased, and why doesn't your solution
handle those *.eln files as well?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.
Added tag(s) patch. Request was from Lars Ingebrigtsen <larsi@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 50666 <at> debbugs.gnu.org:


Received: (at 50666) by debbugs.gnu.org; 18 Sep 2021 20:58:33 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Sep 18 16:58:33 2021
Received: from localhost ([127.0.0.1]:37061 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mRhPt-0003SP-BD
	for submit <at> debbugs.gnu.org; Sat, 18 Sep 2021 16:58:33 -0400
Received: from mail-bn8nam12on2115.outbound.protection.outlook.com
 ([40.107.237.115]:56215 helo=NAM12-BN8-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <kbrown@HIDDEN>) id 1mRhPr-0003SA-MM
 for 50666 <at> debbugs.gnu.org; Sat, 18 Sep 2021 16:58:32 -0400
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=X/gLXxk9zyFfs4p4MbsolRF7H33j3EYbuH8sHw8Ajh5KLRk/I1K4Sdm/G8v2/3f2jpWe9sM2VI1SyLr1E8Dg3RD5dRlWeHlaNAWjLyNCrZ74oXWGYB4SjgPfk4TpknitJUAk1sOfihS8j82IVePTslYXGWG4PJo8IxHE3KihQUB7aU/gkqYw+ksRouPf1n7XYvFwV1nPxbnq3linH5rVLuCU8a5exsIyZG/dguUmuG2VuM9PUZ4zE2GjJc1PXV149TF/smop7O/Id1cAxWgw0e/GR28Uj8MsO3SqCFO6UXAB9tmjDMi4sIWqItQAd3T0keH2ozuEb7GU7v2G09VmtQ==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version; 
 bh=0lj4EKyEsFeiRcVYHmBNoHHYDjZ7bB13EJurm86PytM=;
 b=fLRYdZrEXFF0Kxgau3Gohym50M0MBY9dA2bRrBvPhaAg9EaWmCZtJ9Vn7cBPUMDBUe0OABuDZMUvRQZgMs3SRND1JXJpyLhxpkLmtzB9la7mF29NNUtbXbPQ50wIr8aBsQ52ev3IslrDUaftsRqvEzUTVe9i38sLL+2qIu/I6Dr8iZW+1rTFbPjbPRP6yzItax8JS2ER968vncRMkSC6/4RQm01LMni6k5bVm9jxNjG8afPzTW+DY7ZbHm8Z4lyJcONMzrceiBcfsL1cx7nSY2nlfxHXm4Kzo6BJkjyfUrgy2RuAIST2aHYYSXHJaOOKPkfQXjykj61zXgN9tH3hOQ==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=pass
 smtp.mailfrom=cornell.edu; dmarc=pass action=none header.from=cornell.edu;
 dkim=pass header.d=cornell.edu; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=cornell.edu;
 s=selector2;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=0lj4EKyEsFeiRcVYHmBNoHHYDjZ7bB13EJurm86PytM=;
 b=Rr3OELUmvfJKXB+indpwwf4kKFgwBQLhgh0RezcFkvLtCJKQF99O3BGYK0t2y+j2N2XIZr6ZfbsqAbJSDf6/hPQ+iVVPWLSM1Vq3QSy6JWo+N4cVIHFcXn9QFx7BqK1A4uDZhcK4KPVbpTMW+cGH0DnF/NwcoLdVL9A4RMeJXLI=
Authentication-Results: debbugs.gnu.org; dkim=none (message not signed)
 header.d=none;debbugs.gnu.org; dmarc=none action=none
 header.from=cornell.edu;
Received: from BN7PR04MB4388.namprd04.prod.outlook.com (2603:10b6:406:f8::19)
 by BN7PR04MB4386.namprd04.prod.outlook.com (2603:10b6:406:fd::13)
 with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.4523.16; Sat, 18 Sep
 2021 20:58:23 +0000
Received: from BN7PR04MB4388.namprd04.prod.outlook.com
 ([fe80::5113:e84a:b38a:7a66]) by BN7PR04MB4388.namprd04.prod.outlook.com
 ([fe80::5113:e84a:b38a:7a66%6]) with mapi id 15.20.4523.018; Sat, 18 Sep 2021
 20:58:23 +0000
Subject: Re: bug#50666: 28.0.50; Fix native compilation on Cygwin
From: Ken Brown <kbrown@HIDDEN>
To: 50666 <at> debbugs.gnu.org
References: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
Message-ID: <01a89ba6-2786-df04-0181-069b50a70331@HIDDEN>
Date: Sat, 18 Sep 2021 16:58:21 -0400
User-Agent: Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:78.0) Gecko/20100101
 Thunderbird/78.14.0
In-Reply-To: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
Content-Type: multipart/mixed; boundary="------------7E67D8349317065DDB82E29E"
Content-Language: en-US
X-ClientProxiedBy: CH0PR04CA0032.namprd04.prod.outlook.com
 (2603:10b6:610:77::7) To BN7PR04MB4388.namprd04.prod.outlook.com
 (2603:10b6:406:f8::19)
MIME-Version: 1.0
Received: from [IPv6:2603:7081:7e3f:3419:1d36:e122:658d:e368]
 (2603:7081:7e3f:3419:1d36:e122:658d:e368) by
 CH0PR04CA0032.namprd04.prod.outlook.com (2603:10b6:610:77::7) with Microsoft
 SMTP Server (version=TLS1_2, cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id
 15.20.4523.14 via Frontend Transport; Sat, 18 Sep 2021 20:58:23 +0000
X-MS-PublicTrafficType: Email
X-MS-Office365-Filtering-Correlation-Id: cae9457b-9202-4987-b213-08d97ae70da2
X-MS-TrafficTypeDiagnostic: BN7PR04MB4386:
X-Microsoft-Antispam-PRVS: <BN7PR04MB4386ADC22A1CB032109CBD7FD8DE9@HIDDEN>
X-MS-Oob-TLC-OOBClassifiers: OLM:8882;
X-MS-Exchange-SenderADCheck: 1
X-MS-Exchange-AntiSpam-Relay: 0
X-Microsoft-Antispam: BCL:0;
X-Microsoft-Antispam-Message-Info: 56ypYPPV+u+YLXoHI3HUtLjr0RUkmEr70QRAOU53fgxza72PgkKuGohgOY/lUgTCIUAKMuFH9MEmDV80iDMg8KteisIVUG9CPccjyTvb/J4YgKsu5FuxhjUNrP2W3A0W0NFwK5uZaaikrxfMS2l+XK8yB39KZnRGT5aJoWJasIYvVba/sraZF1I1Hteu1s5lKgXG1OgNdVt9Zff8iFy0sjaY48oZZaIUI3FBjd/NL9M3nF7SXfPHy3FRb1N1ta1kJ23aAXKqFcIrdsI8vw2FN+OadB3CqJVy4cFCsIefsCy+zcpwHwJfd0e7WGElAJkHBqvrManE+aGkA7vPDt5ATuIbgkl4MbYm1HI0O0uRViJxS5bx4PsqGZwIbOS/s3Z7uAYhDmgaJMJ7K1drVUk3crzAluYibBc66Jv4733HDqL3chL53yJLEwh7BHxyp+6Ai6McaX7MJL21KwForg8bzQCMSHtOMcisozkaCiMAh3TW2ypQo/7GuGUCMUzFZVyS9chgL2/hwI/DSQS2UdLet0zqqHOVbj4wdtCx0J9yj4HOQuncO4ogkbMFFiF//o0IdRjpY175A3hkhUupD71NjJcWzB+X/3YtzBjYfpGtwc4HDwBgCPTDoGeJf2nOXM0YQHKbd4/KJeaw36OE1ah03BOh/3PrROXFyVIbh3v7U+mq7f9DgIkvSgauCHB/zVTyHH650buDBQ4qbMNCSiawYw/x/81RX2QU7WHvlHlFXg8=
X-Forefront-Antispam-Report: CIP:255.255.255.255; CTRY:; LANG:en; SCL:1; SRV:;
 IPV:NLI; SFV:NSPM; H:BN7PR04MB4388.namprd04.prod.outlook.com; PTR:; CAT:NONE;
 SFS:(4636009)(366004)(31696002)(5660300002)(36756003)(316002)(66556008)(66616009)(8936002)(235185007)(83380400001)(53546011)(8676002)(508600001)(186003)(66476007)(86362001)(31686004)(33964004)(564344004)(66946007)(6916009)(2616005)(75432002)(2906002)(6486002)(38100700002)(43740500002)(45980500001);
 DIR:OUT; SFP:1102; 
X-MS-Exchange-AntiSpam-MessageData-ChunkCount: 1
X-MS-Exchange-AntiSpam-MessageData-0: =?Windows-1252?Q?OQtJ3T1YZhtPcrkm3FKUZOcpUZ/9wWQubsGf4TcaQ0dc1Pb92qgaALLQ?=
 =?Windows-1252?Q?5yJQNFhUtj9Fr1cqRTYCkPLyr8CB55NhreGhCf0iUe1kX06heknNV89s?=
 =?Windows-1252?Q?4SlYQs24UGI16+YoxQlbpBtiBmglVfkLDCLfkIDVtO6BVYYecJhtLc5o?=
 =?Windows-1252?Q?LeGXjXveQOkL1cxhAHlEeNMHGEmR5aKRWbpBSw6mZ95MhR7c39KcqOkN?=
 =?Windows-1252?Q?QsXQRo80WW8NiP/iOsLNGM2w07/HIOO4DeDxQtvRHwDJ8PBnCpg7AsSH?=
 =?Windows-1252?Q?fXv3muMQhquB7fZZ2e5rb3wfwiLpwMEtjiixDffyxdgsAKycj3hchkvq?=
 =?Windows-1252?Q?y3GBLtA83sHh9v+02Cw0C5DCRk9nNM9EjPnOM4d2HIp5gJnvKHSkbptB?=
 =?Windows-1252?Q?t5btsXaC67cEdk63aNTDsXNVrfR8kn0rfySCvLSIVQFe8c8rHGsoK/wV?=
 =?Windows-1252?Q?NcAPsynRHC8YawHhATFsgsdHzV+PxVNnBoHbNQx0MOVHw9+E8hLXCXCy?=
 =?Windows-1252?Q?MB/zLv55XlaYLUoAmtP8PFq668LbMNQL5p0jqpX2rc0+DiBi90mWmGgF?=
 =?Windows-1252?Q?2YmPE16/vm3K1Fh9E+vJqAsO9YQWmEh+a6tnaSaTvayd0KmJFOBoOHza?=
 =?Windows-1252?Q?7wjyvUwqWvfuzk+ebx+yheMHmrjbCFnYxrVhrkUDyN5hr7+3GwSDo8w8?=
 =?Windows-1252?Q?eGaPeFbFa/Mki9JuTCBPigPb0JpRznY5qVtop8+inmRLVWaoSrjYea2A?=
 =?Windows-1252?Q?xRvFCTrMUOPpMOEoqkEG33hzkC+8OZs8pA74jOMchuamFWN0J10/EbQS?=
 =?Windows-1252?Q?Eebbiw0EsCUq//Jb00TFGtbCrICapXpP6JS7rhwo6OrD0yNos5rkemaX?=
 =?Windows-1252?Q?eDQHG9BXLsM9qQZlQeqkM2tQhN/t7KU5w/hkYcpKq93rQyhsazlwi5WD?=
 =?Windows-1252?Q?iG6R5wAlq3TKKCaAAHma4zn2uvqmBNH30hQ0wdJA34r2IvSsz4x5Ybf1?=
 =?Windows-1252?Q?Dx4m4Nh9qNxcAERlESt4drd+LjMvU2xBtClrT4YxmYk/eIKAnYYTu2EL?=
 =?Windows-1252?Q?f/bDjxRqBqNeN+SyIao+d9HyNu+ZqeAwDAhZd93OzbGPOGzLLHM899ai?=
 =?Windows-1252?Q?MlJw2gBhDCLSyO/bCm20M/K4R3o+FRdEx/AqslN8Ayewi+J0dIDtj+PD?=
 =?Windows-1252?Q?7nJ/IbcJYs9RzEjU0RNR5oQuaKPRl0yeeTuhppGZesxRvLgBbCwEOdVV?=
 =?Windows-1252?Q?G396oc/CqOnFVnhGzkVhdkIsSmpWN8RRRxzdsxZgCdlmmso/IvFs8glO?=
 =?Windows-1252?Q?h/+hEDCIefEnE3VLIBhbn+eL7Ag91UQHLlZbO1BRBjXoMiGSWXZLHbIH?=
 =?Windows-1252?Q?WTQYRFWeJGryStFhofQ1nRgrffWlEYl7oMVKhy7mmToABrz2eW4WTuYP?=
 =?Windows-1252?Q?f7iQm6idILODPFZZFNj7HEN/hZF/3Sp5NSJs3u5I1upoS+RV/PxsEMMJ?=
 =?Windows-1252?Q?1rcp8EXE?=
X-OriginatorOrg: cornell.edu
X-MS-Exchange-CrossTenant-Network-Message-Id: cae9457b-9202-4987-b213-08d97ae70da2
X-MS-Exchange-CrossTenant-AuthSource: BN7PR04MB4388.namprd04.prod.outlook.com
X-MS-Exchange-CrossTenant-AuthAs: Internal
X-MS-Exchange-CrossTenant-OriginalArrivalTime: 18 Sep 2021 20:58:23.6404 (UTC)
X-MS-Exchange-CrossTenant-FromEntityHeader: Hosted
X-MS-Exchange-CrossTenant-Id: 5d7e4366-1b9b-45cf-8e79-b14b27df46e1
X-MS-Exchange-CrossTenant-MailboxType: HOSTED
X-MS-Exchange-CrossTenant-UserPrincipalName: q3W0+6PpzvbfspyLCTJWXR+NsF5sOoJxLUeZuKT4Q1m1wWqSwbFwEWLjJDU6xeCX7g93sUU/UhH5whnoYrWxwg==
X-MS-Exchange-Transport-CrossTenantHeadersStamped: BN7PR04MB4386
X-Spam-Score: -0.1 (/)
X-Debbugs-Envelope-To: 50666
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.1 (-)

--------------7E67D8349317065DDB82E29E
Content-Type: text/plain; charset=windows-1252; format=flowed
Content-Transfer-Encoding: 7bit

On 9/18/2021 4:46 PM, Ken Brown wrote:
> In a followup to this message, I'll submit a patch that does this
> ephemeral rebase and fixes the build problem.

Patch attached.

--------------7E67D8349317065DDB82E29E
Content-Type: text/plain; charset=UTF-8;
 name="0001-Fix-build-with-native-compilation-on-Cygwin.patch"
Content-Transfer-Encoding: 7bit
Content-Disposition: attachment;
 filename="0001-Fix-build-with-native-compilation-on-Cygwin.patch"

From 3a655d37dea44876b1cbc624b4cf1813945f9f2e Mon Sep 17 00:00:00 2001
From: Ken Brown <kbrown@HIDDEN>
Date: Sat, 18 Sep 2021 14:03:41 -0400
Subject: [PATCH] Fix build with native compilation on Cygwin

* src/Makefile.in (emacs$(EXEEXT)) [CYGWIN]: Rebase the *.eln
files after they are all created, to avoid fork problems later
in the build.  (Bug#50666)
---
 src/Makefile.in | 5 +++++
 1 file changed, 5 insertions(+)

diff --git a/src/Makefile.in b/src/Makefile.in
index 732cd8f099..bb69a65707 100644
--- a/src/Makefile.in
+++ b/src/Makefile.in
@@ -547,6 +547,8 @@ ${charscript}:
 
 ${lispintdir}/characters.elc: ${charscript:.el=.elc}
 
+SYSTEM_TYPE = @SYSTEM_TYPE@
+
 ## The dumped Emacs is as functional and more efficient than
 ## bootstrap-emacs, so we replace the latter with the former.
 ## Strictly speaking, emacs does not depend directly on all of $lisp,
@@ -555,6 +557,9 @@ ${lispintdir}/characters.elc: ${charscript:
 emacs$(EXEEXT): temacs$(EXEEXT) \
                 lisp.mk $(etc)/DOC $(lisp) \
                 $(lispsource)/international/charprop.el ${charsets}
+ifeq ($(SYSTEM_TYPE),cygwin)
+	find ${top_builddir} -name '*.eln' | rebase -v -O -T -
+endif
 ifeq ($(DUMPING),unexec)
 	LC_ALL=C $(RUN_TEMACS) -batch $(BUILD_DETAILS) -l loadup --temacs=dump
   ifneq ($(PAXCTL_dumped),)
-- 
2.33.0


--------------7E67D8349317065DDB82E29E--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 18 Sep 2021 20:51:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Sep 18 16:51:54 2021
Received: from localhost ([127.0.0.1]:37050 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mRhJS-0003II-9W
	for submit <at> debbugs.gnu.org; Sat, 18 Sep 2021 16:51:54 -0400
Received: from lists.gnu.org ([209.51.188.17]:60732)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <kbrown@HIDDEN>) id 1mRhJQ-0003IA-Ij
 for submit <at> debbugs.gnu.org; Sat, 18 Sep 2021 16:51:52 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:44316)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <kbrown@HIDDEN>)
 id 1mRhJQ-00080X-Am
 for bug-gnu-emacs@HIDDEN; Sat, 18 Sep 2021 16:51:52 -0400
Received: from mail-dm6nam11on2071a.outbound.protection.outlook.com
 ([2a01:111:f400:7eaa::71a]:39905
 helo=NAM11-DM6-obe.outbound.protection.outlook.com)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <kbrown@HIDDEN>)
 id 1mRhJO-0000WU-06
 for bug-gnu-emacs@HIDDEN; Sat, 18 Sep 2021 16:51:51 -0400
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=eHCKW5Dh0LcK7DUiDv7NsFqfrJXxgK0fWAAcwmWrFWAc4TK4LqDqtOz+ZL35tmy2NRI08LrXFgFhPiCAcG4xDrsrudPA8/lknsnjL8tLjI+PV6SW0/p6QUNRpO29EzbGTIj/zOhtYqREW20scRACFSQwR5jrX8ra7rgxLSRH0EoSxl+sjUw15dESqPWzH1h5wvYzNTikjFxJ4hAX09n6G4DHH9wE1iXZ0Q0h1ZtcPBbp82GzPfILhsuKIw00nmSF47bksIh5eetft0ajFyJrvWZNuwk7Zs33Zu/zG6cLCGL0gZ/bYjtM2C38HZ3Wvge0WOxX2lkhkWyorDZSPNmZSQ==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version; 
 bh=WmWWKFj/zPD35arbGo7LaWnxQix5JQuQ9WnvcA3KTUM=;
 b=mhMAznzX3WA8IfI0enAM+wK6WcyxB298BX1O/hJHGhglRaMbHApdRQUSIs79uGzwQA3LvX2wCDpA34XytYMzGZ2YyF1uQ41dGmSQdD1odcf6WlVYMq2BLxx7Ab9XdD9diX/8KCrKY/28Abj48VabPYIavVRDsLDa15bHiWUA/yeg09r0gcWWzZ3+OiZEYIE0A+T82oWL05pasRns3e6FzNpoeMl9J4bx2J8G1gh9m/gug7WBrc5yQ+CUCAhr+GvhXsoYDUBoKGtBCKfchFp5XnFNafl2rBBzZxAHlbJXBBH0USYjdKpa9Y5xh3oUiSaU9TLw51yjqRP48ZXQe6uU7A==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=pass
 smtp.mailfrom=cornell.edu; dmarc=pass action=none header.from=cornell.edu;
 dkim=pass header.d=cornell.edu; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=cornell.edu;
 s=selector2;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=WmWWKFj/zPD35arbGo7LaWnxQix5JQuQ9WnvcA3KTUM=;
 b=KL/AwXVviUbAFaDIOn2fjSPx3ZOgiymm6PTT2ssd1ALqIeni/AOoTiKtIBjCzkkbZk+j7Dm315JrVmX7ekbHmOFQmebgJoWa4FhXh7D1+qKuP0oeLfrVP8R6hqOAT7ki1yUiZU1n6OzJ9oAWRuUSZTzosDovQ7MIaXZPt5+D/jM=
Authentication-Results: gnu.org; dkim=none (message not signed)
 header.d=none;gnu.org; dmarc=none action=none header.from=cornell.edu;
Received: from BN7PR04MB4388.namprd04.prod.outlook.com (2603:10b6:406:f8::19)
 by BN8PR04MB6068.namprd04.prod.outlook.com (2603:10b6:408:4d::24)
 with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.4523.16; Sat, 18 Sep
 2021 20:46:44 +0000
Received: from BN7PR04MB4388.namprd04.prod.outlook.com
 ([fe80::5113:e84a:b38a:7a66]) by BN7PR04MB4388.namprd04.prod.outlook.com
 ([fe80::5113:e84a:b38a:7a66%6]) with mapi id 15.20.4523.018; Sat, 18 Sep 2021
 20:46:44 +0000
To: bug-gnu-emacs@HIDDEN
Subject: 28.0.50; Fix native compilation on Cygwin
From: Ken Brown <kbrown@HIDDEN>
Message-ID: <9f20194e-b1ba-9417-4f18-caa1d80b5568@HIDDEN>
Date: Sat, 18 Sep 2021 16:46:42 -0400
User-Agent: Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:78.0) Gecko/20100101
 Thunderbird/78.14.0
Content-Type: text/plain; charset=windows-1252; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-ClientProxiedBy: CH2PR04CA0003.namprd04.prod.outlook.com
 (2603:10b6:610:52::13) To BN7PR04MB4388.namprd04.prod.outlook.com
 (2603:10b6:406:f8::19)
MIME-Version: 1.0
Received: from [IPv6:2603:7081:7e3f:3419:1d36:e122:658d:e368]
 (2603:7081:7e3f:3419:1d36:e122:658d:e368) by
 CH2PR04CA0003.namprd04.prod.outlook.com (2603:10b6:610:52::13) with Microsoft
 SMTP Server (version=TLS1_2, cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id
 15.20.4523.14 via Frontend Transport; Sat, 18 Sep 2021 20:46:44 +0000
X-MS-PublicTrafficType: Email
X-MS-Office365-Filtering-Correlation-Id: b7751de4-d133-49b9-8f3c-08d97ae56d0f
X-MS-TrafficTypeDiagnostic: BN8PR04MB6068:
X-Microsoft-Antispam-PRVS: <BN8PR04MB6068380D32044CDEDAA5730BD8DE9@HIDDEN>
X-MS-Oob-TLC-OOBClassifiers: OLM:9508;
X-MS-Exchange-SenderADCheck: 1
X-MS-Exchange-AntiSpam-Relay: 0
X-Microsoft-Antispam: BCL:0;
X-Microsoft-Antispam-Message-Info: m8CJlw3wu+RPVV/ADvcDsdH8Welc622X++Nl/wumJzDxzVncwgpEZh6Cug2dSty1qtveoY2CVsidPQgdMZ+qn7AHb52UCTU2eG3wcKRZeKrJ/7swQs/fu1/emndkKjtkZQwxUQbrwVTjg7FNYrmD1bFHfQ+iVDM6Dm46/GTy0S6QEmYAiKjNC33vUvqxMVFE1J+h+YGoCNIEkSfHL0Ltrr+gFE4zPIh5EnAKUzebr9XsDcpUeVH/ZbhZxiUXqRUa0OIF8bZfuDxmd1UsuQq2cQtXRskYdWbDyL+nhkX1sArFCuMpBuolZf1jF2JNT2QWYNHVF8ZymClPY7JSbIpRBGpXvT3Mh10vNN+rkutj9Qk7/62J+y92uv3WBDkU6K/wd+dc8O3C48L9JZXaGrTbe1ZaM1I2qrFi0UQNN668jhjPxt/3iJUKSDuE2T2pb0Fup0aFUNpohsRrfI9ISjKtwgCOdbVM21qMN4PQPE5TGYddQOs2ldtzYVcpiYxRArSsKVD0Ra+NvrkmKLg1eKvS5Woim7Zx2kpA3c71IdN0G1IqRlTxsFXfSUHAS8ebTTjRogec1D47snslBax6R4A2ZYgkucmTxNBtO+/ROgZCCXyzx2k7hiqxvBVhrfcv7cjkDl6hPc+UuMgDYdYvPaEp9syqBAPCx+hY77JF7Q3rUlzihgFJFoUJpUIimesDok4r83DoNQVudpIFZx+RVl6cI7CmlL03Goe2HNITY6Cn26JY4LpqVoBkMolRXxV4qh2VP+kKbA7Q4mCINAKgTOtq9OLArcjbaciyyvugopFst7p/9SJwYavf0lUVE0bOEHuB
X-Forefront-Antispam-Report: CIP:255.255.255.255; CTRY:; LANG:en; SCL:1; SRV:;
 IPV:NLI; SFV:NSPM; H:BN7PR04MB4388.namprd04.prod.outlook.com; PTR:; CAT:NONE;
 SFS:(4636009)(366004)(8676002)(8936002)(2906002)(75432002)(38100700002)(31686004)(186003)(5660300002)(83380400001)(966005)(508600001)(6916009)(36756003)(6486002)(86362001)(2616005)(316002)(66556008)(31696002)(66946007)(66476007)(45980500001)(43740500002);
 DIR:OUT; SFP:1102; 
X-MS-Exchange-AntiSpam-MessageData-ChunkCount: 1
X-MS-Exchange-AntiSpam-MessageData-0: =?Windows-1252?Q?zGtFgSCSuHoQHWcyzLR7YVfVwZh+vZgPMJB05GmpaRU0qLTkzsjyMD2K?=
 =?Windows-1252?Q?3Di7b/+BXCupLtjOesdU1rQu/+Sutwm/ai0ytHI7UNRtd2u4nwv2UbOQ?=
 =?Windows-1252?Q?sCasJvkeKri53OIZOylZl8yfDqfLL04TKxcvVUIza1AgFQT9wy32Y335?=
 =?Windows-1252?Q?eLuubwJW1S/IAe00xHIqCeV3trjsAful2ZQ70tTuDusngGgQlYULjCXB?=
 =?Windows-1252?Q?04Y3ROIfriKCMfsG/zXWaGtAxZwPZASRiI2GEMPkY4WY5tDqfsiHBCT9?=
 =?Windows-1252?Q?nagouMJ6Nv5jSeWrfksd889nE/sZe+DOnDxkRjdlPWFjd+UJmubQLFOx?=
 =?Windows-1252?Q?qiVrcl/dOmjFU/3lpC9dxAD5L8jXIGlPPyq4W+I2UliSTY2hbdUUyRbr?=
 =?Windows-1252?Q?s0YnMRkssziSUoEdEPFuqBsgNxJbBIGxz0VGimPQQCOoQGk6wjYwEAC4?=
 =?Windows-1252?Q?pR8A+3Xkn6h/p22XgHdVWYPgTHKnxLmOjn5eGLEadZ9/JOzWrES5Torv?=
 =?Windows-1252?Q?dcgzRfkJAo08EJ6IwTynu3LQpAUdsKh0TRP5UEniA+lOIEjJ+nSi4+cM?=
 =?Windows-1252?Q?vw5auupE377j4uKagTOybh1PQES1yhzJoNVejdfyzIqXfOGYVVS5DMhO?=
 =?Windows-1252?Q?aUMpDTaYXFEIsawIKwN/fjLOOHmPQnEJF7mL5qcgg7sg0ugbraJf1A3M?=
 =?Windows-1252?Q?68RI+l3pNSZNLYxEfkfIo1TWDWVScej6GUx4CAAOrXD3os6gYuVNWrPV?=
 =?Windows-1252?Q?KH7mK5nVrmI4n5CgnE3zAzErrues2nRfC0iKPdVmru5AzuZpLKEl/Kh2?=
 =?Windows-1252?Q?Gp5SJnQc4M9PEqnphQ4U4vlQmmdNRwRCD9tSIEse1ogyxo0Igy6kP3tP?=
 =?Windows-1252?Q?3rMWQoLzl6LWBtFWKffy/dJN5GiWTnKMXnzpVMLRE5egf/10THSOxj/y?=
 =?Windows-1252?Q?09o5SSS0VMs6YJMkPQt/iwUM8vjgmJ6hK722SCH5sdTbJ0aG6m2BD1iW?=
 =?Windows-1252?Q?b5qQyWwmpUXjLUGKt7NJu29XkV7hUpVCmqGYcpo30luyUF7Nj4zKbq2j?=
 =?Windows-1252?Q?f1x7NdlzN+5nPvjrVnC9+SUIjpJR9+DLwtJW17clJ23pHfO7iL7J+32h?=
 =?Windows-1252?Q?FtouitZ55OiAcP58TUQyrniEObGDgqK1oIzmUbnZCGcDq+MB3CaofSTA?=
 =?Windows-1252?Q?Y7D6OoRDq+rsYK2MU75YM1v5Vc+JzEvDfcwpXwNhTJAi2iDGp4S4YjyQ?=
 =?Windows-1252?Q?LUVYII5AOWRoN8DH4ro72ew5HNZyGi4t7dnRBfJxKDAYaDB6+gZZC9Bx?=
 =?Windows-1252?Q?rBxIV3nS1+VVBT95H0RhN8g62NaDF1eohex/Oyn8qRpX+CNgzaaJ2uvs?=
 =?Windows-1252?Q?Orz404IC62KaFjq0FUMEpYvDEzJtFs2UOq7BishPdvzFDIZoH0HUerZX?=
 =?Windows-1252?Q?9G+xbGGMJfLADA8isRsjR7SFKCdN8uRj6An8yBbvV240sq8VfGmHbZzm?=
 =?Windows-1252?Q?hXI22zQQ?=
X-OriginatorOrg: cornell.edu
X-MS-Exchange-CrossTenant-Network-Message-Id: b7751de4-d133-49b9-8f3c-08d97ae56d0f
X-MS-Exchange-CrossTenant-AuthSource: BN7PR04MB4388.namprd04.prod.outlook.com
X-MS-Exchange-CrossTenant-AuthAs: Internal
X-MS-Exchange-CrossTenant-OriginalArrivalTime: 18 Sep 2021 20:46:44.6530 (UTC)
X-MS-Exchange-CrossTenant-FromEntityHeader: Hosted
X-MS-Exchange-CrossTenant-Id: 5d7e4366-1b9b-45cf-8e79-b14b27df46e1
X-MS-Exchange-CrossTenant-MailboxType: HOSTED
X-MS-Exchange-CrossTenant-UserPrincipalName: ukzgUejMrPF3Z0yIKn3LGv7ZwVkhRuhY3pjshP7Jacx6d67I0Bfand6zu3en5XgkYOeebE7hfDA3mFXxD7/5sA==
X-MS-Exchange-Transport-CrossTenantHeadersStamped: BN8PR04MB6068
Received-SPF: pass client-ip=2a01:111:f400:7eaa::71a;
 envelope-from=kbrown@HIDDEN;
 helo=NAM11-DM6-obe.outbound.protection.outlook.com
X-Spam_score_int: -20
X-Spam_score: -2.1
X-Spam_bar: --
X-Spam_report: (-2.1 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1,
 MSGID_FROM_MTA_HEADER=0.001, SPF_HELO_PASS=-0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.6 (-)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.6 (--)

Building --with-native-compilation on 32-bit Cygwin currently fails with
errors like the following:

child_info_fork::abort: address space needed by
'simple-fab5b0cf-aaf18a4e.eln' (0x5910000) is already occupied

This happens because shared libraries (usually DLLs, but also *.eln
files in this case) often need to be rebased in order for Cygwin's fork
implementation to work.  See

   https://cygwin.com/cygwin-ug-net/highlights.html#ov-hi-process-problems

for an explanation.  It's mostly an issue in the 32-bit case because of
the limited address space, but on rare occasions it can be a problem on
64-bit Cygwin also.

For shared libraries installed in standard places, Cygwin normally takes
care of the rebasing automatically.  But if libraries are created in the
course of a build and then used later in the build, an "ephemeral" rebase
might be necessary.  This is the case for the *.eln libraries produced
during the emacs build.

In a followup to this message, I'll submit a patch that does this
ephemeral rebase and fixes the build problem.

Note: The build will not actually be convenient to use on 32-bit Cygwin, because 
sooner or later the *.eln files in ~/.emacs.d/eln-cache will also need to be 
rebased.  I hope to address this in future patches.

Ken




Acknowledgement sent to Ken Brown <kbrown@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#50666; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Sat, 25 Sep 2021 15:15:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.